'From Squeak 2.0 of May 22, 1998 on 31 May 1998 at 9:52:38 pm'!
"Change Set:		sw_DropFixes
Date:			31 May 1998
Author:			Scott Wallace

Fixes long-standing bug in BookMorph accept-drop code that sometimes allowed unwanted and inappropriate dropping of objects *above* the page controls, for example.  Comparable bulletproofing is also added to PasteUpMorph, to avoid the phenomenon of objects being dropped 'successfully' but not being visible on the page after drop -- which could happen in drops on a page of a book in a tabbed complex, for example."!


!BookMorph methodsFor: 'dropping/grabbing' stamp: 'sw 5/31/1998 00:04'!
wantsDroppedMorph: aMorph event: evt
	(currentPage bounds containsPoint: evt cursorPoint) ifFalse: [^ false].
	^ super wantsDroppedMorph: aMorph event: evt! !


!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'sw 5/31/1998 00:21'!
wantsDroppedMorph: aMorph event: evt
	^ (self openToDragNDrop and: [self isPartsBin not]) and: [self bounds containsPoint: evt cursorPoint]! !


