'From Squeak 2.5 of August 6, 1999 [latest update: #1499] on 1 October 1999 at 3:52:56 pm'!
"Change Set:		ClassOrderFix-RAA
Date:			1 October 1999
Author:			Bob Arning
Improves the order of ChangeSet>>superclassOrder: for certain fileOut situations.
"!


!ChangeSet class methodsFor: 'fileIn/Out' stamp: 'RAA 9/30/1999 14:34'!
superclassOrder: classes 
	"Arrange the classes in the collection, classes, in superclass order so the 
	classes can be properly filed in."

	| all list i aClass |
	list _ classes copy. 			"list is indexable"
	all _ OrderedCollection new: list size.
	[list size > 0] whileTrue: [
		i _ 0.
		[
			i _ i + 1.
			aClass _ list at: i.
			(list includesAnyOf: aClass allSuperclasses) or: [
				aClass isMeta and: [
					(list includes: aClass soleInstance) or: [
						list includesAnyOf: aClass soleInstance allSuperclasses
					] 
				].
			].
		] whileTrue.
		all addLast: aClass.
		list _ list copyWithout: aClass
	].
	^all! !


