'From Squeak2.6 of 11 October 1999 [latest update: #1633] on 24 November 1999 at 9:09:40 pm'!
"Change Set:		updateTOCFix
Date:			24 November 1999
Author:			Steve Elkins

The method version included below fixes a pair of minor bugs in Celeste>>updateTOC.  To see the bugs, make sure no category is selected in the category pane and choose 'empty trash' from the category menu.  The fixes account for the possibility that 'currentMessages' may be nil.
"!


!Celeste methodsFor: 'table of contents pane' stamp: 'sge 11/24/1999 17:11'!
updateTOC
	"Update the table of contents after a moving, removing, or deleting a message. Select a message near the removed message in the table of contents if possible."

	| currentMsgIndex |
	(currentCategory isNil or:
	 [currentMsgID isNil or:
	 [currentMessages size < 2]])
		ifTrue: [currentMsgIndex _ 1]
		ifFalse: [currentMsgIndex _ currentMessages indexOf: currentMsgID].
	currentMsgID _ nil.
	self setCategory: currentCategory.  "update currentMessages, currentTOC"
	currentMessages isEmptyOrNil ifFalse: [
		(currentMsgIndex <= currentMessages size)
			ifTrue: [currentMsgID _ currentMessages at: currentMsgIndex]
			ifFalse: [currentMsgID _ currentMessages last].
	].

	self changed: #tocEntryList.
	self changed: #tocEntry.
	self changed: #messageText.
! !


