'From Squeak2.6 of 11 October 1999 [latest update: #1693] on 12 December 1999 at 4:05:35 pm'!
"Change Set:		FileOpenChoices-RAF
Date:			12 December 1999
Author:			Josh Flowers

Adds some default options to the popup menu that appears when a read only
file is requested, but can't be found.  This is quite helpful on the Mac where many of the Alice
file names get truncated.
"!


!StandardFileStream class methodsFor: 'file creation' stamp: 'jaf 12/12/1999 16:05'!
readOnlyFileNamed: fileName 
 "Open an existing file with the given name for reading."
 "Changed to open a more usefull popup menu.  It now also includes the most likely choices.  jaf
12/10/1999 17:22"
 | selection dir files choices newName |
 (self isAFileNamed: fileName)
  ifTrue: [^ self new open: fileName forWrite: false].
 "File does not exist..."
 dir _ FileDirectory forFileName: fileName.
 files _ dir fileNames.
 choices _ (FileDirectory localNameFor: fileName) correctAgainst: files.
 choices add: 'Choose another name'.
 choices add: 'Cancel'.
 selection _ (PopUpMenu labelArray: choices lines: (Array with: 5) )
    startUpWithCaption: (FileDirectory localNameFor: fileName)
      , '
does not exist.'.
 selection < (choices size - 1) ifTrue: [ newName _ (dir pathName , FileDirectory slash , (choices
at: selection))].
 selection = (choices size - 1) ifTrue: [ newName _ (FillInTheBlank request: 'Enter a new file
name' initialAnswer: (fileName))].
 newName = '' ifFalse: [^ self readOnlyFileNamed: newName].
 ^ self error: 'Could not open a file'
 ! !


