'From Squeak2.8alpha of 19 January 2000 [latest update: #2204] on 24 May 2000 at 12:42:12 pm'!
"Change Set:		fileIntoNewChangeSet
Date:			24 May 2000
Author:			Jim Heyne

A recent change to FileList>>fileIntoNewChangeSet names the resulting change set with the full path of the file, not just the file name.  This is not too bad, but if the path includes a period, the name is truncated by a subsequent call to #sansPeriodSuffix -- and all changes loaded from that path are given the same name!!

This amends FileList>>fileIntoNewChangeSet to use only the fileName (sans path) as the name of the change set.

"!


!FileList methodsFor: 'file list menu' stamp: 'jwh 5/24/2000 12:35'!
fileIntoNewChangeSet
	"File in all of the contents of the currently selected file,
	if any, into a new change set." 

	| fn ff |
	listIndex = 0 ifTrue: [^ self].
	ff _ directory readOnlyFileNamed: (fn _ self uncompressedFileName).
	((self getSuffix: fn) sameAs: 'html') ifTrue: [ff _ ff asHtml].
	ChangeSorter newChangesFromStream: ff named: (FileDirectory localNameFor: fn)! !

