'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 1 June 2000 at 1:05:18 pm'!
"Change Set:		083ShowByteCodes-sma
Date:			28 May 2000
Author:			Stefan Matthias Aust

I like the show bytecodes goodie (altough I think it's hacked into the system at the wrong place) but was annoying that you couldn't easily get rid of it again.  So I made it a toggle. Select it again and the normal method code is shown again.  I also refactored MessageSet so that this methods had only to be implemented once."!


!Browser methodsFor: 'code pane' stamp: 'sma 5/28/2000 11:03'!
showBytecodes
	"Show or hide the bytecodes of the selected method."

	(messageListIndex = 0 or: [self okToChange not])
		ifTrue: [^ self changed: #flash].
	editSelection == #byteCodes
		ifTrue: [editSelection _ #editMessage]
		ifFalse: [editSelection _ #byteCodes].
	self contentsChanged! !


!MessageSet methodsFor: 'message list' stamp: 'sma 5/28/2000 11:10'!
messageListIndex: anInteger 
	"Set the index of the selected item to be anInteger."

	messageListIndex _ anInteger.
	contents _ 
		messageListIndex ~= 0
			ifTrue: [self selectedMessage]
			ifFalse: [''].
	self changed: #messageListIndex.	"update my selection"
	editSelection _ #editMessage.
	self contentsChanged.
	(messageListIndex ~= 0 and: [autoSelectString notNil])
		ifTrue: [self changed: #autoSelect].
! !

!MessageSet methodsFor: 'contents' stamp: 'sma 5/28/2000 11:09'!
contents
	^ contents == nil
		ifTrue: [currentCompiledMethod _ nil. '']
		ifFalse: [messageListIndex = 0 
			ifTrue: [currentCompiledMethod _ nil. contents]
			ifFalse: [editSelection == #byteCodes
				ifTrue: [(self selectedClassOrMetaClass
							compiledMethodAt: self selectedMessageName) symbolic]
				ifFalse: [self selectedMessage]]]! !

MessageSet removeSelector: #showBytecodes!
