'From Squeak2.8alpha of 12 January 2000 [latest update: #2338] on 12 June 2000 at 10:20:15 pm'!
"Change Set:		AdvanceVersion
Date:			12 January 2000
Author:			Dan Ingalls

This update offers the choice to advance the Squeak version number for the purpose of continuing to retrieve updates for Release 2.8 and 2.9alpha and beyond.
"!

"Postscript:
Offer the chance to advance the version number."
(self confirm: 'This is the last update for Squeak 2.8alpha.
Your system is now marked as Squeak2.8.
Do you wish to have your system marked as version 2.9alpha
so that you may retrieve updates for version 2.9alpha and beyond?
[Choose no if you want a stable Squeak to use until the next release.
You can change your mind later after saving a backup.
Choose yes if you wish to track the latest updates and act as a
test pilot for new features as they are being developed]')
	ifTrue: [EToySystem eToyVersion: 'Squeak2.9alpha' date: Date today.
			PopUpMenu notify: 'You may now request updates again
to retrieve updates for 2.9alpha and beyond.']
	ifFalse: [EToySystem eToyVersion: 'Squeak2.8' date: Date today.
			PopUpMenu notify: 'If you request further updates,
you will only have access to bug fixes for Squeak2.8.
If you later wish to advance to 2.9alpha, execute the code
in the postscript of this changeSet (advanceVersion).'].
!

