'From Squeak2.9alpha of 12 June 2000 [latest update: #2462] on 1 August 2000 at 11:06:05 pm'!
"Change Set:		MonthMorphTweak
Date:			1 August 2000
Author:			Dan Ingalls

Make month morphs update the display of today, regardless of when they were last updated.
"!

AlignmentMorph subclass: #MonthMorph
	instanceVariableNames: 'month showingToday '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Dates'!

!MonthMorph methodsFor: 'all' stamp: 'di 8/1/2000 23:05'!
step

	| today ts sm thisMonth |
	today _ Date today.
	thisMonth _ today month.
	(thisMonth = month or: [showingToday ifNil: [true]]) ifFalse: [^ self].
	showingToday _ false.
	ts _ today dayOfMonth printString.
	self allMorphsDo:
		[:m | (m isKindOf: SimpleSwitchMorph) ifTrue:
			[(sm _ m findA: StringMorph) ifNotNil:
				[(sm contents = ts and: [thisMonth = month])
					ifTrue: [(m borderWidth = 2 and: [m borderColor = Color yellow]) ifFalse:
								[m borderWidth: 2; borderColor: Color yellow].
							showingToday _ true]
					ifFalse: [m borderWidth: 1;
								setSwitchState: m color = m onColor]]]].

! !

