'From Squeak2.9alpha of 12 June 2000 [latest update: #2551] on 1 September 2000 at 9:04:03 am'!
"Change Set:		SelectionTweak3
Date:			1 September 2000
Author:			Dan Ingalls

Causes a selection-in-hand to be properly aligned with the cursor.
This makes it simpler to plan where to click down, especially if you
wish to draw out the selection upward or to the left.
"!


!HandMorph methodsFor: 'world menu commands' stamp: 'di 9/1/2000 08:56'!
makeSelection
	"Make and grab a new selection"

	self addMorphBack: (SelectionMorph newBounds: (self lastEvent cursorPoint extent: 16@16)).
	self world abandonAllHalos! !


!SelectionMorph methodsFor: 'halo commands' stamp: 'di 9/1/2000 08:58'!
addOrRemoveItems: handOrEvent
	"Make a new selection extending the current one."

	| oldOwner hand |
	hand _ (handOrEvent isKindOf: HandMorph)
			ifTrue: [handOrEvent]
			ifFalse: [handOrEvent hand].
	hand addMorphBack: ((SelectionMorph newBounds: (hand lastEvent cursorPoint extent: 16@16))
							setOtherSelection: self).
	oldOwner _ owner.
	self world abandonAllHalos.  "Will delete me"
	oldOwner addMorph: self.! !

