'From Squeak2.9alpha of 13 June 2000 [latest update: #2551] on 6 September 2000 at 11:04:26 pm'!
"Change Set:		SystemWindowStep-jg
Date:			6 September 2000
Author:			Joshua Gargus

Fixes bug in changeset 2532 which caused SystemWindows not to step.  I first noticed this when my Inspectors weren't updating."!

!SystemWindow methodsFor: 'stepping' stamp: 'jcg 9/6/2000 23:01'!
step
	"Step the receiver.  Send it to the model, the receiver is open and if it **has* a model"

	isCollapsed ifFalse: [model ifNotNil: [model stepIn: self]]! !

!SystemWindow methodsFor: 'stepping' stamp: 'jcg 9/6/2000 23:01'!
stepAt: millisecondClockValue
	"Step the receiver at the given point in time.  Send it to the model, the receiver is open and if it **has* a model"

	isCollapsed ifFalse: [model ifNotNil: [model stepAt: millisecondClockValue in: self]]! !

!SystemWindow methodsFor: 'stepping' stamp: 'jcg 9/6/2000 23:01'!
wantsSteps
	"Return true if the model wants its view to be stepped.  For an open system window, we give the model to offer an opinion"

	self isPartsDonor ifTrue: [^ false].
	self player wantsSteps ifTrue: [^ true].
	^ isCollapsed not and: [model wantsStepsIn: self]! !
