'From Squeak2.9alpha of 12 June 2000 [latest update: #2575] on 9 September 2000 at 10:53:21 am'!
"Change Set:		BlockEnablementForMenus
Date:			9 September 2000
Author:			Dan Ingalls

Allows menu item enablement to be specified as a block as well as with a unary sleector.  This frequently avoids a proliferation of unnecessary methods.
"!


!BlockContext methodsFor: 'accessing' stamp: 'di 9/9/2000 10:44'!
copyForSaving
	"Fix the values of the temporary variables used in the block that are 
	ordinarily shared with the method in which the block is defined."

	home _ home copy.
	home swapSender: nil! !


!UpdatingMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'di 9/9/2000 10:49'!
enablement

	(enablementSelector isKindOf: BlockContext)
		ifTrue: [^ enablementSelector value]
		ifFalse: [^ wordingProvider perform: enablementSelector]! !

!UpdatingMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'di 9/9/2000 10:44'!
enablementSelector: aSelector

	(aSelector isKindOf: BlockContext)
		ifTrue: [enablementSelector _ aSelector copyForSaving]
		ifFalse: [enablementSelector _ aSelector]! !

!UpdatingMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'di 9/9/2000 10:51'!
step
	| newString enablement |
	super step.
	wordingProvider ifNotNil:
		[wordingSelector ifNotNil:
			[newString _ wordingProvider perform: wordingSelector.
			newString = contents ifFalse: [self contents: newString]].
		enablementSelector ifNotNil:
			[(enablement _ self enablement) == isEnabled ifFalse:
				[self isEnabled: enablement]]]! !

