'From Squeak2.9alpha of 5 August 2000 [latest update: #2620] on 17 September 2000 at 12:35:29 pm'!
"Change Set:		graphScriptFix-sw
Date:			17 September 2000
Author:			Scott Wallace

Fixes the bug that dropped you into a debugger when you select the #sampling category of a GraphMorph's viewer"!


!GraphMorph class methodsFor: 'scripting' stamp: 'sw 9/17/2000 12:34'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^ #(

	(basic (
(slot cursor 	'The current cursor location, wrapped back to the beginning if appropriate' number	 readWrite player getCursor player setCursorWrapped:)

(slot sampleAtCursor	'The sample value at the current cursor location' number readWrite player getSampleAtCursor player setSampleAtCursor:)))

	(sampling (
(slot cursor 	'The current cursor location, wrapped back to the beginning if appropriate' number	 readWrite player getCursor player setCursorWrapped:)
(slot sampleAtCursor	'The sample value at the current cursor location' number readWrite player getSampleAtCursor player setSampleAtCursor:)
(slot lastValue 'The last value obtained' number readWrite	player getLastValue player setLastValue:)
(command clear 'Clear the graph of current contents')
(command loadSineWave 'Load a sine wave as the current graph')
(command loadSound: 'Load the specified sound into the current graph' sound)
(command reverse 'Reverse the graph')
(command play 'Play the current graph as a sound'))))! !

"Postscript:"
StandardScriptingSystem initialize.
!

