'From Squeak2.9alpha of 17 July 2000 [latest update: #2670] on 21 September 2000 at 5:22:53 pm'!
"Change Set:		geeTweaks
Date:			21 September 2000
Author:			Bob Arning

- when composite morphs are dropped into a GeeMail, make sure only the outermost is linked to the text."!


!TextAnchorPlus methodsFor: 'as yet unclassified' stamp: 'RAA 9/21/2000 17:19'!
emphasizeScanner: scanner

	anchoredMorph ifNil: [^self].
	(anchoredMorph ownerThatIsA: TextPlusPasteUpMorph) ifNil: [^anchoredMorph _ nil].
	scanner setYFor: anchoredMorph

! !


!TextPlusMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/21/2000 17:12'!
removeAlansAnchorFor: aMorph

	| anchors |

	anchors _ OrderedCollection new.
	text runs withStartStopAndValueDo: [:start :stop :attributes |
		attributes do: [:att |
			(att isMemberOf: TextAnchorPlus) ifTrue: [
				(att anchoredMorph isNil or: [
					att anchoredMorph == aMorph or: [att anchoredMorph world isNil]]) ifTrue: [
					anchors add: {att. start. stop}
				]
			]
		]
	].
	anchors do: [ :old |
		text removeAttribute: old first from: old second to: old third.
	].

! !


!TextPlusPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/21/2000 17:10'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: NewHandleMorph) ifTrue: [^self].
	self addMorph: aMorph.
	aMorph allMorphsDo: [ :each | theTextMorph removeAlansAnchorFor: each].
	theTextMorph linkNewlyDroppedMorph: aMorph! !

