'From Squeak2.9alpha of 5 August 2000 [latest update: #2683] on 22 September 2000 at 6:00:39 am'!
"Change Set:		menuConflictFix-sw
Date:			22 September 2000
Author:			Scott Wallace

Integrates conflicting changes in updates  2581worldMorphMenu-sw and  2593GeeMail-raa"!


!Morph methodsFor: 'menus' stamp: 'sw 9/22/2000 05:41'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand.  Note the special-casing of Worlds, for which some of the the otherwise generic items are excluded."

	self isWorldMorph
		ifFalse:
			[aCustomMenu add: 'add drop-shadow' action: #addDropShadow.
			(self isKindOf: SystemWindow)
				ifFalse: [aCustomMenu add: 'put in a window' action: #embedInWindow].
			aCustomMenu addUpdating: #stickinessString target: self action: #toggleStickiness.
			aCustomMenu add: 'adhere to edge...' action: #adhereToEdge]
		ifTrue:
			[aCustomMenu add: 'desktop menu...' target: aHandMorph action: #putUpDesktopMenu.
			aCustomMenu addLine].

	Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aCustomMenu hand: aHandMorph].

	(owner isKindOf: TextPlusPasteUpMorph) ifTrue:
		[aCustomMenu add: 'GeeMail stuff...' subMenu: (owner textPlusMenuFor: self)]! !

