'From Squeak2.9alpha of 13 June 2000 [latest update: #2830] on 8 October 2000 at 11:05:01 pm'!
"Change Set:		StickyFix-ar
Date:			8 October 2000
Author:			Andreas Raab

Prevent world menu when clicking on sticky morphs."!


!PasteUpMorph methodsFor: 'event handling' stamp: 'ar 10/8/2000 23:03'!
morphToGrab: event
	"Return the morph to grab from a mouse down event. If none, return nil."
	self submorphsDo:[:m|
		(m isLocked not and:[m fullContainsPoint: event cursorPoint]) ifTrue:[^m].
	].
	^nil! !

!PasteUpMorph methodsFor: 'event handling' stamp: 'ar 10/8/2000 23:03'!
mouseDown: evt
	"Handle a mouse down event."
	| grabbedMorph |
	grabbedMorph _ self morphToGrab: evt.
	grabbedMorph ifNotNil:[
		grabbedMorph isSticky ifTrue:[^self].
		grabbedMorph isPartsDonor 
			ifTrue:[^grabbedMorph partRepresented duplicateMorph: evt].
		^evt hand grabMorph: grabbedMorph].

	(super handlesMouseDown: evt)
		ifTrue:[^super mouseDown: evt].

	evt hand halo: nil. "shake off halos"
	evt hand releaseKeyboardFocus. "shake of keyboard foci"
	evt shiftPressed ifTrue:[^self dragThroughOnDesktop: evt].
	self isWorldMorph ifTrue:[self addAlarm: #invokeWorldMenu: with: evt after: 200].! !

