'From Squeak2.9alpha of 13 June 2000 [latest update: #2944] on 4 November 2000 at 8:16:21 pm'!
"Change Set:		DragFix-ar
Date:			4 November 2000
Author:			Andreas Raab

Fixes accidental dragging when the lonely submorph of a world got multiple CMD-clicks."!


!Morph methodsFor: 'meta-actions' stamp: 'ar 11/4/2000 20:14'!
blueButtonDown: anEvent
	"Special gestures (cmd-mouse on the Macintosh; Alt-mouse on Windows and Unix) allow a mouse-sensitive morph to be moved or bring up a halo for the morph."
	| h tfm doNotDrag |
	h _ anEvent hand halo.
	"Prevent wrap around halo transfers originating from throwing the event back in"
	doNotDrag _ false.
	h ifNotNil:[
		(h innerTarget == self) ifTrue:[doNotDrag _ true].
		(h innerTarget hasOwner: self) ifTrue:[doNotDrag _ true].
		(self hasOwner: h target) ifTrue:[doNotDrag _ true]].
	h _ self addHalo: anEvent.
	doNotDrag ifTrue:[^self].
	"Initiate drag transition if requested"
	tfm _ (self transformedFrom: nil) inverseTransformation.
	anEvent hand 
		waitForClicksOrDrag: h
		event: (anEvent transformedBy: tfm)
		selectors: { nil. nil. #dragTarget:. }
		threshold: 5.
	"Pass focus explicitly here"
	anEvent hand newMouseFocus: h.! !

