'From Squeak2.9alpha of 13 June 2000 [latest update: #2968] on 7 November 2000 at 6:58:57 pm'!
"Change Set:		DragFix-ar
Date:			7 November 2000
Author:			Andreas Raab

Quick fix for multi selection list morphs."!


!PluggableListMorphOfMany methodsFor: 'as yet unclassified' stamp: 'ar 11/7/2000 18:57'!
mouseDown: event onItem: aMorph
	| index oldIndex oldVal |
	event yellowButtonPressed ifTrue: [^ self yellowButtonActivity: event shiftPressed].
	model okToChange ifFalse: [^ self].  "No change if model is locked"

	index _ scroller submorphs indexOf: aMorph.
	index = 0 ifTrue: [^ self  "minimize chance of selecting with a pane border drag"].

	"Set meaning for subsequent dragging of selection"
	dragOnOrOff _ (model listSelectionAt: index) not.
	oldIndex _ self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal _ model listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff
		ifTrue: [self setSelectedMorph: aMorph]
		ifFalse: [self setSelectedMorph: nil].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [model listSelectionAt: oldIndex put: oldVal].
	model listSelectionAt: index put: dragOnOrOff.
	event hand releaseMouseFocus: aMorph.
	aMorph changed! !

