'From Squeak2.9alpha of 13 June 2000 [latest update: #2983] on 8 November 2000 at 8:29:46 pm'!
"Change Set:		KbdResize-ar
Date:			8 November 2000
Author:			Andreas Raab

Allow resizing a morph using cursor keys when over the resize handle. Very useful for accurately resizing some morph just a few pixels."!


!EventHandler methodsFor: 'testing' stamp: 'ar 10/28/2000 22:17'!
handlesKeyboard: evt
	keyStrokeRecipient ifNotNil: [^ true].
	^ false! !


!Morph methodsFor: 'event handling' stamp: 'ar 10/28/2000 22:18'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event"
	self eventHandler ifNotNil: [^ self eventHandler handlesKeyboard: evt].
	^ false
! !


!HaloMorph methodsFor: 'private' stamp: 'ar 10/28/2000 22:25'!
strokeGrow: evt with: growHandle
	| dir |
	evt keyValue = 28 ifTrue:[dir _ -1@0].
	evt keyValue = 29 ifTrue:[dir _ 1@0].
	evt keyValue = 30 ifTrue:[dir _ 0@-1].
	evt keyValue = 31 ifTrue:[dir _ 0@1].
	dir ifNil:[^self].
	evt hand obtainHalo: self.
	evt hand newKeyboardFocus: growHandle.
	target extent: target extent + dir.
	self layoutChanged.! !

!HaloMorph methodsFor: 'handles' stamp: 'ar 10/28/2000 22:15'!
addGrowHandle: haloSpec
	target isFlexMorph ifFalse: 
		[(self addHandle: haloSpec
				on: #mouseDown send: #startGrow:with: to: self)
				on: #mouseMove send: #doGrow:with: to: self;
				on: #keyStroke send: #strokeGrow:with: to: self]
	"This or addScaleHandle:, but not both, will prevail at any one time"
! !

