'From Squeak2.9alpha of 17 July 2000 [latest update: #2997] on 11 November 2000 at 2:55:29 pm'!
"Change Set:		moreThreads
Date:			11 November 2000
Author:			Bob Arning

- make InternalThreadNavigationMorph smaller and translucent"!


!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 14:50'!
addButtons

	self layoutInset: 2.
	self addARow: {
		self inAColumn: {(StringMorph contents: threadName asString) lock}.
	}.
	self fewerButtonsMode ifTrue: [
		self addARow: {
			self inAColumn: {self buttonPrevious}.
			self inAColumn: {self buttonForward}.
			self inAColumn: {self buttonForMenu}.
		}.
	] ifFalse: [
		self addARow: {
			self inAColumn: {self buttonFirst}.
			self inAColumn: {self buttonPrevious}.
			self inAColumn: {self buttonForward}.
			self inAColumn: {self buttonLast}.
			self inAColumn: {self buttonForMenu}.
		}.
	].

! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 14:48'!
fewerButtonsMode

	^true
! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 14:45'!
initialColor

	^(Color r: 0.27 g: 0.634 b: 0.365) alpha: 0.25! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 14:51'!
moreCommands

	| allThreads aMenu others |

	allThreads _ self class knownThreads.
	aMenu _ MenuMorph new defaultTarget: self.
	others _ (allThreads keys reject: [ :each | each = threadName]) asSortedCollection.
	others do: [ :each |
		aMenu add: 'switch to <',each,'>' selector: #switchToThread: argument: each.
	].
	aMenu add: 'thread of recent projects' action: #getRecentThread.
	aMenu addLine.
	aMenu add: 'First project in thread' action: #firstPage.
	aMenu add: 'Last project in thread' action: #lastPage.
	aMenu add: 'jump within this thread' action: #jumpWithinThread.
	aMenu addLine.
	aMenu add: 'book of all projects' action: #bookOfAllProjects.
	aMenu add: 'edit this thread' action: #editThisThread.
	aMenu addLine.
	aMenu add: 'simply close this navigator' action: #delete.
	aMenu popUpEvent: self world primaryHand lastEvent in: self world! !

