'From Squeak2.9alpha of 13 June 2000 [latest update: #3150] on 8 December 2000 at 3:32:58 pm'!
"Change Set:		ColorPickerLayer-ar
Date:			8 December 2000
Author:			Andreas Raab

Make the color picker search the entire owner chain so it always stays in front."!


!ColorPickerMorph methodsFor: 'other' stamp: 'ar 12/8/2000 15:32'!
putUpFor: aMorph near: aRectangle
	"Put the receiver up on the screen.   Note highly variant behavior depending on the setting of the #modalColorPickers preference"
	| layerNumber |
	aMorph isMorph ifTrue: [
		layerNumber _ aMorph morphicLayerNumber.
		aMorph allOwnersDo:[:m|
			layerNumber _ layerNumber min: m morphicLayerNumber].
		self setProperty: #morphicLayerNumber toValue: layerNumber - 0.1
	].

	isModal == true "backward compatibility"
		ifTrue:
			[self pickUpColorFor: aMorph]
		ifFalse:
			[self addToWorld:
				((aMorph notNil and: [aMorph world notNil])
					ifTrue:
						[aMorph world]
					ifFalse:
						[self currentWorld])
		  		near:
					(aRectangle ifNil:
						[aMorph ifNil: [100@100 extent: 1@1] ifNotNil: [aMorph fullBoundsInWorld]])]! !

