'From Squeak2.9alpha of 13 June 2000 [latest update: #3185] on 19 December 2000 at 6:26:35 pm'!
"Change Set:		FlapTweaks-ar
Date:			19 December 2000
Author:			Andreas Raab

Two tweaks for flaps:
#1 Optimize flaps when being #shrinkWrapped (which lead to a huge number of large area invalidations before).
#2 Fix a minor problem when no previous wording was supplied for a graphical tab."!


!FlapTab methodsFor: 'menu' stamp: 'ar 12/18/2000 16:38'!
wording
	^ self isCurrentlyTextual
		ifTrue:
			[self existingWording]
		ifFalse:
			[self valueOfProperty: #priorWording ifAbsent: ['---']]! !

!FlapTab methodsFor: 'positioning' stamp: 'ar 12/17/2000 22:28'!
spanWorld
	| container |

	container _ self pasteUpMorph ifNil: [self currentWorld].
	(self orientation == #vertical) ifTrue: [
		referent vResizing == #rigid 
			ifTrue:[referent height: container height].
		referent hResizing == #rigid 
			ifTrue:[referent width: (referent width min: container width - self width)].
		referent top: container top.
	] ifFalse: [
		referent hResizing == #rigid
			ifTrue:[referent width: container width].
		referent vResizing == #rigid
			ifTrue:[referent height: (referent height min: container height - self height)].
		referent left: container left.
	] ! !

