'From Squeak2.9alpha of 13 June 2000 [latest update: #3196] on 19 December 2000 at 7:54:28 pm'!
"Change Set:		FillTweak-ar
Date:			19 December 2000
Author:			Andreas Raab

A fix for flood fills which hadn't been properly tested with 'unlimited paint area == false'."!


!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'ar 12/19/2000 19:53'!
fill: evt 
	"Find the area that is the same color as where you clicked. Fill it with 
	the current paint color."
	| box |
	evt isMouseUp
		ifFalse: [^ self].
	"Only fill upon mouseUp"
	"would like to only invalidate the area changed, but can't find out what it is."
	Cursor execute
		showWhile: [
			box _ paintingForm
				floodFill: (self getColorFor: evt)
				at: evt cursorPoint - bounds origin.
			self render: (box translateBy: bounds origin)]! !

