'From Squeak2.9alpha of 17 July 2000 [latest update: #3266] on 14 January 2001 at 3:51:09 pm'!
"Change Set:		scamperProj
Date:			14 January 2001
Author:			Bob Arning

Load a Project from a SuperSwiki link on a page in Scamper"!


!Scamper methodsFor: 'document handling' stamp: 'RAA 1/14/2001 15:50'!
processUnhandledPage: newSource
	"offer to save it to a file"
	| fileName file |
	self status: 'sittin'.

	(newSource url toText endsWith: '.pr') ifTrue: [
		(self confirm: 'Looks like a Squeak project - do you want to load it as such?') ifTrue: [
			^ProjectLoading thumbnailFromUrl: newSource url toText
		].
	].

	(self confirm: 'unkown content-type ', newSource contentType,'--
Would you like to save to a file?') ifFalse: [ ^false ].

	fileName _ ''.
	[
		fileName _ FillInTheBlank request: 'file to save in' initialAnswer: fileName.
		fileName isEmpty ifTrue: [ ^self ].
		file _ FileStream fileNamed: fileName.
		file == nil
	] whileTrue.

	file reset.
	file binary.
	file nextPutAll: newSource content.
	file close.
	^true! !

