'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 28 February 2001 update 3927] on 11 April 2001 at 11:08:10 pm'!
"Change Set:		AtRandomFix
Date:			11 April 2001
Author:			Andreas Raab

Fixes Set>>atRandom looping infintely if set size was divisable by five, e.g., 
	((Set new: 3) add: 1; yourself) atRandom
locked up more often than not."!


!Set methodsFor: 'accessing' stamp: 'ar 4/11/2001 23:01'!
atRandom: aGenerator
	"Answer a random element of the receiver.  Uses aGenerator which
	should be kept by the user in a variable and used every time. Use
	this instead of #atRandom for better uniformity of random numbers 
	because only you use the generator.  Causes an error if self has no 
	elements."
	| ind |
	self emptyCheck.
	ind _ aGenerator nextInt: array size.
	ind to: array size do:[:i|
		(array at: i) == nil ifFalse:[^array at: i]].
	1 to: ind do:[:i|
		(array at: i) == nil ifFalse:[^array at: i]].
	self errorEmptyCollection.! !

