'From Squeakland 3.1.4295 of 28 February 2001 [latest update: #4295] on 12 September 2001 at 3:26:20 pm'!
"Change Set:		magicHalos
Date:			12 September 2001
Author:			Michael Rueger

Adds a preference to turn on mouse over halos in the World by default.
Fixes a bug with magic halos and direction handles."
Preferences addPreference: #mouseOverHalos categories: #(halos) default: false balloonHelp: 'If true, mouse over halos are enabled in the world' projectLocal: false changeInformee: Preferences changeSelector: #mouseOverHalosChanged!


!ColorMappingCanvas methodsFor: 'drawing' stamp: 'mir 9/12/2001 14:24'!
drawPolygon: vertices color: aColor borderWidth: bw borderColor: bc
	"Draw the given polygon."
	^myCanvas
		drawPolygon: vertices
		color: aColor
		borderWidth: bw
		borderColor: (self mapColor: bc)! !


!PasteUpMorph methodsFor: 'world state' stamp: 'mir 9/12/2001 15:18'!
initForProject: aWorldState

	worldState _ aWorldState.
	bounds _ Display boundingBox.
	color _ (Color r:0.937 g: 0.937 b: 0.937).
	self addHand: HandMorph new.
	self setProperty: #automaticPhraseExpansion toValue: true.
	self setProperty: #optimumExtentFromAuthor toValue: Display extent.
	self wantsMouseOverHalos: Preferences mouseOverHalos.
	self borderWidth: 0.
	model _ nil.
! !


!Preferences class methodsFor: 'reacting to change' stamp: 'mir 9/12/2001 15:15'!
mouseOverHalosChanged
	World wantsMouseOverHalos: self mouseOverHalos! !
