'From Squeak3.1alpha of 28 February 2001 [latest update: #4354] on 28 September 2001 at 7:46:36 am'!
"Change Set:		booleanTileFix-sw
Date:			28 September 2001
Author:			Scott Wallace

Fixees a couple of just-introduced drop-related bugs concerning the types of PhraseTileMorphs"!


!PhraseTileMorph methodsFor: 'queries' stamp: 'sw 9/28/2001 07:46'!
isBoolean
	"Answer whether the receiver has a boolean type"

	^ self resultType = #Boolean! !


!ScriptEditorMorph methodsFor: 'dropping/grabbing' stamp: 'sw 9/28/2001 07:07'!
wantsDroppedMorph: aMorph event: evt
	"Answer whether the receiver would be interested in accepting the morph"

	^ (aMorph isTileLike and: [self isTextuallyCoded not]) and:
		[(#(Command Unknown) includes: aMorph resultType capitalized)]! !


!BooleanScriptEditor methodsFor: 'as yet unclassified' stamp: 'sw 9/28/2001 07:45'!
wantsDroppedMorph: aMorph event: evt
	"Answer whether the receiver would be interested in accepting the morph"

	((aMorph isKindOf: PhraseTileMorph) and:
		[submorphs size == 1]) ifTrue: [^ false].  "Avoids unintended destructive drop"
	^ aMorph isTileLike and: [(#(Command Unknown) includes: aMorph resultType capitalized) not]
! !

PhraseTileMorph removeSelector: #booleanOperator!
