'From Squeak 2.3 beta of Nov 25, 1998 on 7 December 1998 at 9:59:10 am'!
"Change Set:		changesMenuHelp-sw
Date:			2 December 1998
Author:			Scott Wallace

balloon help for the Changes menu in morphic"!


!HandMorph methodsFor: 'world menu' stamp: 'sw 12/2/1998 21:21'!
changesMenu
	"Build the changes menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'Change management') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'file out changes' target: ScreenController new action: #fileOutChanges.
	menu balloonTextForLastItem: 'Write the current change set out to a file whose name reflects the change set name and the current date & time.'.

	menu add: 'create new change set...' target: ChangeSorter action: #newChangeSet.
	menu balloonTextForLastItem: 'Create a new change set and make it the current one.'.

	menu add: 'browse changed methods' action: #browseChangedMessages.
	menu balloonTextForLastItem: 'Open a message-list browser showing all methods in the current change set'.

	menu add: 'check for slips' target: Smalltalk changes action: #lookForSlips.
	menu balloonTextForLastItem: 'Check the current change set for halts, references to the Transcript, etc., and if any such thing is found, open up a message-list browser detailing all possible slips.'.


	menu addLine.
	menu add: 'simple change sorter' selector: #openChangeSorter: argument: 1.
	menu balloonTextForLastItem: 'Open a change sorter that allows you to view one change set at a time.'.

	menu add: 'dual change sorter' selector: #openChangeSorter: argument: 2.
	menu balloonTextForLastItem: 'Open a change sorter that shows you two change sets at a time, making it easy to copy and move methods and classes between them.'.

	menu addLine.
	menu add: 'browse recent submissions' action: #openRecentChanges.
	menu balloonTextForLastItem: 'Open a message-list browser that shows the most recent methods that have been submitted.  If you submit changes within that browser, it will keep up-to-date, always showing the most recent submissions.'.

	menu add: 'recent change log' action: #openChangesLog.
	menu balloonTextForLastItem: 'Open a change-list browser on the latter part of the changes log.'.

	menu addLine.
	menu add: 'save world as morph file' action: #saveWorldInFile.
	menu balloonTextForLastItem: 'Save a file that, when reloaded, reconstitutes the current World.'.

	^ menu! !


