'From Squeak3.3alpha of 30 January 2002 [latest update: #4827] on 19 April 2002 at 8:55:11 am'!
"Change Set:		WeakSetCollectFix-nk
Date:			11 March 2002
Author:			Ned Konz

The output of collect: when applied to a WeakSet
includes flag objects that shouldn't appear in the output.

That is, the following code:

w _ WeakSet withAll: { 1 . 2 . 3 }.
w collect: [ :ea | ea ] 

answers a Set(1 2 an Object 3)

This change set fixes this behavior.
It answers a WeakSet, which I think is appropriate, but am not sure.
"!


!WeakSet methodsFor: 'public' stamp: 'nk 3/11/2002 20:35'!
collect: aBlock
	| each newSet |
	newSet _ self species new: self size.
	tally = 0 ifTrue: [^newSet ].
	1 to: array size do:
		[:index |
			((each _ array at: index) == nil or: [each == flag])
				ifFalse: [newSet add: (aBlock value: each)]
		].
	^newSet! !

