'From Squeak 2.3 of January 14, 1999 on 15 January 1999 at 9:08:55 am'!
"Change Set:		InterpChgs
Date:			15 January 1999
Author:			Ian Piumarta

Debugging and Jitter interface methods.
"!


!Interpreter methodsFor: 'debug support'!
okayInterpreterObjects

	| oopOrZero oop |
	self okayFields: nilObj.
	self okayFields: falseObj.
	self okayFields: trueObj.
	self okayFields: specialObjectsOop.
	self okayFields: activeContext.
	self okayFields: method.
	self okayFields: receiver.
	self okayFields: theHomeContext.
	self okayFields: messageSelector.
	self okayFields: newMethod.
	self okayFields: lkupClass.
	0 to: MethodCacheEntries - 1 by: MethodCacheEntrySize do: [ :i |
		oopOrZero _ methodCache at: i + MethodCacheSelector.
		oopOrZero = 0 ifFalse: [
			self okayFields: (methodCache at: i + MethodCacheSelector).
			self okayFields: (methodCache at: i + MethodCacheClass).
			self okayFields: (methodCache at: i + MethodCacheMethod).
		].
	].
	1 to: remapBufferCount do: [ :i |
		oop _ remapBuffer at: i.
		(self isIntegerObject: oop) ifFalse: [
			self okayFields: oop.
		].
	].
	self okayActiveProcessStack.! !

!Interpreter methodsFor: 'compiler support'!
bytecodeExecuteNewMethod

	primitiveIndex > 0 ifTrue: [
		self primitiveResponse.
		successFlag ifTrue: [^ nil]].

	"if not primitive, or primitive failed, activate the method"
	self bytecodeActivateNewMethod.

	"check for possible interrupts at each real send"
	self quickCheckForInterrupts.
! !


