'From Squeak 2.3 of January 14, 1999 on 25 February 1999 at 2:02:44 pm'!

!Float methodsFor: 'mathematical functions' stamp: 'jsp 2/25/1999 11:15'!
arcSin
	"Answer the angle in radians."

	((self < -1.0) or: [self > 1.0]) ifTrue: [self error: 'Value out of range'].
	((self = -1.0) or: [self = 1.0])
		ifTrue: [^ Halfpi * self]
		ifFalse: [^ (self / (1.0 - (self * self)) sqrt) arcTan]! !

!Float methodsFor: 'mathematical functions' stamp: 'jsp 2/24/1999 15:29'!
arcTan: denominator
	"Answer the angle in radians.
	 Optional. See Object documentation whatIsAPrimitive."

	| result |

	(self = 0.0) ifTrue: [ (denominator > 0.0) ifTrue: [ result _ 0 ]
										    ifFalse: [ result _ Pi ]
						]
			    ifFalse: [(denominator = 0.0) ifTrue: [ (self > 0.0) ifTrue: [ result _ Halfpi ]
																ifFalse: [ result _ Halfpi negated ]
													]
										    ifFalse: [ result _ (self / denominator) arcTan].
						].
	
	^ result.! !


