'From Squeak3.1alpha of 7 February 2001 [latest update: #3619] on 16 February 2001 at 4:27:09 pm'!
"Change Set:		fileListMenu-sw
Date:			16 February 2001
Author:			Scott Wallace

Allows shift-yellow-click in the file-list pane of a File browser to bring up the full list of options immediately"!


!FileList methodsFor: 'file list menu' stamp: 'sw 2/16/2001 16:22'!
fileSelectedMenu: aMenu
	"Fill the menu with items appropriate for the selected file type, or for all file types if the shift key is down"

	| firstItems secondItems thirdItems n1 n2 n3 |
	firstItems _ self itemsForFileEnding:
		(Sensor leftShiftDown
			ifFalse:
				[self fileNameSuffix asLowercase]
			ifTrue:
				['*']).

	secondItems _ self itemsForAnyFile.
	thirdItems _ self itemsForNoFile.
	n1 _ firstItems first size.
	n2 _ n1 + secondItems first size.
	n3 _ n2 + thirdItems first size.
	^ aMenu
		labels: firstItems first , secondItems first , thirdItems first , #('more...')
		lines: firstItems second
				, (Array with: n1 with: n2)
				, (thirdItems second collect: [:n | n + n2])
				, (Array with: n3)
		selections: firstItems third , secondItems third , thirdItems third , #(offerAllFileOptions)! !


!PluggableFileList methodsFor: 'file list menu' stamp: 'sw 2/16/2001 16:20'!
fileSelectedMenu: aMenu
	"Fill the menu with items appropriate for the selected file type, or for all file types if the shift key is down"

	| firstItems secondItems thirdItems n1 n2 n3 |
	firstItems _ self itemsForFileEnding:
		(Sensor leftShiftDown
			ifFalse:
				[self fileNameSuffix asLowercase]
			ifTrue:
				['*']).
	secondItems _ self itemsForAnyFile.
	thirdItems _ self itemsForNoFile.
	n1 _ firstItems first size.
	n2 _ n1 + secondItems first size.
	n3 _ n2 + thirdItems first size.
	^ aMenu
		labels: firstItems first , secondItems first , thirdItems first
		lines: firstItems second
				, (Array with: n1 with: n2)
				, (thirdItems second collect: [:n | n + n2])
				, (Array with: n3)
		selections: firstItems third , secondItems third , thirdItems third! !

