'From Squeak3.1alpha of 5 February 2001 [latest update: #3752] on 1 March 2001 at 11:20:33 am'!
"Change Set:		renamedButton-sw
Date:			28 February 2001
Author:			Scott Wallace

If a ScriptActivationButton has ever been renamed manually, then do not automatically update it upon subsequent renamings of the player to which it pertains."!


!ScriptActivationButton methodsFor: 'as yet unclassified' stamp: 'sw 2/28/2001 21:55'!
establishLabelWording
	"Set the label wording, unless it has already been manually edited"

	| itsName |
	itsName _ target externalName.
	(self hasProperty: #labelManuallyEdited)
		ifFalse:
			[self label: (itsName, ' ', arguments first)].
	self setBalloonText: 'click to run the script "', arguments first, '" in player named "', itsName, '"'! !

!ScriptActivationButton methodsFor: 'as yet unclassified' stamp: 'sw 2/28/2001 21:42'!
setLabel
	"Allow the user to enter a new label for this button"

	| newLabel existing |
	existing _ self label.
	newLabel _ FillInTheBlank
		request: 'Please enter a new label for this button'
		initialAnswer: existing.
	(newLabel isEmptyOrNil not and: [newLabel ~= existing]) ifTrue:
		[self setProperty: #labelManuallyEdited toValue: true.
		self label: newLabel].
! !

