'From Squeak3.1alpha of 4 February 2001 [latest update: #3820] on 9 March 2001 at 1:21:05 am'!
"Change Set:		UnwindPS
Date:			9 March 2001
Author:			Andreas Raab

Simulate the former exception behavior wrt unwind *exactly*. EHTester will now succeed if no proper unwind support is available in the VM."!


!BlockContext methodsFor: 'private-exceptions' stamp: 'ar 3/9/2001 01:18'!
ifProperUnwindSupportedElseSignalAboutToReturn
	"A really ugly hack to simulate the necessary unwind behavior for VMs not having proper unwind support"
	<primitive: 123>
	"The above indicates new EH primitives supported. In this case is identical to #value. Sender is expected to use [nil] ifProperUnwindSupportedElseSignalAboutToReturn."
	^ExceptionAboutToReturn signal.! !


!Exception methodsFor: 'signaledException' stamp: 'ar 3/9/2001 01:18'!
return: returnValue
	"Return the argument as the value of the block protected by the active exception handler."
	| handlerHomeContext |
	handlerHomeContext _ [nil] ifProperUnwindSupportedElseSignalAboutToReturn.
	initialContext unwindTo: handlerContext.
	thisContext terminateTo: handlerContext.
	handlerHomeContext == nil
		ifFalse: [handlerContext sender swapSender: handlerHomeContext].
	^returnValue! !

