'From Squeak3.1alpha of 5 February 2001 [latest update: #4232] on 6 August 2001 at 10:37:02 am'!
"Change Set:		betterProjName
Date:			6 August 2001
Author:			Bob Arning

Do a better job of displaying the project name in ProjectViewMorphs when the project is still a DiskProxy"!


!ProjectViewMorph methodsFor: 'drawing' stamp: 'RAA 8/6/2001 10:34'!
safeProjectName

	| projectName args |
	projectName _ self valueOfProperty: #SafeProjectName ifAbsent: ['???'].
	self isTheRealProjectPresent ifFalse: [
		project class == DiskProxy ifTrue: [
			args _ project constructorArgs.
			((args isKindOf: Array) and: [args size = 1 and: [args first isKindOf: String]]) ifTrue: [
				^args first
			].
		] ifFalse: [
			^ projectName
		].
	].
	self setProperty: #SafeProjectName toValue: project name.
	^project name
! !

