'From Squeak3.1alpha of 28 February 2001 [latest update: #4295] on 24 August 2001 at 7:22:07 pm'!
"Change Set:		etoyFlapsFix
Date:			24 August 2001
Author:			Michael Rueger

Makes the creation of default flaps dependend on the eToyFriendly preference."!


!ProjectLauncher methodsFor: 'running' stamp: 'mir 8/24/2001 19:21'!
startUpAfterLogin
	| scriptName loader isUrl |
	self setupFlaps.
	HTTPClient isRunningInBrowser ifTrue:[
		self setupFromParameters.
		scriptName _ self parameterAt: 'src'.
		CodeLoader defaultBaseURL: (self parameterAt: 'Base').
	] ifFalse:[
		scriptName _ (Smalltalk getSystemAttribute: 2) ifNil:[''].
		scriptName isEmpty ifFalse:[
			"figure out if script name is a URL by itself"
			isUrl _ (scriptName asLowercase beginsWith:'http://') or:[
					(scriptName asLowercase beginsWith:'file://') or:[
					(scriptName asLowercase beginsWith:'ftp://')]].
			isUrl ifFalse:[scriptName _ 'file://',scriptName]].
	].
	scriptName isEmptyOrNil
		ifTrue:[^Preferences eToyFriendly ifTrue: [self currentWorld addGlobalFlaps]].
	loader _ CodeLoader new.
	loader loadSourceFiles: (Array with: scriptName).
	(scriptName asLowercase endsWith: '.pr') 
		ifTrue:[self installProjectFrom: loader]
		ifFalse:[loader installSourceFiles].
! !

