'From Squeak3.1alpha of 7 March 2001 [latest update: #4332] on 20 September 2001 at 12:22:59 am'!
"Change Set:		CategorizeUncategorizedMethods-nk
Date:			12 February 2001
Author:			Ned Konz

This is a little tweak that adds a popup menu choice
called 'categorize all uncategorized'
to the message category list menu.

This menu choice will attempt to recategorize uncategorized
methods by looking in parent classes for the method category.
"!


!Browser methodsFor: 'message category functions' stamp: 'dew 9/20/2001 00:21'!
messageCategoryMenu: aMenu

^ aMenu labels:
'browse
printOut
fileOut
reorganize
alphabetize
remove empty categories
categorize all uncategorized
new category...
rename...
remove'
	lines: #(3 8)
	selections:
		#(buildMessageCategoryBrowser printOutMessageCategories fileOutMessageCategories
		editMessageCategories alphabetizeMessageCategories removeEmptyCategories
		categorizeAllUncategorizedMethods addCategory renameCategory removeMessageCategory)
! !

!Browser methodsFor: 'message category list' stamp: 'nk 2/12/2001 09:58'!
categorizeAllUncategorizedMethods
	"Categorize methods by looking in parent classes for a method category."

	| organizer organizers |
	organizer _ self classOrMetaClassOrganizer.
	organizers _ self selectedClass withAllSuperclasses collect: [ :ea | ea organization ].
	(organizer listAtCategoryNamed: ClassOrganizer default) do: [ :sel | | found |
		found _ (organizers collect: [ :org | org categoryOfElement: sel ])
			detect: [ :ea | ea ~= ClassOrganizer default ]
			ifNone: [ ].
		found ifNotNil: [ organizer classify: sel under: found ]
	].

	self changed: #messageCategoryList.! !

