'From Squeak3.2alpha of 2 October 2001 [latest update: #4609] on 15 December 2001 at 2:24:56 pm'!
"Change Set:		BorderedImage
Date:			15 December 2001
Author:			Andreas Raab

Enable the use of common border styles around image like morphs. As an example, you can now use our border styles for framing project views."!


!ImageMorph methodsFor: 'accessing' stamp: 'ar 12/12/2001 01:08'!
borderStyle: newStyle
	| newExtent |
	newExtent _ 2 * newStyle width + image extent.
	bounds extent = newExtent ifFalse:[super extent: newExtent].
	super borderStyle: newStyle.! !

!ImageMorph methodsFor: 'accessing' stamp: 'ar 12/12/2001 01:11'!
borderWidth: bw
	| newExtent |
	newExtent _ 2 * bw + image extent.
	bounds extent = newExtent ifFalse:[super extent: newExtent].
	super borderWidth: bw! !

!ImageMorph methodsFor: 'accessing' stamp: 'ar 12/15/2001 14:14'!
innerBounds
	"Return the inner rectangle enclosed by the bounds of this morph excluding the space taken by its borders. For an unbordered morph, this is just its bounds."

	^ bounds insetBy: self borderWidth! !

!ImageMorph methodsFor: 'drawing' stamp: 'ar 12/12/2001 01:09'!
drawOn: aCanvas
	| style |
	(style _ self borderStyle) ifNotNil:[
		style frameRectangle: bounds on: aCanvas.
	].
	self isOpaque
		ifTrue:[aCanvas drawImage: image at: self innerBounds origin]
		ifFalse:[aCanvas paintImage: image at: self innerBounds origin]! !

