'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 7 March 2003 at 1:51:28 am'!
"Change Set:		PreDebugToDebugFix
Date:			7 March 2003
Author:			Joshua Gargus

A 'fade-out' effect was observed going from the PreDebug window to the Debug window.  This was caused by the PreDebug window being drawn after its model was deleted, but before it was deleted.  This fix causes it to be deleted before the full Debug window is open.  
There is also a nice usability side effect: before, the full debug window would be likely to open somewhere else on the screen (where ever the real-estate manager found room for it).  Now, it is likely to open on the spot vacated by the PreDebug window. "!


!Debugger methodsFor: 'notifier menu' stamp: 'jcg 3/7/2003 01:47'!
debug
	"Open a full DebuggerView."
	| topView |
	topView _ self topView.
	topView model: nil.  "so close won't release me."
	Smalltalk isMorphic
		ifTrue:
			[self breakDependents.
			topView delete.
			^ self openFullMorphicLabel: topView label].

	topView controller controlTerminate.
	topView deEmphasize; erase.

	"a few hacks to get the scroll selection artifacts out when we got here by clicking in the list"
	topView subViewWantingControl ifNotNil: [
		topView subViewWantingControl controller controlTerminate
	].
	topView controller status: #closed.

	self openFullNoSuspendLabel: topView label.
	topView controller closeAndUnscheduleNoErase.
	Processor terminateActive.
! !

