'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 8 March 2003 at 11:54:25 am'!
"Change Set:		MethodReferenceHashFix-dgd
Date:			8 March 2003
Author:			Diego Gomez Deck <DiegoGomezDeck@ConsultAr.com>

Method MethodReferenceTest>>= is implemented but MethodReferenceTest>>hash isn't

- implementation of MethodReferenceTest>>hash
- reimplementation of MethodReferenceTest>>= with ANDs instead of IFs
- remove MethodReferenceTest>>species (it's not necesary becouse of Object>>species)
"!


!MethodReference methodsFor: 'comparisons' stamp: 'dgd 3/7/2003 13:18'!
= anotherMethodReference 
	"Answer whether the receiver and the argument represent the 
	same object."
	^ self species == anotherMethodReference species
		and: [self classSymbol = anotherMethodReference classSymbol]
		and: [self classIsMeta = anotherMethodReference classIsMeta]
		and: [self methodSymbol = anotherMethodReference methodSymbol]! !

!MethodReference methodsFor: 'comparisons' stamp: 'dgd 3/8/2003 11:54'!
hash
	"Answer a SmallInteger whose value is related to the receiver's  
	identity."
	^ (self species hash bitXor: self classSymbol hash)
		bitXor: self methodSymbol hash! !

MethodReference removeSelector: #species!
