'From TeaSqueak3.2 of 19 September 2002 [latest update: #401] on 18 May 2003 at 7:21:39 pm'!
"Change Set:		ZipFileConstantsPool
Date:			18 May 2003
Author:			Andreas Raab

Rewrite ZipFileConstants."
Smalltalk at: #ZipFileConstantsOBSOLETEPOOL put: ZipFileConstants.
Smalltalk removeKey: #ZipFileConstants.!

SharedPool subclass: #ZipFileConstants
	instanceVariableNames: ''
	classVariableNames: 'CentralDirectoryFileHeaderSignature CompressionDeflated CompressionLevelDefault CompressionLevelNone CompressionStored DataDescriptorLength DefaultDirectoryPermissions DefaultFilePermissions DeflatingCompressionFast DeflatingCompressionMaximum DeflatingCompressionNormal DeflatingCompressionSuperFast DirectoryAttrib EndOfCentralDirectorySignature FaMsdos FaUnix FileAttrib IfaBinaryFile IfaTextFile LocalFileHeaderSignature '
	poolDictionaries: ''
	category: 'System-Archives'!

!ZipFileConstants class methodsFor: 'pool initialization' stamp: 'ar 5/18/2003 19:20'!
initialize
	"ZipFileConstants initialize"
	FaMsdos		:= 0.
	FaUnix 		:= 3.
	DeflatingCompressionNormal		:= 0.
	DeflatingCompressionMaximum	:= 2.
	DeflatingCompressionFast		:= 4.
	DeflatingCompressionSuperFast	:= 6.
	CompressionStored				:= 0.
	CompressionDeflated				:= 8.
	CompressionLevelNone			:= 0.
	CompressionLevelDefault			:= 6.
	IfaTextFile						:= 1.
	IfaBinaryFile					:= 0.
	CentralDirectoryFileHeaderSignature	:= 0.
	LocalFileHeaderSignature 			:= 0.
	EndOfCentralDirectorySignature 		:= 0.
	DataDescriptorLength 				:= 12.

	"Unix permission bits"
	DefaultDirectoryPermissions		:= 8r040755.
	DefaultFilePermissions			:= 8r0100666.
	DirectoryAttrib 					:= 8r040000.
	FileAttrib 						:= 8r0100000.

	CentralDirectoryFileHeaderSignature _ 
		(ByteArray with: 16r50 with: 16r4B with: 16r01 with: 16r02) asString.
	LocalFileHeaderSignature _
		(ByteArray with: 16r50 with: 16r4B with: 16r03 with: 16r04) asString.
	EndOfCentralDirectorySignature _
		(ByteArray with: 16r50 with: 16r4B with: 16r05 with: 16r06) asString.! !

ZipFileConstants initialize!
ZipArchive class removeSelector: #initialize!
ZipArchive class removeSelector: #initializeZipFileConstants!
"Postscript:
Rebind users of ZipFileConstants"
Smalltalk allClassesDo:[:aClass|
	(aClass sharedPools includes: ZipFileConstantsOBSOLETEPOOL) ifTrue:[
		Compiler evaluate: (aClass definition copyReplaceAll: 'OBSOLETEPOOL' with: '').
	].
].
Smalltalk removeKey: #ZipFileConstantsOBSOLETEPOOL.!

