'From Squeak3.6beta of ''4 July 2003'' [latest update: #5395] on 11 August 2003 at 10:43:49 pm'!
"Change Set:		MoviesCleanup
Date:			30 July 2003
Author:			Adam Spitz

Moves some classes and methods into the Movies-* categories.

Still leaves the 'add movie clip player' menu item in PianoRollScoreMorph; there might be some kind of general menu-registration mechanism coming soon, so we'll deal with that then."

Smalltalk organization classifyAll: {#BlobMPEGMorph. #MovieClipEndMorph. #MovieClipStartMorph. #MovieFrameSyncMorph. #MoviePlayerMorph. } under: 'Movies-Player'.
Smalltalk organization classifyAll: {#StreamingMP3Sound} under: 'Movies-Kernel'.

PianoRollScoreMorph organization classifyAll: { #addMovieClipPlayer. } under: '*movies'.

"We don't want these methods to be part of the Tools-FileList package; then FileList would depend on Movies, which makes no sense."
MPEGMoviePlayerMorph organization renameCategory: '*Tools-FileList-accessing' toBe: 'accessing'.
MPEGMoviePlayerMorph class organization renameCategory: '*Tools-FileList-registering' toBe: 'registering'.
MPEGPlayer class organization renameCategory: '*Tools-FileList-file suffixes' toBe: 'file suffixes'.
!


!MPEGMoviePlayerMorph class methodsFor: 'class initialization' stamp: 'ads 7/30/2003 16:07'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl | cl unregisterQuadsWithReceiver: self].

	FileList unregisterFileReader: self.! !

