'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5526] on 9 November 2003 at 10:12:06 am'!
"Change Set:		MetaclassInitFix-nk
Date:			9 November 2003
Author:			Ned Konz

The recent changes to new/initialize cause superclasses to be re-initialized upon subclassing.

This CS fixes that problem.

"!


!Metaclass methodsFor: 'instance creation' stamp: 'nk 11/9/2003 10:00'!
new
	"The receiver can only have one instance. Create it or complain that
	one already exists."

	thisClass class ~~ self
		ifTrue: [^thisClass _ self basicNew]
		ifFalse: [self error: 'A Metaclass should only have one instance!!']! !

