'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 1 December 2003 at 12:22:09 pm'!
"Change Set:		MiscCommentBugs
Date:			19 November 2003
Author:			Bijan Parsia

Found some typos and bugs in some comments as I poke around.

So, we need metacomments for these :)

FileList2 class comment contains the line:

	FileList2 morphicViewImageViewer openInWorld

But there is no such method in my 3.6 image. DELETED!!

Form class>>openImageInWindow: had a typo for storeOn:

Given the class comment in ImageMorph, I wonder if this method should be changed to return and ImageMorph rather than a SketchMorph, even though ImageMorph is less functional. (ImageMorph's class comment claims that it supercedes SketchMorph. The change is simple enough, i.e., change the ifTrue: branch of the last statement from '[(SketchMorph withForm: image) openInWorld]' to '[image asMorph openInWorld]'
"!


!FileList2 commentStamp: 'BJP 11/19/2003 21:13' prior: 0!
Some variations on FileList that
- use a hierarchical pane to show folder structure
- use different pane combinations, button layouts and prefiltering for specific uses

FileList2 morphicView openInWorld				"an alternative to the standard FileList"
FileList2 morphicViewNoFile openInWorld			"useful for selecting, but not viewing"
FileList2 morphicViewProjectLoader openInWorld	"useful for finding and loading projects"
FileList2 modalFolderSelector						"allows the user to select a folder"



!
]style[(169 38 41 43 39 48 41 36 36 4)f1cblue;,f1,f1cblue;,f1,f1cblue;,f1,f1cblue;,f1,f1cblue;,f1!


!Form class methodsFor: 'fileIn/Out' stamp: 'BJP 11/19/2003 21:15'!
openImageInWindow: fullName
	"Handle five file formats: GIF, JPG, PNG, Form storeOn: (run coded), and BMP.
	Fail if file format is not recognized."

	| image myStream |

	myStream _ (FileStream readOnlyFileNamed: fullName) binary.
	image _ self fromBinaryStream: myStream.
	myStream close.

	Smalltalk isMorphic ifTrue:[
		Project current resourceManager 
			addResource: image 
			url: (FileDirectory urlForFileNamed: fullName) asString.
	].

	Smalltalk isMorphic
		ifTrue: [(SketchMorph withForm: image) openInWorld]
		ifFalse: [FormView open: image named: fullName]! !

