'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5623] on 14 January 2004 at 7:58:08 pm'!
"Change Set:		IntervallNewFromFix-reposted
Date:			14 January 2004
Author:			Marcus Denker

md: just reposting as changeset. Original Message:

Subject:		[FIX] Interval class>>newFrom:
Author:		Richard A. O'Keefe
Date Posted: 31 May 2002
Archive ID: 6326
Comments:	In Squeak 3.0.1, try
   Interval newFrom: (1 to: 1)
You expect a fresh copy of (1 to: 1).  You GET a division by 0.
This is because the implementation starts

   | newInterval |

   newInterval := self from: aCollection first to: aCollection last
      by: (aCollection last - aCollection first) // (aCollection size - 1).

If aCollection size = 0, this errs instead of returning an empty Interval.
If aCollection size = 1, this gets a divide-by-zero.

Instead, it should read

    | newInterval n |

    (n := aCollection size) <= 1 ifTrue: [
	n = 0 ifTrue: [^self from: 1 to: 0].
	^self from: aCollection first to: aCollection last].
    newInterval := self from: aCollection first to: aCollection last
	by: (aCollection last - aCollection first) // (n - 1).

Has this already been fixed in 3.2?




"!


!Interval class methodsFor: 'instance creation' stamp: 'md 1/14/2004 11:42'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."

    | newInterval n |

    (n := aCollection size) <= 1 ifTrue: [
		n = 0 ifTrue: [^self from: 1 to: 0].
		^self from: aCollection first to: aCollection last].
    	newInterval := self from: aCollection first to: aCollection last
	by: (aCollection last - aCollection first) // (n - 1).
	aCollection ~= newInterval
		ifTrue: [self error: 'The argument is not an arithmetic progression'].
	^newInterval

"	Interval newFrom: {1. 2. 3}
	{33. 5. -23} as: Interval
	{33. 5. -22} as: Interval    (an error)
	(-4 to: -12 by: -1) as: Interval
"! !

