'From TeaSqueak3.6 of 8 February 2004 [latest update: #537] on 10 February 2004 at 5:20:39 pm'!
"Change Set:		ColorFormTranslucent
Date:			10 February 2004
Author:			Andreas Raab

Fix to FormCanvas>>translucentImage:at: failing to draw translucent color forms correctly."!


!Canvas methodsFor: 'drawing-images' stamp: 'ar 2/10/2004 17:19'!
translucentImage: aForm at: aPoint sourceRect: sourceRect
	"Draw a translucent image using the best available way of representing translucency.
	Note: This will be fixed in the future."
	self shadowColor ifNotNil:[
		^self stencil: aForm at: aPoint sourceRect: sourceRect color: self shadowColor].
	(self depth < 32 or:[aForm isTranslucent not]) 
		ifTrue:[^self paintImage: aForm at: aPoint sourceRect: sourceRect].
	self image: aForm
		at: aPoint
		sourceRect: sourceRect
		rule: Form blend! !


!Form methodsFor: 'testing' stamp: 'ar 2/10/2004 17:18'!
isTranslucent
	"Answer whether this form may be translucent"
	^self depth = 32! !


!ColorForm methodsFor: 'testing' stamp: 'ar 2/10/2004 17:18'!
isTranslucent
	"Answer whether this form may be translucent"
	^true! !


