'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 26 February 2004 at 9:37:01 am'!
"Change Set:		EventRecorderPlaybackFix-los
Date:			26 February 2004
Author:			Lothar Schenk

Image: 3.7a

Clicking on a tape in a Filelist that was recorded with the EventRecorderMorph (e.g. EventRecorder.tape) and then choosing the 'open for playback' button results in a walkback: 'MessageNotUnderstood: EventRecorderMorph>>rewind'.

The reason is this call in EventRecorderMorph class>>openTapeFromFile:

openTapeFromFile: fullName
	(EventRecorderMorph new readTape: fullName) rewind openInWorld

EventRecorderMorph has no 'rewind' method or anything resembling it. Leaving out the call to 'rewind' seems to work fine (also plausible, considering that the tape has just been read in from the file).

The attached change set contains a corresponding patch.

Regards, Lothar
"!


!EventRecorderMorph class methodsFor: 'instance creation' stamp: 'los 2/26/2004 11:46'!
openTapeFromFile: fullName
	"Open an eventRecorder tape for playback."
 
	(self new) readTape: fullName; openInWorld! !

