'From Squeak3.7alpha of 11 September 2003 [latest update: #5764] on 11 March 2004 at 9:40:19 am'!
"Change Set:		DependentsSizeFix-nk
Date:			11 March 2004
Author:			Ned Konz

I noticed in the ChangeSorter that if you add a postscript, then close the editor window and try to remove the postscript that you can't.

Further examination showed that there is code in postscriptHasDependents that says
	self postscript dependents size > 0

which returned true even though the dependents slots had been nil'd out.

Though counting dependents is probably questionable, this change set makes DependentsArray>>size report the number of actual dependents (i.e. does not count nils).

"!


!DependentsArray methodsFor: 'copying' stamp: 'nk 3/11/2004 09:34'!
size
	^self inject: 0 into: [ :count :dep | dep ifNotNil: [ count _ count + 1 ]]! !

!DependentsArray methodsFor: 'enumerating' stamp: 'nk 3/11/2004 09:34'!
do: aBlock
	"Refer to the comment in Collection|do:."
	| dep |
	1 to: self basicSize do:[:i|
		(dep _ self at: i) ifNotNil:[aBlock value: dep]].! !

