'From Squeak3.7beta of ''1 April 2004'' [latest update: #5923] on 27 May 2004 at 1:57:18 pm'!
"Change Set:		MultipleEmph
Date:			27 May 2004
Author:			Yoshiki Ohshima

An attempt to fix the handling of multiple text attributes."!


!ParagraphEditor methodsFor: 'editing keys' stamp: 'yo 5/27/2004 13:56'!
setEmphasis: emphasisSymbol
	"Change the emphasis of the current selection."

	| oldAttributes attribute |
	oldAttributes _ paragraph text attributesAt: self selectionInterval first forStyle: paragraph textStyle.

	attribute _ TextEmphasis perform: emphasisSymbol.
	(emphasisSymbol == #normal) 
		ifFalse:	[oldAttributes do:	
			[:att | (att dominates: attribute) ifTrue: [attribute turnOff]]].
	self replaceSelectionWith: (self selection addAttribute: attribute)! !

