'From Squeak3.7-m17n of 21 July 2004 [latest update: #0] on 21 July 2004 at 7:28:58 pm'!
SMSimpleInstaller subclass: #SMLanguageInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMBase-installer'!

!SMLanguageInstaller methodsFor: 'services' stamp: 'mir 7/21/2004 19:28'!
install
	"This service should bring the package to the client, 
	unpack it if necessary and install it into the image. 
	The package is notified of the installation."

	self cache; unpack.
	[NaturalLanguageTranslator mergeTranslationFileNamed: unpackedFileName]
			ensure: [packageRelease noteInstalled]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SMLanguageInstaller class
	instanceVariableNames: ''!

!SMLanguageInstaller class methodsFor: 'testing' stamp: 'mir 7/21/2004 19:28'!
canInstall: aPackage
	"Answer if this class can install the package.
	We handle .translation files optionally compressed."

	| fileName |
	fileName _ aPackage downloadFileName.
	fileName ifNil: [^false].
	fileName _ fileName asLowercase.
	^(fileName endsWith: '.translation') or: [
		(fileName endsWith: '.tra') or: [
			(fileName endsWith: '.tra.gz') or: [
				fileName endsWith: '.translation.gz']]]! !
