'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 17 August 2004 at 10:15:22 pm'!
"Change Set:		PRServerDirectory-dgd
Date:			17 August 2004
Author:			Diego Gomez Deck

Methods missing coming from Small-Land's image"!


!PRServerDirectory methodsFor: 'testing' stamp: 'dgd 8/17/2004 22:14'!
queryProjectsAndShow: thingsToSearchForCollection 
	"query the server for all the projects that match  
	thingsToSearchForCollection"
	| url arguments answer string |
	url := self urlFromServer: self server directories: {'programmatic'. 'queryprojects'}.
	arguments := self getPostArgsFromThingsToSearchFor: thingsToSearchForCollection.
	""
	Cursor read
		showWhile: [""
			"answer := HTTPClient httpPostDocument: url args:  
			args."
			answer := HTTPSocket httpGetDocument: url args: arguments.
			string := answer contents.
			(string beginsWith: '--OK--')
				ifTrue: [^ true]].
	""
	self
		inform: ('Server responded: {1}' translated format: {string}).
	^ false! !

!PRServerDirectory methodsFor: 'private' stamp: 'dgd 8/17/2004 22:14'!
getPostArgsFromThingsToSearchFor: thingsToSearchForCollection 
	| args |
	args := Dictionary new.
	""
	thingsToSearchForCollection
		do: [:each | 
			| pos | 
			pos := each indexOf: $:.
			pos isZero
				ifFalse: [| key value | 
					key := (each first: pos - 1) withBlanksTrimmed.
					value := (each allButFirst: pos) withBlanksTrimmed.
					(value beginsWith: '*')
						ifTrue: [value := value allButFirst].
					(value endsWith: '*')
						ifTrue: [value := value allButLast].
					""
					args at: key put: {value}]].
	""
	^ args! !

