'From Squeakland 3.8.5976 of 19 August 2004 [latest update: #243] on 23 August 2004 at 5:10:15 pm'!
"Change Set:		TextMorphEditor-dispatchFix2-nk
Date:			23 August 2004
Author:			Ned Konz

Fixes a problem introduced in CS 60000TextMorphEditor-dispatchOnCharacterwith that affected the use of NCDisplayTextMorph instances.

This is a fix for bug 0000081
"!


!TextMorphEditor methodsFor: 'editing keys' stamp: 'nk 8/23/2004 17:08'!
changeEmphasis: aStream
	"Change the emphasis of the current selection."
	| retval |
	retval := super changeEmphasis: aStream.
	paragraph composeAll.
	self recomputeInterval.
	morph updateFromParagraph.
	^retval! !

!TextMorphEditor methodsFor: 'typing support' stamp: 'sw 8/12/2002 01:12'!
dispatchOnCharacter: char with: typeAheadStream
	"Carry out the action associated with this character, if any.
	Type-ahead is passed so some routines can flush or use it."

	((char == Character cr) and: [morph acceptOnCR])
		ifTrue:
			[sensor keyboard.  "Gobble cr -- probably unnecessary."
			self closeTypeIn.
			^ true].

	^ super dispatchOnCharacter: char with: typeAheadStream! !

