'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #308] on 4 September 2004 at 7:17:26 pm'!
"Change Set:		TrueTypeFontSavingFix-nk
Date:			3 September 2004
Author:			Ned Konz

Ref: bug# 0000129

All TrueType fonts (at least the TTFont type) that were being saved in a project were being loaded back in as the default font, because when they were saved the full name was used (like 'Bitstream Vera Sans Bold'), but when they were being loaded the family name (like 'Bitstream Vera Sans') was being used.

This change set changes this behavior to use the full name at both times.

I don't believe that the TTCFontDescriptions work at all when filed out.

Anyway, this is a temporary fix and will be included in a later more comprehensive fix for font issues.

"!


!TTFontDescription methodsFor: 'copying' stamp: 'nk 9/3/2004 14:48'!
objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  Write a reference to a known Font in the other system instead.  "

	"A path to me"
	(TextConstants at: #forceFontWriting ifAbsent: [false]) ifTrue: [^ self].
		"special case for saving the default fonts on the disk.  See collectionFromFileNamed:"

	dp _ DiskProxy global: #TTFontDescription selector: #descriptionFullNamed:
			args: {self fullName}.
	refStrm replace: self with: dp.
	^ dp.
! !

