'From Small-Land 3.8-5976-0266 of 10 September 2004 [latest update: #5976] on 12 September 2004 at 8:47:42 pm'!
"Change Set:		MorphIconOrThumbnail-dgd
Date:			12 September 2004
Author:			Diego Gomez Deck

Methods for convenience to represent any morph as an icon or as a thumbnail of itself.

Useful to put an representation of any morph on menus, docking bars, etc.

"!


!Morph methodsFor: 'thumbnail' stamp: 'dgd 9/12/2004 20:19'!
icon
	"Answer a form with an icon to represent the receiver"
	^ nil! !

!Morph methodsFor: 'thumbnail' stamp: 'dgd 9/12/2004 20:33'!
iconOrThumbnail
	"Answer an appropiate form to represent the receiver"

	^ self icon
		ifNil: [ | maxExtent fb |maxExtent := 320 @ 240.
			fb := self fullBounds.
			fb area <= (maxExtent x * maxExtent y)
				ifTrue: [self imageForm]
				ifFalse: [self imageFormForRectangle: (fb topLeft extent: maxExtent)]
		]
! !

