'From Squeak3.6beta of ''4 July 2003'' [latest update: #5402] on 28 August 2003 at 6:35:22 pm'!
"Change Set:		StreamClosedFix
Date:			28 August 2003
Author:			Avi Bryant

Stream implements #closed for compatibility with FileStream.  However, this method is inconsistently implemented in the Stream hierarchy: ReadWriteStream implements it to return false, as does GZipSurrogateStream, but the abstract Stream superclass implements it to return true.

This means, in particular, that ReadStreams are always considered closed, which leads to problems when using them with ZipArchive.

This changeset modifies Stream>>closed to return false.  There may be some reason this is a bad idea, but I'm submitting this fix to at least start the discussion.
"!


!Stream methodsFor: 'testing' stamp: 'ab 8/28/2003 18:30'!
closed
	^ false! !

