'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6485] on 26 November 2004 at 5:03:38 pm'!
"Change Set:		BecomeTest2-md
Date:			26 November 2004
Author:			Marcus Denker

test for become, renamed test for forwordBecome"!


!ObjectTest methodsFor: 'testing' stamp: 'md 11/26/2004 16:37'!
testBecome
	"self debug: #testBecome"
	"this test should that all the variables pointing to an object are pointing now to another one, and all
      object pointing to the other are pointing to the object"

	| pt1 pt2 pt3 |
	pt1 := 0@0.
	pt2 := pt1.
	pt3 := 100@100.

	pt1 become: pt3.
	self assert: pt2 = (100@100).
	self assert: pt3 = (0@0).
	self assert: pt1 = (100@100).! !

!ObjectTest methodsFor: 'testing' stamp: 'md 11/26/2004 16:36'!
testBecomeForward
	"self debug: #testBecomeForward"
	"this test should that all the variables pointing to an object are pointing now to another one.
	Not that this inverse is not true. This kind of become is called oneWayBecome in VW"

	| pt1 pt2 pt3 |
	pt1 := 0@0.
	pt2 := pt1.
	pt3 := 100@100.
	pt1 becomeForward: pt3.
	self assert: pt2 = (100@100).
	self assert: pt3 == pt2.
	self assert: pt1 = (100@100)! !

