'From Squeak3.7beta of ''1 April 2004'' [latest update: #5923] on 26 November 2004 at 10:59:59 am'!
"Change Set:		PrintShowingDecimalPlacesTest-dtl
Date:			26 November 2004
Author:			David T. Lewis

A unit test for Number>>printShowingDecimalPlaces:

This will fail for '10 printShowingDecimalPlaces: 20' due to missing
range check in Utilities class>>floatPrecisionForDecimalPlaces:

A fix is provided in a separate change set."!


!NumberTest methodsFor: 'testing' stamp: 'dtl 11/25/2004 14:37'!
testPrintShowingDecimalPlaces

	self assert: (111.2 printShowingDecimalPlaces: 2) = '111.20'.
	self assert: (111111111111111 printShowingDecimalPlaces: 2) = '1.11'.
	self assert: (123e20 printShowingDecimalPlaces: 2) = '1.23'.
	self assert: (123.999e20 printShowingDecimalPlaces: 2) = '1.23'.
	self assert: (10 printShowingDecimalPlaces: 20) ='10.00000000000000000000'.
! !


!NumberTest reorganize!
('testing' testPrintShowingDecimalPlaces)
!

