'From Squeak3.7beta of ''1 April 2004'' [latest update: #5923] on 11 December 2004 at 12:13:31 pm'!
"Change Set:		DelayFix-dtl
Date:			11 December 2004
Author:			David T. Lewis

The following will hang a Squeak image. The error cannot be caught and the image is left in an unrecoverable condition (at least I don't know how to recover it).

  (Delay forMilliseconds: 625/4) wait ==> BOOM

The fix (provided) is to ensure that a Delays are created with integral values.
"!


!Delay class methodsFor: 'instance creation' stamp: 'dtl 12/11/2004 11:59'!
forMilliseconds: anInteger
	"Return a new Delay for the given number of milliseconds. Sending 'wait' to this Delay will cause the sender's process to be suspended for approximately that length of time."

	anInteger < 0 ifTrue: [self error: 'delay times cannot be negative'].
	^ self new
		setDelay: anInteger asInteger
		forSemaphore: Semaphore new
! !

