'From Squeak3.10alpha of 30 March 2007 [latest update: #7111] on 24 May 2007 at 9:17:12 am'!
"Reporter: dpollet
Summary: 0006462: Jump-by-key in some lists broken
Description: PluggableListMorph>>basicKeyPressed: is responsible for the jump to an item by typing its first letter(s) feature in lists, which is broken in e.g. the class column of Omnibrowser.
This is because of this identity comparison near the end of the method, which should actually be a simple equality so it still works with Texts or Strings instead of Symbols:
        nextSelection := self getList findFirst: [:a | a == nextSelectionText].

Additionally the jump behavior is wrong when typing several keystrokes in a burst to jump to a multi-letter-prefix: it will jump to the next matching item at each keystroke within a keystroke burst, instead of staying in place as long as the item still matches the typed prefix.

Here is a fixed implementation (tested in OmniBrowser and the OB Universe Browser, on a 3.10 squeak-dev image):
"!

ReleaseBuilderFor3dot10 new updatePackages: 'Morphic-edc.124(123).mcd'
!

