'From Squeak 2.0 BETA of May 8, 1998 on 19 May 1998 at 2:15:32 pm'!
"Change Set:		jhmMidiAndDispPrims
Date:			19 May 1998
Author:			John Maloney

Virtual Machine addtions and changes:
  1.  Adds MIDI primitives
  2. Removes support for MIDI from SerialPorts (and prims)
  3. Image remembers if it was in fullScreen mode when saved
  4. Primitive support for deferred display updating"!

ObjectMemory subclass: #DynamicInterpreterState
	instanceVariableNames: 'localCP pseudoReceiver newReceiver theTemporaryPointer localIP localSP messageSelector argumentCount newMethod currentBytecode successFlag primitiveIndex methodCache mcProbe nextPollTick nextWakeupTick lastTick interruptKeycode interruptPending semaphoresToSignal semaphoresToSignalCount savedWindowSize fullScreenFlag deferDisplayUpdates '
	classVariableNames: 'ActiveProcessIndex BlockArgumentCountIndex CacheProbeMax CallerIndex CharacterValueIndex DirBadPath DirEntryFound DirNoMoreEntries ExcessSignalsIndex FirstLinkIndex HeaderIndex HomeIndex InitialIPIndex InstanceSpecificationIndex InstructionPointerIndex LastLinkIndex LiteralStart MaxPrimitiveIndex MessageArgumentsIndex MessageDictionaryIndex MessageSelectorIndex MessageSize MethodArrayIndex MethodCacheClassCol MethodCacheColumns MethodCacheDelayCol MethodCacheEntries MethodCacheMask MethodCacheMethodCol MethodCachePrimIndexCol MethodCacheSelectorCol MethodCacheSize MethodCacheTMethodCol MethodIndex MyListIndex NextLinkIndex PrimitiveTable PriorityIndex ProcessListsIndex ReceiverIndex SelectorStart SemaphoresToSignalSize SenderIndex StackPointerIndex StreamArrayIndex StreamIndexIndex StreamReadLimitIndex StreamWriteLimitIndex SuperclassIndex SuspendedContextIndex TempFrameStart TranslatedMethodIndex ValueIndex XIndex YIndex '
	poolDictionaries: ''
	category: 'Squeak-Jitter'!
ObjectMemory subclass: #Interpreter
	instanceVariableNames: 'activeContext theHomeContext method receiver instructionPointer stackPointer localIP localSP messageSelector argumentCount newMethod currentBytecode successFlag primitiveIndex methodCache reclaimableContextCount mcProbe nextPollTick nextWakeupTick lastTick interruptKeycode interruptPending semaphoresToSignal semaphoresToSignalCount savedWindowSize fullScreenFlag deferDisplayUpdates '
	classVariableNames: 'ActiveProcessIndex BlockArgumentCountIndex BytecodeTable CacheProbeMax CallerIndex CharacterValueIndex DirBadPath DirEntryFound DirNoMoreEntries ExcessSignalsIndex FirstLinkIndex HeaderIndex HomeIndex InitialIPIndex InstanceSpecificationIndex InstructionPointerIndex LastLinkIndex LiteralStart MaxPrimitiveIndex MessageArgumentsIndex MessageDictionaryIndex MessageSelectorIndex MessageSize MethodArrayIndex MethodCacheEntries MethodCacheMask MethodCacheSize MethodIndex MyListIndex NextLinkIndex PrimitiveTable PriorityIndex ProcessListsIndex ReceiverIndex SelectorStart SemaphoresToSignalSize SenderIndex StackPointerIndex StreamArrayIndex StreamIndexIndex StreamReadLimitIndex StreamWriteLimitIndex SuperclassIndex SuspendedContextIndex TempFrameStart ValueIndex XIndex YIndex '
	poolDictionaries: ''
	category: 'Squeak-Interpreter'!
Object subclass: #MidiPrimTester
	instanceVariableNames: 'port '
	classVariableNames: 'CanSetClock CanUseSemaphore ClockTicksPerSec EchoOn EventsAvailable FlushDriver HasBuffer HasDurs HasInputClock Installed UseControllerCache Version '
	poolDictionaries: ''
	category: 'System-Serial Port'!

!DisplayScreen methodsFor: 'private' stamp: 'jm 5/17/1998 08:29'!
deferUpdates: aBoolean
	"Set the deferUpdates flag in the virtual machine. When this flag is true, BitBlt operations on the Display are not automatically propagated to the screen. If this underlying platform does not support deferred updates, this primitive will fail. Answer the receiver if the primitive succeeds, nil if it fails."

	<primitive: 126>
	^ nil  "answer nil if primitive fails"
! !

!DisplayScreen methodsFor: 'private' stamp: 'jm 5/17/1998 08:35'!
showRectLeft: l right: r top: t bottom: b
	"Force the given rectangular section of the Display to be copied to the screen. Do nothing if the primitive fails. Typically used when the deferUpdates flag in the virtual machine is on; see deferUpdates:. This primitive is not implemented on all platforms."

	<primitive: 127>
	"do nothing if primitive fails"
! !


!DynamicInterpreter reorganize!
('initialization' initializeInterpreter: loadInitialContext preTranslateContextMethods)
('utilities' areIntegers:and: arrayValueOf: booleanValueOf: checkedIntegerValueOf: externalizeIPandSP fetchArray:ofObject: fetchFloat:ofObject: fetchInteger:ofObject: fetchIntegerOrTruncFloat:ofObject: floatValueOf: internalizeIPandSP makePointwithxValue:yValue: quickFetchInteger:ofObject: signExtend16: sizeOfSTArrayFromCPrimitive: storeInteger:ofObject:withValue: successIfClassOf:is: successIfFloat:and: translatedInstructionIndex:toPointerIn: translatedInstructionPointer:toIndexIn:)
('object memory support' mapInterpreterOops markAndTraceInterpreterOops postGCAction)
('compiled methods' argumentCountOf: headerOf: literal: literal:ofMethod: literalCountOf: literalCountOfHeader: methodClassOf: primitiveIndexOf: primitiveNewMethod)
('registers' instructionPointer internalInstructionPointer internalMethod internalReceiver internalSetInstructionPointer: internalSetStackPointer: internalStackPointer internalTranslatedMethod setStackPointer: setTemporaryPointer: stackPointer temporaryPointer translatedMethod)
('context cache' cachedInstructionIndexAt: cachedInstructionIndexAt:put: cachedInstructionPointerAt: cachedInstructionPointerAt:put: cachedTranslatedMethodAt: cachedTranslatedMethodAt:put:)
('context cache-private' basicCachedTranslatedMethodAt: basicCachedTranslatedMethodAt:put: translatedMethodOfBlockContext:)
('contexts' argumentCountOfBlock: fetchContextRegisters: internalFetchContextRegisters internalPop: internalPop:thenPush: internalPush: internalStackTop internalStackValue: methodOfBlockContext: pop: pop:thenPush: popInteger popPos32BitInteger popStack push: pushBool: pushInteger: receiverOfBlockContext: stackIntegerValue: stackTop stackValue: temporary: temporary:put: unPop:)
('object format' fixedFieldsOf:format:length: formatOfClass:)
('message sending' activateNewMethod argCount createActualMessage executeForCachedReceiver executeForNormalReceiver executeNewMethod findNewMethodInClass: lookupMethodInClass: lookupMethodInDictionary: sendSelectorToClass: specialSelector: superclassOf:)
('method lookup cache' addToMethodCacheSel:class:method:primIndex:translatedMethod: hashForCacheWithSelector:class: lookupInMethodCacheSel:class: markAndTraceMethodCache markAndTraceMethodCacheLine: remapMethodCache remapMethodCacheLine:)
('interpreter shell' interpret interpreterInitializing)
('primitive support' failed positive32BitIntegerFor: positive32BitValueOf: primIndex primitiveFail primitiveResponse primitiveResponseForCachedReceiver success:)
('arithmetic primitives' checkBooleanResult: checkIntegerResult: compare31or32Bits:equal: primitiveAdd primitiveBitAnd primitiveBitOr primitiveBitShift primitiveBitXor primitiveDiv primitiveDivide primitiveEqual primitiveGreaterOrEqual primitiveGreaterThan primitiveLessOrEqual primitiveLessThan primitiveMakePoint primitiveMod primitiveMultiply primitiveNotEqual primitiveQuo primitiveSubtract)
('float primitives' popFloat primitiveArctan primitiveAsFloat primitiveExp primitiveExponent primitiveFloatAdd primitiveFloatDivide primitiveFloatEqual primitiveFloatGreaterOrEqual primitiveFloatGreaterThan primitiveFloatLessOrEqual primitiveFloatLessThan primitiveFloatMultiply primitiveFloatNotEqual primitiveFloatSubtract primitiveFractionalPart primitiveLogN primitiveSine primitiveSquareRoot primitiveTimesTwoPower primitiveTruncated pushFloat:)
('array and stream primitives' asciiOfCharacter: byteLengthOf: characterForAscii: commonAt: commonAtPut: lengthOf: lengthOf:baseHeader:format: okArrayClass: okStreamArrayClass: primitiveAt primitiveAtEnd primitiveAtPut primitiveNext primitiveNextPut primitiveSize primitiveStringAt primitiveStringAtPut primitiveStringReplace stObject:at: stObject:at:put: stSizeOf: subscript:with:format: subscript:with:storing:format:)
('object access primitives' primitiveArrayBecome primitiveAsOop primitiveClass primitiveClone primitiveEquivalent primitiveInstVarAt primitiveInstVarAtPut primitiveNew primitiveNewWithArg primitiveNextInstance primitiveNextObject primitiveObjectAt primitiveObjectAtPut primitiveObjectPointsTo primitivePointX primitivePointY primitiveSomeInstance primitiveSomeObject sufficientSpaceToInstantiate:indexableSize:)
('control primitives' initializeCachedBlockContext:fromClosure: primitiveBlockCopy primitiveDoPrimitiveWithArgs primitivePerform primitivePerformWithArgs primitiveValue primitiveValueWithArgs)
('processes' addLastLink:toList: checkForInterrupts internalQuickCheckForInterrupts isEmptyList: primitiveResume primitiveSignal primitiveSuspend primitiveWait putToSleep: quickCheckForInterrupts removeFirstLinkOfList: resume: schedulerPointer signalSemaphoreWithIndex: synchronousSignal: transferTo: wakeHighestPriority)
('I/O primitives' fullDisplayUpdate primitiveBeCursor primitiveBeDisplay primitiveBeep primitiveCopyBits primitiveDeferDisplayUpdates primitiveDrawLoop primitiveForceDisplayUpdate primitiveInputSemaphore primitiveInputWord primitiveInterruptSemaphore primitiveKbdNext primitiveKbdPeek primitiveMouseButtons primitiveMousePoint primitiveScanCharacters primitiveScreenSize primitiveSetInterruptKey primitiveShowDisplayRect primitiveWarpBits showDisplayBits)
('file primitives' asciiDirectoryDelimiter fileRecordSize fileValueOf: makeDirEntryName:size:createDate:modDate:isDir:fileSize: primitiveDirectoryCreate primitiveDirectoryDelimitor primitiveDirectoryLookup primitiveDirectorySetMacTypeAndCreator primitiveFileAtEnd primitiveFileClose primitiveFileDelete primitiveFileGetPosition primitiveFileOpen primitiveFileRead primitiveFileRename primitiveFileSetPosition primitiveFileSize primitiveFileWrite)
('memory space primitives' primitiveBytesLeft primitiveFullGC primitiveIncrementalGC primitiveLowSpaceSemaphore primitiveSignalAtBytesLeft)
('socket primitives' primitiveInitializeNetwork primitiveSocketAbortConnection primitiveSocketCloseConnection primitiveSocketConnectToPort primitiveSocketConnectionStatus primitiveSocketCreate primitiveSocketDestroy primitiveSocketError primitiveSocketListenOnPort primitiveSocketLocalAddress primitiveSocketLocalPort primitiveSocketReceiveDataAvailable primitiveSocketReceiveDataBufCount primitiveSocketRemoteAddress primitiveSocketRemotePort primitiveSocketSendDataBufCount primitiveSocketSendDone socketRecordSize socketValueOf:)
('resolver primitives' intToNetAddress: netAddressToInt: primitiveResolverAbortLookup primitiveResolverAddressLookupResult primitiveResolverError primitiveResolverLocalAddress primitiveResolverNameLookupResult primitiveResolverStartAddressLookup primitiveResolverStartNameLookup primitiveResolverStatus)
('sound primitives' primitiveConstantFill primitiveShortAt primitiveShortAtPut primitiveSoundAvailableSpace primitiveSoundGetRecordingSampleRate primitiveSoundInsertSamples primitiveSoundPlaySamples primitiveSoundPlaySilence primitiveSoundRecordSamples primitiveSoundSetRecordLevel primitiveSoundStart primitiveSoundStartRecording primitiveSoundStartWithSemaphore primitiveSoundStop primitiveSoundStopRecording)
('serial port primitives' primitiveSerialPortClose primitiveSerialPortOpen primitiveSerialPortRead primitiveSerialPortWrite)
('midi primitives' primitiveMIDIClosePort primitiveMIDIGetClock primitiveMIDIGetPortCount primitiveMIDIGetPortDirectionality primitiveMIDIGetPortName primitiveMIDIOpenPort primitiveMIDIParameterGetOrSet primitiveMIDIRead primitiveMIDIWrite)
('other primitives' primitiveClipboardText primitiveExitToDebugger primitiveFlushCache primitiveFlushCacheSelective primitiveFormPrint primitiveGetAttribute primitiveImageName primitiveMillisecondClock primitiveNoop primitiveQuit primitiveReadJoystick primitiveRelinquishProcessor primitiveSecondsClock primitiveSetFullScreen primitiveSignalAtMilliseconds primitiveSnapshot primitiveSpecialObjectsOop primitiveVMParameter primitiveVMPath)
('quick primitives' primitiveLoadInstVar primitivePushFalse primitivePushMinusOne primitivePushNil primitivePushOne primitivePushSelf primitivePushTrue primitivePushTwo primitivePushZero)
('debug printing' cr print: printChar: printNum:)
('debug support' allAccessibleObjectsOkay debugPrint: findClassOfMethod:forReceiver: findSelectorOfMethod:forReceiver: okayActiveProcessStack okayFields: okayInterpreterObjects okayOop: oopHasOkayClass: printCallStack printNameOfClass:count: printStringOf: reportContexts)
('image save/restore' byteSwapByteObjects byteSwapped: checkImageVersionFrom: getLongFromFile:swap: imageFormatVersion putLong:toFile: readImageFromFile:HeapSize: reverseBytesFrom:to: reverseBytesInImage writeImageFile:)
('assert-verify' assert: assertAny: assertIsArray: assertIsArrayOrNil: assertIsCachedBaseContext: assertIsCachedBlockContext: assertIsCachedContext: assertIsCachedMethodContext: assertIsCompiledMethod: assertIsCompiledMethodOrInteger: assertIsContext: assertIsContextOrNull: assertIsIntegerObject: assertIsLegalCachedTempPointer: assertIsLegalInstructionIndex:in: assertIsLegalInstructionPointer:in: assertIsLegalStableTempPointer: assertIsLegalStackOffsetInContext: assertIsLegalStackPointer: assertIsLegalTempOffset: assertIsLegalTempPointer: assertIsLegalTranslatedInstructionIndex:in: assertIsLegalTranslatedInstructionPointer:in: assertIsNotNull: assertIsNull: assertIsOop: assertIsProcess: assertIsPseudoActiveContext: assertIsPseudoContext: assertIsPseudoContextOrNull: assertIsStableBaseContext: assertIsStableBlockContext: assertIsStableContext: assertIsStableContextClass: assertIsStableContextOrNil: assertIsStableContextOrNilOrNull: assertIsStableContextOrNull: assertIsStableMethodContext: assertIsValidPseudoContextAt: assertIsWordAligned: assertNotIntegerObject: assertStackPointerIsExternal assertStackPointerIsInternal verifyCachedContext: verifyMethodCache verifyStableContext: verifyStack)
!


!DynamicInterpreter methodsFor: 'initialization' stamp: 'jm 5/18/1998 13:25'!
initializeInterpreter: bytesToShift
	"Initialize Interpreter state before starting execution of a new image."
	self inline: false.
	self initializeObjectMemory: bytesToShift.
	self initBBOpTable.

	messageSelector			_ nilObj.
	newReceiver			_ nilObj.
	newMethod				_ nilObj.
	newTranslatedMethod	_ nilObj.

	pseudoReceiver			_ 0.

	self initializeTranslator.

	self initMethodCache.
	self loadInitialContext.
	interruptCheckCounter _ 0.
	nextPollTick _ 0.
	nextWakeupTick _ 0.
	lastTick _ 0.
	interruptKeycode _ 2094.  "cmd-."
	interruptPending _ false.
	semaphoresToSignalCount _ 0.
	deferDisplayUpdates _ false.
! !

!DynamicInterpreter methodsFor: 'I/O primitives' stamp: 'jm 5/18/1998 13:34'!
primitiveDeferDisplayUpdates
	"Set or clear the flag that controls whether modifications of the Display object are propagated to the underlying platform's screen."

	| flag |
	flag _ self stackTop.
	flag = trueObj
		ifTrue: [deferDisplayUpdates _ true]
		ifFalse: [
			flag = falseObj
				ifTrue: [deferDisplayUpdates _ false]
				ifFalse: [self primitiveFail]].
	successFlag ifTrue: [self pop: 1].  "pop flag; leave rcvr on stack"
! !

!DynamicInterpreter methodsFor: 'I/O primitives' stamp: 'jm 5/18/1998 13:35'!
primitiveForceDisplayUpdate
	"On some platforms, this primitive forces enqueued display updates to be processed immediately. On others, it does nothing."

	self ioForceDisplayUpdate.
! !

!DynamicInterpreter methodsFor: 'I/O primitives' stamp: 'jm 5/18/1998 13:36'!
primitiveShowDisplayRect
	"Force the given rectangular section of the Display to be copied to the screen."

	| bottom top right left displayObj dispBits w h d dispBitsPtr |
	bottom	_ self stackIntegerValue: 0.
	top		_ self stackIntegerValue: 1.
	right	_ self stackIntegerValue: 2.
	left		_ self stackIntegerValue: 3.
	displayObj _ self splObj: TheDisplay.
	self success: ((self isPointers: displayObj) and: [(self lengthOf: displayObj) >= 4]).
	successFlag ifTrue: [
		dispBits _ self fetchPointer: 0 ofObject: displayObj.
		w _ self fetchInteger: 1 ofObject: displayObj.
		h _ self fetchInteger: 2 ofObject: displayObj.
		d _ self fetchInteger: 3 ofObject: displayObj].
	left < 0 ifTrue: [left _ 0].
	right > w ifTrue: [right _ w].
	top < 0 ifTrue: [top _ 0].
	bottom > h ifTrue: [bottom _ h].
	self success: ((left <= right) and: [top <= bottom]).
	successFlag ifTrue: [
		dispBitsPtr _ dispBits + BaseHeaderSize.
		self cCode: 'ioShowDisplay(dispBitsPtr, w, h, d, left, right, top, bottom)'].
	successFlag ifTrue: [self pop: 4].  "pop left, right, top, bottom; leave rcvr on stack"
! !

!DynamicInterpreter methodsFor: 'I/O primitives' stamp: 'jm 5/18/1998 13:38'!
showDisplayBits
	"Repaint the portion of the Smalltalk screen bounded by the affected rectangle. Used to synchronize the screen after a Bitblt to the Smalltalk Display object."

	| displayObj dispBits w h affectedRectL affectedRectR affectedRectT affectedRectB dispBitsIndex d |
	deferDisplayUpdates ifTrue: [^ nil].
	displayObj _ self splObj: TheDisplay.
	self targetForm = displayObj ifFalse: [^ nil].
	self success: ((self isPointers: displayObj) and: [(self lengthOf: displayObj) >= 4]).
	successFlag ifTrue: [
		dispBits _ self fetchPointer: 0 ofObject: displayObj.
		w _ self fetchInteger: 1 ofObject: displayObj.
		h _ self fetchInteger: 2 ofObject: displayObj.
		d _ self fetchInteger: 3 ofObject: displayObj.
	].
	successFlag ifTrue: [
		affectedRectL _ self affectedLeft.
		affectedRectR _ self affectedRight.
		affectedRectT _ self affectedTop.
		affectedRectB _ self affectedBottom.
		dispBitsIndex _ dispBits + BaseHeaderSize.  "index in memory byte array"
		self cCode: 'ioShowDisplay(dispBitsIndex, w, h, d, affectedRectL, affectedRectR, affectedRectT, affectedRectB)'.
	].! !

!DynamicInterpreter methodsFor: 'serial port primitives' stamp: 'jm 5/18/1998 13:27'!
primitiveSerialPortClose

	| portNum |
	portNum _ self stackIntegerValue: 0.
	successFlag ifTrue: [self serialPortClose: portNum].
	successFlag ifTrue: [self pop: 1].  "pop portNum; leave rcvr on stack"
! !

!DynamicInterpreter methodsFor: 'serial port primitives' stamp: 'jm 5/18/1998 13:28'!
primitiveSerialPortOpen

	| xOffChar xOnChar inFlowControl outFlowControl dataBits
	  parityType stopBitsType baudRate portNum |
	xOffChar		_ self stackIntegerValue: 0.
	xOnChar		_ self stackIntegerValue: 1.
	outFlowControl	_ self stackIntegerValue: 2.
	inFlowControl	_ self stackIntegerValue: 3.
	dataBits			_ self stackIntegerValue: 4.
	parityType		_ self stackIntegerValue: 5.
	stopBitsType		_ self stackIntegerValue: 6.
	baudRate		_ self stackIntegerValue: 7.
	portNum		_ self stackIntegerValue: 8.
	successFlag ifTrue: [
		self cCode: 'serialPortOpen(
			portNum, baudRate, stopBitsType, parityType, dataBits,
			inFlowControl, outFlowControl, xOnChar, xOffChar)'].
	successFlag ifTrue: [self pop: 9].  "pop 9 args; leave rcvr on stack"
! !

!DynamicInterpreter methodsFor: 'serial port primitives' stamp: 'jm 5/18/1998 13:28'!
primitiveSerialPortRead

	| count startIndex array portNum fmt bytesRead |
	count		_ self stackIntegerValue: 0.
	startIndex	_ self stackIntegerValue: 1.
	array		_ self stackValue: 2.
	portNum	_ self stackIntegerValue: 3.
	fmt _ self formatOf: array.
	self success: (fmt >= 8 and: [fmt <= 11]).  "bytes array, not CompiledMethod"
	self success: (
		(startIndex >= 1) and:
		[(startIndex + count - 1) <= (self lengthOf: array)]).
	successFlag ifTrue: [
		bytesRead _ self serialPort: portNum
			Read: count
			Into: array + BaseHeaderSize + startIndex - 1].  "adjust for zero-origin indexing"
	successFlag ifTrue: [
		self pop: 5.  "pop rcvr, portNum, array, startIndex, count"
		self pushInteger: bytesRead].
! !

!DynamicInterpreter methodsFor: 'serial port primitives' stamp: 'jm 5/18/1998 13:29'!
primitiveSerialPortWrite

	| count startIndex array portNum fmt bytesWritten |
	count		_ self stackIntegerValue: 0.
	startIndex	_ self stackIntegerValue: 1.
	array		_ self stackValue: 2.
	portNum	_ self stackIntegerValue: 3.
	fmt _ self formatOf: array.
	self success: (fmt >= 8 and: [fmt <= 11]).  "bytes array, not CompiledMethod"
	self success: (
		(startIndex >= 1) and:
		[(startIndex + count - 1) <= (self lengthOf: array)]).
	successFlag ifTrue: [
		bytesWritten _ self serialPort: portNum
			Write: count
			From: array + BaseHeaderSize + startIndex - 1].  "adjust for zero-origin indexing"
	successFlag ifTrue: [
		self pop: 5.  "pop rcvr, portNum, array, startIndex, count"
		self pushInteger: bytesWritten].
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 13:30'!
primitiveMIDIClosePort

	| portNum |
	portNum _ self stackIntegerValue: 0.
	successFlag ifTrue: [self sqMIDIClosePort: portNum].
	successFlag ifTrue: [self pop: 1].  "pop portNum; leave rcvr on stack"
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 13:30'!
primitiveMIDIGetClock
	"Return the value of the MIDI clock as a SmallInteger. The range is limited to SmallInteger maxVal / 2 to allow scheduling MIDI events into the future without overflowing a SmallInteger. The sqMIDIGetClock function is assumed to wrap at or before 16r20000000."

	| clockValue |
	clockValue _ self sqMIDIGetClock bitAnd: 16r1FFFFFFF.
	successFlag ifTrue: [
		self pop: 1.  "pop rcvr"
		self pushInteger: clockValue].
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 13:30'!
primitiveMIDIGetPortCount

	| n |
	n _ self sqMIDIGetPortCount.
	successFlag ifTrue: [
		self pop: 1.  "pop rcvr"
		self pushInteger: n].
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 13:30'!
primitiveMIDIGetPortDirectionality

	| portNum dir |
	portNum _ self stackIntegerValue: 0.
	successFlag ifTrue: [dir _ self sqMIDIGetPortDirectionality: portNum].
	successFlag ifTrue: [
		self pop: 2.  "pop rcvr, portNum"
		self pushInteger: dir].
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 13:30'!
primitiveMIDIGetPortName

	| portName portNum sz nameObj namePtr |
	self var: #portName declareC: 'char portName[256]'.
	portNum _ self stackIntegerValue: 0.
	successFlag ifTrue: [
		sz _ self cCode: 'sqMIDIGetPortName(portNum, (int) &portName, 255)'].
	successFlag ifTrue: [
		nameObj _ self instantiateClass: (self splObj: ClassString) indexableSize: sz.
		namePtr _ nameObj + BaseHeaderSize.
		self cCode: 'memcpy((char *) namePtr, portName, sz)'].
	successFlag ifTrue: [
		self pop: 2.  "pop rcvr, portNum"
		self push: nameObj].
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 13:30'!
primitiveMIDIOpenPort

	| clockRate semaIndex portNum |
	clockRate	_ self stackIntegerValue: 0.
	semaIndex	_ self stackIntegerValue: 1.
	portNum	_ self stackIntegerValue: 2.
	successFlag ifTrue: [
		self cCode: 'sqMIDIOpenPort(portNum, semaIndex, clockRate)'].
	successFlag ifTrue: [self pop: 3].  "pop portNum, semaIndex, clockRate; leave rcvr on stack"
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 13:30'!
primitiveMIDIParameterGetOrSet
	"Behaviour depends on argument count:
		1 arg:	return the indicated MIDI parameter
		2 args:	set the indicated MIDI parameter to the given value"

	| whichParameter currentValue newValue |
	argumentCount = 1 ifTrue: [  "read parameter"
		whichParameter _ self stackIntegerValue: 0.
		successFlag ifFalse: [^ nil].
		currentValue _ self cCode: 'sqMIDIParameter(whichParameter, false, 0)'.
		successFlag ifTrue: [
			self pop: 2.  "pop rcvr, whichParameter"
			self pushInteger: currentValue].
		^ nil].

	argumentCount = 2 ifTrue: [  "write parameter"
		newValue			_ self stackIntegerValue: 0.
		whichParameter		_ self stackIntegerValue: 1.
		successFlag ifFalse: [^ nil].
		self cCode: 'sqMIDIParameter(whichParameter, true, newValue)'.
		successFlag ifTrue: [
			self pop: 2].  "pop whichParameter, newValue; leave rcvr on stack"
		^ nil].

	self primitiveFail.  "bad argument count"
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 15:47'!
primitiveMIDIRead

	| array portNum fmt arrayLength bytesRead |
	array		_ self stackValue: 0.
	portNum	_ self stackIntegerValue: 1.
	fmt _ self formatOf: array.
	self success: (fmt >= 8 and: [fmt <= 11]).  "bytes array, not CompiledMethod"
	successFlag ifTrue: [
		arrayLength _ self lengthOf: array.
		bytesRead _ self sqMIDIPort: portNum
			Read: arrayLength
			Into: array + BaseHeaderSize].
	successFlag ifTrue: [
		self pop: 3.  "pop rcvr, portNum, array"
		self pushInteger: bytesRead].
! !

!DynamicInterpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 15:48'!
primitiveMIDIWrite

	| time array portNum fmt arrayLength bytesWritten |
	time		_ self stackIntegerValue: 0.
	array		_ self stackValue: 1.
	portNum	_ self stackIntegerValue: 2.
	fmt _ self formatOf: array.
	self success: (fmt >= 8 and: [fmt <= 11]).  "bytes array, not CompiledMethod"
	successFlag ifTrue: [
		arrayLength _ self lengthOf: array.
		bytesWritten _ self sqMIDIPort: portNum
			Write: arrayLength
			From: array + BaseHeaderSize
			At: time].
	successFlag ifTrue: [
		self pop: 4.  "pop rcvr, portNum, array, time"
		self pushInteger: bytesWritten].
! !

!DynamicInterpreter methodsFor: 'image save/restore' stamp: 'jm 5/18/1998 13:51'!
readImageFromFile: f HeapSize: desiredHeapSize
	"Read an image from the given file stream, allocating the given amount of memory to its object heap. Fail if the image has an unknown format or requires more than the given amount of memory."
	"Details: This method detects when the image was stored on a machine with the opposite byte ordering from this machine and swaps the bytes automatically. Furthermore, it allows the header information to start 512 bytes into the file, since some file transfer programs for the Macintosh apparently prepend a Mac-specific header of this size. Note that this same 512 bytes of prefix area could also be used to store an exec command on Unix systems, allowing one to launch Smalltalk by invoking the image name as a command."
	"This code is based on C code by Ian Piumarta and Smalltalk code by Tim Rowledge. Many thanks to both of you!!!!"

	| swapBytes headerStart headerSize dataSize oldBaseAddr minimumMemory memStart bytesRead bytesToShift actualHeapSize |
	self var: #f declareC: 'sqImageFile f'.

	swapBytes _ self checkImageVersionFrom: f.
	headerStart _ (self sqImageFilePosition: f) - 4.  "record header start position"

	headerSize			_ self getLongFromFile: f swap: swapBytes.
	dataSize				_ self getLongFromFile: f swap: swapBytes.
	oldBaseAddr			_ self getLongFromFile: f swap: swapBytes.
	specialObjectsOop	_ self getLongFromFile: f swap: swapBytes.
	lastHash			_ self getLongFromFile: f swap: swapBytes.
	savedWindowSize	_ self getLongFromFile: f swap: swapBytes.
	fullScreenFlag		_ self getLongFromFile: f swap: swapBytes.

	lastHash = 0 ifTrue: [
		"lastHash wasn't stored (e.g. by the cloner); use 999 as the seed"
		lastHash _ 999].

	"compare memory requirements with availability".
	minimumMemory _ dataSize + 80000.  "need at least 80K of breathing room"
	desiredHeapSize < minimumMemory
		ifTrue: [self error: 'Insufficient memory for this image'].

	contextCacheEntries = nil ifTrue: [contextCacheEntries _ ContextCacheEntries].
	stackCacheEntries = nil ifTrue: [stackCacheEntries _ StackCacheEntries].
	actualHeapSize _ desiredHeapSize + self cacheSize.

	"allocate a contiguous block of memory for the Squeak heap"
	memory _ self cCode: '(unsigned char *) sqAllocateMemory(minimumMemory, actualHeapSize)'.
	memory = nil
		ifTrue: [self error: 'Failed to allocate memory for the heap'].

	memStart _ self startOfMemory.
	memoryLimit _ (memStart + desiredHeapSize) - 24.  "decrease memoryLimit a tad for safety"
	endOfMemory _ memStart + dataSize.

	"position file after the header"
	self sqImageFile: f Seek: headerStart + headerSize.

	"read in the image in bulk, then swap the bytes if necessary"
	bytesRead _ self cCode: 'sqImageFileRead(memory, sizeof(unsigned char), dataSize, f)'.
	bytesRead ~= dataSize
		ifTrue: [self error: 'Read failed or premature end of image file'].
	swapBytes ifTrue: [self reverseBytesInImage].

	"compute difference between old and new memory base addresses"
	bytesToShift _ memStart - oldBaseAddr.
	self initializeCache: memStart + desiredHeapSize.
	self initializeInterpreter: bytesToShift.  "adjusts all oops to new location"
	^ dataSize
! !

!DynamicInterpreter methodsFor: 'image save/restore' stamp: 'jm 5/18/1998 13:41'!
writeImageFile: imageBytes

	| headerStart headerSize f bytesWritten |
	self var: #f declareC: 'sqImageFile f'.

	"local constants"
	headerStart _ 0.  "change to 512 to leave room for a Unix exec string"
	headerSize _ 64.  "header size in bytes; do not change!!"

	f _ self cCode: 'sqImageFileOpen(imageName, "wb")'.
	f = nil ifTrue: [
		"could not open the image file for writing"
		self success: false.
		^ nil].

	self cCode: '/* Note: on Unix systems one could put an exec command here, padded to 512 bytes */'.
	"position file to start of header"
	self sqImageFile: f Seek: headerStart.

	self putLong: (self imageFormatVersion) toFile: f.
	self putLong: headerSize toFile: f.
	self putLong: imageBytes toFile: f.
	self putLong: (self startOfMemory) toFile: f.
	self putLong: specialObjectsOop toFile: f.
	self putLong: lastHash toFile: f.
	self putLong: (self ioScreenSize) toFile: f.
	self putLong: fullScreenFlag toFile: f.
	1 to: 8 do: [:i | self putLong: 0 toFile: f].  "fill remaining header words with zeros"
	successFlag ifFalse: [
		"file write or seek failure"
		self cCode: 'sqImageFileClose(f)'.
		^ nil].

	"position file after the header"
	self sqImageFile: f Seek: headerStart + headerSize.

	"write the image data"
	bytesWritten _ self cCode: 'sqImageFileWrite(memory, sizeof(unsigned char), imageBytes, f)'.
	self success: bytesWritten = imageBytes.
	self cCode: 'sqImageFileClose(f)'.

	"set Mac file type and creator; this is a noop on other platforms"
	self cCode: 'dir_SetMacFileTypeAndCreator(imageName, strlen(imageName), "STim", "FAST")'.
! !


!DynamicInterpreterState class methodsFor: 'class initialization' stamp: 'jm 5/18/1998 13:03'!
initializePrimitiveTable
	"This table generates a C switch statement for primitive dispatching."

	"NOTE: The real limit here is 2047, but our C compiler currently barfs over 700"
	MaxPrimitiveIndex _ 700.
	PrimitiveTable _ Array new: MaxPrimitiveIndex + 1.
	self table: PrimitiveTable from: 
	#(	"Integer Primitives (0-19)"
		(0 primitiveFail)
		(1 primitiveAdd)
		(2 primitiveSubtract)
		(3 primitiveLessThan)
		(4 primitiveGreaterThan)
		(5 primitiveLessOrEqual)
		(6 primitiveGreaterOrEqual)
		(7 primitiveEqual)
		(8 primitiveNotEqual)
		(9 primitiveMultiply)
		(10 primitiveDivide)
		(11 primitiveMod)
		(12 primitiveDiv)
		(13 primitiveQuo)
		(14 primitiveBitAnd)
		(15 primitiveBitOr)
		(16 primitiveBitXor)
		(17 primitiveBitShift)
		(18 primitiveMakePoint)
		(19 primitiveFail)

		"LargeInteger Primitives (20-39)"
		"32-bit logic is aliased to Integer prims above"
		(20 39 primitiveFail)

		"Float Primitives (40-59)"
		(40 primitiveAsFloat)
		(41 primitiveFloatAdd)
		(42 primitiveFloatSubtract)
		(43 primitiveFloatLessThan)
		(44 primitiveFloatGreaterThan)
		(45 primitiveFloatLessOrEqual)
		(46 primitiveFloatGreaterOrEqual)
		(47 primitiveFloatEqual)
		(48 primitiveFloatNotEqual)
		(49 primitiveFloatMultiply)
		(50 primitiveFloatDivide)
		(51 primitiveTruncated)
		(52 primitiveFractionalPart)
		(53 primitiveExponent)
		(54 primitiveTimesTwoPower)
		(55 primitiveSquareRoot)
		(56 primitiveSine)
		(57 primitiveArctan)
		(58 primitiveLogN)
		(59 primitiveExp)

		"Subscript and Stream Primitives (60-67)"
		(60 primitiveAt)
		(61 primitiveAtPut)
		(62 primitiveSize)
		(63 primitiveStringAt)
		(64 primitiveStringAtPut)
		(65 primitiveNext)
		(66 primitiveNextPut)
		(67 primitiveAtEnd)

		"StorageManagement Primitives (68-79)"
		(68 primitiveObjectAt)
		(69 primitiveObjectAtPut)
		(70 primitiveNew)
		(71 primitiveNewWithArg)
		(72 primitiveFail)					"Blue Book: primitiveBecome"
		(73 primitiveInstVarAt)
		(74 primitiveInstVarAtPut)
		(75 primitiveAsOop)
		(76 primitiveFail)					"Blue Book: primitiveAsObject"
		(77 primitiveSomeInstance)
		(78 primitiveNextInstance)
		(79 primitiveNewMethod)

		"Control Primitives (80-89)"
		(80 primitiveFail)   					"Blue Book:  primitiveBlockCopy"
		(81 primitiveValue)
		(82 primitiveValueWithArgs)
		(83 primitivePerform)
		(84 primitivePerformWithArgs)
		(85 primitiveSignal)
		(86 primitiveWait)
		(87 primitiveResume)
		(88 primitiveSuspend)
		(89 primitiveFlushCache)

		"Input/Output Primitives (90-109)"
		(90 primitiveMousePoint)
		(91 primitiveFail)					"Blue Book: primitiveCursorLocPut"
		(92 primitiveFail)					"Blue Book: primitiveCursorLink"
		(93 primitiveInputSemaphore)
		(94 primitiveFail)					"Blue Book: primitiveSampleInterval"
		(95 primitiveInputWord)
		(96 primitiveCopyBits)
		(97 primitiveSnapshot)
		(98 primitiveFail)					"Blue Book: primitiveTimeWordsInto"
		(99 primitiveFail)					"Blue Book: primitiveTickWordsInto"
		(100 primitiveFail)					"Blue Book: primitiveSignalAtTick"
		(101 primitiveBeCursor)
		(102 primitiveBeDisplay)
		(103 primitiveScanCharacters)
		(104 primitiveDrawLoop)
		(105 primitiveStringReplace)
		(106 primitiveScreenSize)
		(107 primitiveMouseButtons)
		(108 primitiveKbdNext)
		(109 primitiveKbdPeek)

		"System Primitives (110-119)"
		(110 primitiveEquivalent)
		(111 primitiveClass)
		(112 primitiveBytesLeft)
		(113 primitiveQuit)
		(114 primitiveExitToDebugger)
		(115 primitiveFail)					"Blue Book: primitiveOopsLeft"
		(116 primitiveFail)
		(117 primitiveFail)
		(118 primitiveDoPrimitiveWithArgs)
		(119 primitiveFlushCacheSelective)

		"Miscellaneous Primitives (120-127)"
		(120 primitiveFail)
		(121 primitiveImageName)
		(122 primitiveNoop)					"Blue Book: primitiveImageVolume"
		(123 primitiveFail)
		(124 primitiveLowSpaceSemaphore)
		(125 primitiveSignalAtBytesLeft)

		"Squeak Primitives Start Here"

		"Squeak Miscellaneous Primitives (128-149)"
		(126 primitiveDeferDisplayUpdates)
		(127 primitiveShowDisplayRect)
		(128 primitiveArrayBecome)
		(129 primitiveSpecialObjectsOop)
		(130 primitiveFullGC)
		(131 primitiveIncrementalGC)
		(132 primitiveObjectPointsTo)
		(133 primitiveSetInterruptKey)
		(134 primitiveInterruptSemaphore)
		(135 primitiveMillisecondClock)
		(136 primitiveSignalAtMilliseconds)
		(137 primitiveSecondsClock)
		(138 primitiveSomeObject)
		(139 primitiveNextObject)
		(140 primitiveBeep)
		(141 primitiveClipboardText)
		(142 primitiveVMPath)
		(143 primitiveShortAt)
		(144 primitiveShortAtPut)
		(145 primitiveConstantFill)
		(146 primitiveReadJoystick)
		(147 primitiveWarpBits)
		(148 primitiveClone)
		(149 primitiveGetAttribute)

		"File Primitives (150-169)"
		(150 primitiveFileAtEnd)
		(151 primitiveFileClose)
		(152 primitiveFileGetPosition)
		(153 primitiveFileOpen)
		(154 primitiveFileRead)
		(155 primitiveFileSetPosition)
		(156 primitiveFileDelete)
		(157 primitiveFileSize)
		(158 primitiveFileWrite)
		(159 primitiveFileRename)
		(160 primitiveDirectoryCreate)
		(161 primitiveDirectoryDelimitor)
		(162 primitiveDirectoryLookup)
		(163 168 primitiveFail)
		(169 primitiveDirectorySetMacTypeAndCreator)

		"Sound Primitives (170-199)"
		(170 primitiveSoundStart)
		(171 primitiveSoundStartWithSemaphore)
		(172 primitiveSoundStop)
		(173 primitiveSoundAvailableSpace)
		(174 primitiveSoundPlaySamples)
		(175 primitiveSoundPlaySilence)		"obsolete; will be removed in the future"
		(176 primWaveTableSoundmixSampleCountintostartingAtpan)
		(177 primFMSoundmixSampleCountintostartingAtpan)
		(178 primPluckedSoundmixSampleCountintostartingAtpan)
		(179 primSampledSoundmixSampleCountintostartingAtpan)
		(180 primFMSoundmixSampleCountintostartingAtleftVolrightVol)
		(181 primPluckedSoundmixSampleCountintostartingAtleftVolrightVol)
		(182 primSampledSoundmixSampleCountintostartingAtleftVolrightVol)
		(183 primReverbSoundapplyReverbTostartingAtcount)
		(184 188 primitiveFail)
		(189 primitiveSoundInsertSamples)
		(190 primitiveSoundStartRecording)
		(191 primitiveSoundStopRecording)
		(192 primitiveSoundGetRecordingSampleRate)
		(193 primitiveSoundRecordSamples)
		(194 primitiveSoundSetRecordLevel)
		(195 199 primitiveFail)

		"Networking Primitives (200-229)"
		(200 primitiveInitializeNetwork)
		(201 primitiveResolverStartNameLookup)
		(202 primitiveResolverNameLookupResult)
		(203 primitiveResolverStartAddressLookup)
		(204 primitiveResolverAddressLookupResult)
		(205 primitiveResolverAbortLookup)
		(206 primitiveResolverLocalAddress)
		(207 primitiveResolverStatus)
		(208 primitiveResolverError)
		(209 primitiveSocketCreate)
		(210 primitiveSocketDestroy)
		(211 primitiveSocketConnectionStatus)
		(212 primitiveSocketError)
		(213 primitiveSocketLocalAddress)
		(214 primitiveSocketLocalPort)
		(215 primitiveSocketRemoteAddress)
		(216 primitiveSocketRemotePort)
		(217 primitiveSocketConnectToPort)
		(218 primitiveSocketListenOnPort)
		(219 primitiveSocketCloseConnection)
		(220 primitiveSocketAbortConnection)
		(221 primitiveSocketReceiveDataBufCount)
		(222 primitiveSocketReceiveDataAvailable)
		(223 primitiveSocketSendDataBufCount)
		(224 primitiveSocketSendDone)
		(225 229 primitiveFail)

		"Other Primitives (230-249)"
		(230 primitiveRelinquishProcessor)
		(231 primitiveForceDisplayUpdate)
		(232 primitiveFormPrint)
		(233 primitiveSetFullScreen)
		(234 primBitmapdecompressfromByteArrayat)
		(235 primStringcomparewithcollated)
		(236 primSampledSoundconvert8bitSignedFromto16Bit)
		(237 primBitmapcompresstoByteArray)
		(238 primitiveSerialPortOpen)
		(239 primitiveSerialPortClose)
		(240 primitiveSerialPortWrite)
		(241 primitiveSerialPortRead)
		(242 249 primitiveFail)

		"VM Implementor Primitives (250-255)"
		(250 clearProfile)
		(251 dumpProfile)
		(252 startProfiling)
		(253 stopProfiling)
		(254 primitiveVMParameter)
		(255 primitiveFail)

		"Quick Push Const Methods"
		(256 primitivePushSelf)
		(257 primitivePushTrue)
		(258 primitivePushFalse)
		(259 primitivePushNil)
		(260 primitivePushMinusOne)
		(261 primitivePushZero)
		(262 primitivePushOne)
		(263 primitivePushTwo)

		"Quick Push Const Methods"
		(264 519 primitiveLoadInstVar)

		"MIDI Primitives (520-539)"
		(520 primitiveFail)
		(521 primitiveMIDIClosePort)
		(522 primitiveMIDIGetClock)
		(523 primitiveMIDIGetPortCount)
		(524 primitiveMIDIGetPortDirectionality)
		(525 primitiveMIDIGetPortName)
		(526 primitiveMIDIOpenPort)
		(527 primitiveMIDIParameterGetOrSet)
		(528 primitiveMIDIRead)
		(529 primitiveMIDIWrite)
		(530 539 primitiveFail)  "reserved for extended MIDI primitives"

		"Unassigned Primitives"
		(540 700 primitiveFail)).
! !


!Interpreter methodsFor: 'initialization' stamp: 'jm 5/17/1998 06:49'!
initializeInterpreter: bytesToShift
	"Initialize Interpreter state before starting execution of a new image."

	self initializeObjectMemory: bytesToShift.
	self initBBOpTable.

	activeContext	_ nilObj.
	theHomeContext	_ nilObj.
	method			_ nilObj.
	receiver		_ nilObj.
	messageSelector	_ nilObj.
	newMethod		_ nilObj.

	self flushMethodCache.
	self loadInitialContext.
	interruptCheckCounter _ 0.
	nextPollTick _ 0.
	nextWakeupTick _ 0.
	lastTick _ 0.
	interruptKeycode _ 2094.  "cmd-."
	interruptPending _ false.
	semaphoresToSignalCount _ 0.
	deferDisplayUpdates _ false.
! !

!Interpreter methodsFor: 'I/O primitives' stamp: 'jm 5/17/1998 20:08'!
primitiveDeferDisplayUpdates
	"Set or clear the flag that controls whether modifications of the Display object are propagated to the underlying platform's screen."

	| flag |
	flag _ self stackTop.
	flag = trueObj
		ifTrue: [deferDisplayUpdates _ true]
		ifFalse: [
			flag = falseObj
				ifTrue: [deferDisplayUpdates _ false]
				ifFalse: [self primitiveFail]].
	successFlag ifTrue: [self pop: 1].  "pop flag; leave rcvr on stack"
! !

!Interpreter methodsFor: 'I/O primitives' stamp: 'jm 5/17/1998 07:06'!
primitiveForceDisplayUpdate
	"On some platforms, this primitive forces enqueued display updates to be processed immediately. On others, it does nothing."

	self ioForceDisplayUpdate.
! !

!Interpreter methodsFor: 'I/O primitives' stamp: 'jm 5/17/1998 07:08'!
primitiveSetFullScreen
	"On platforms that support it, set full-screen mode to the value of the boolean argument."

	| argOop |
	argOop _ self stackTop.
	argOop = trueObj
		ifTrue: [self ioSetFullScreen: true]
		ifFalse: [
			argOop = falseObj
				ifTrue: [self ioSetFullScreen: false]
				ifFalse: [self primitiveFail]].
	successFlag ifTrue: [self pop: 1].
! !

!Interpreter methodsFor: 'I/O primitives' stamp: 'jm 5/17/1998 20:09'!
primitiveShowDisplayRect
	"Force the given rectangular section of the Display to be copied to the screen."

	| bottom top right left displayObj dispBits w h d dispBitsPtr |
	bottom	_ self stackIntegerValue: 0.
	top		_ self stackIntegerValue: 1.
	right	_ self stackIntegerValue: 2.
	left		_ self stackIntegerValue: 3.
	displayObj _ self splObj: TheDisplay.
	self success: ((self isPointers: displayObj) and: [(self lengthOf: displayObj) >= 4]).
	successFlag ifTrue: [
		dispBits _ self fetchPointer: 0 ofObject: displayObj.
		w _ self fetchInteger: 1 ofObject: displayObj.
		h _ self fetchInteger: 2 ofObject: displayObj.
		d _ self fetchInteger: 3 ofObject: displayObj].
	left < 0 ifTrue: [left _ 0].
	right > w ifTrue: [right _ w].
	top < 0 ifTrue: [top _ 0].
	bottom > h ifTrue: [bottom _ h].
	self success: ((left <= right) and: [top <= bottom]).
	successFlag ifTrue: [
		dispBitsPtr _ dispBits + BaseHeaderSize.
		self cCode: 'ioShowDisplay(dispBitsPtr, w, h, d, left, right, top, bottom)'].
	successFlag ifTrue: [self pop: 4].  "pop left, right, top, bottom; leave rcvr on stack"
! !

!Interpreter methodsFor: 'I/O primitives' stamp: 'jm 5/16/1998 22:58'!
showDisplayBits
	"Repaint the portion of the Smalltalk screen bounded by the affected rectangle. Used to synchronize the screen after a Bitblt to the Smalltalk Display object."

	| displayObj dispBits w h affectedRectL affectedRectR affectedRectT affectedRectB dispBitsIndex d |
	deferDisplayUpdates ifTrue: [^ nil].
	displayObj _ self splObj: TheDisplay.
	self targetForm = displayObj ifFalse: [^ nil].
	self success: ((self isPointers: displayObj) and: [(self lengthOf: displayObj) >= 4]).
	successFlag ifTrue: [
		dispBits _ self fetchPointer: 0 ofObject: displayObj.
		w _ self fetchInteger: 1 ofObject: displayObj.
		h _ self fetchInteger: 2 ofObject: displayObj.
		d _ self fetchInteger: 3 ofObject: displayObj.
	].
	successFlag ifTrue: [
		affectedRectL _ self affectedLeft.
		affectedRectR _ self affectedRight.
		affectedRectT _ self affectedTop.
		affectedRectB _ self affectedBottom.
		dispBitsIndex _ dispBits + BaseHeaderSize.  "index in memory byte array"
		self cCode: 'ioShowDisplay(dispBitsIndex, w, h, d, affectedRectL, affectedRectR, affectedRectT, affectedRectB)'.
	].! !

!Interpreter methodsFor: 'image save/restore' stamp: 'jm 5/17/1998 07:24'!
readImageFromFile: f HeapSize: desiredHeapSize
	"Read an image from the given file stream, allocating the given amount of memory to its object heap. Fail if the image has an unknown format or requires more than the given amount of memory."
	"Details: This method detects when the image was stored on a machine with the opposite byte ordering from this machine and swaps the bytes automatically. Furthermore, it allows the header information to start 512 bytes into the file, since some file transfer programs for the Macintosh apparently prepend a Mac-specific header of this size. Note that this same 512 bytes of prefix area could also be used to store an exec command on Unix systems, allowing one to launch Smalltalk by invoking the image name as a command."
	"This code is based on C code by Ian Piumarta and Smalltalk code by Tim Rowledge. Many thanks to both of you!!!!"

	| swapBytes headerStart headerSize dataSize oldBaseAddr minimumMemory memStart bytesRead bytesToShift |
	self var: #f declareC: 'sqImageFile f'.

	swapBytes _ self checkImageVersionFrom: f.
	headerStart _ (self sqImageFilePosition: f) - 4.  "record header start position"

	headerSize			_ self getLongFromFile: f swap: swapBytes.
	dataSize				_ self getLongFromFile: f swap: swapBytes.
	oldBaseAddr			_ self getLongFromFile: f swap: swapBytes.
	specialObjectsOop	_ self getLongFromFile: f swap: swapBytes.
	lastHash			_ self getLongFromFile: f swap: swapBytes.
	savedWindowSize	_ self getLongFromFile: f swap: swapBytes.
	fullScreenFlag		_ self getLongFromFile: f swap: swapBytes.

	lastHash = 0 ifTrue: [
		"lastHash wasn't stored (e.g. by the cloner); use 999 as the seed"
		lastHash _ 999].

	"compare memory requirements with availability".
	minimumMemory _ dataSize + 80000.  "need at least 80K of breathing room"
	desiredHeapSize < minimumMemory
		ifTrue: [self error: 'Insufficient memory for this image'].

	"allocate a contiguous block of memory for the Squeak heap"
	memory _ self cCode: '(unsigned char *) sqAllocateMemory(minimumMemory, desiredHeapSize)'.
	memory = nil
		ifTrue: [self error: 'Failed to allocate memory for the heap'].

	memStart _ self startOfMemory.
	memoryLimit _ (memStart + desiredHeapSize) - 24.  "decrease memoryLimit a tad for safety"
	endOfMemory _ memStart + dataSize.

	"position file after the header"
	self sqImageFile: f Seek: headerStart + headerSize.

	"read in the image in bulk, then swap the bytes if necessary"
	bytesRead _ self cCode: 'sqImageFileRead(memory, sizeof(unsigned char), dataSize, f)'.
	bytesRead ~= dataSize
		ifTrue: [self error: 'Read failed or premature end of image file'].
	swapBytes ifTrue: [self reverseBytesInImage].

	"compute difference between old and new memory base addresses"
	bytesToShift _ memStart - oldBaseAddr.
	self initializeInterpreter: bytesToShift.  "adjusts all oops to new location"
	^ dataSize
! !

!Interpreter methodsFor: 'image save/restore' stamp: 'jm 5/17/1998 07:22'!
writeImageFile: imageBytes

	| headerStart headerSize f bytesWritten |
	self var: #f declareC: 'sqImageFile f'.

	"local constants"
	headerStart _ 0.  "change to 512 to leave room for a Unix exec string"
	headerSize _ 64.  "header size in bytes; do not change!!"

	f _ self cCode: 'sqImageFileOpen(imageName, "wb")'.
	f = nil ifTrue: [
		"could not open the image file for writing"
		self success: false.
		^ nil].

	self cCode: '/* Note: on Unix systems one could put an exec command here, padded to 512 bytes */'.
	"position file to start of header"
	self sqImageFile: f Seek: headerStart.

	self putLong: (self imageFormatVersion) toFile: f.
	self putLong: headerSize toFile: f.
	self putLong: imageBytes toFile: f.
	self putLong: (self startOfMemory) toFile: f.
	self putLong: specialObjectsOop toFile: f.
	self putLong: lastHash toFile: f.
	self putLong: (self ioScreenSize) toFile: f.
	self putLong: fullScreenFlag toFile: f.
	1 to: 8 do: [:i | self putLong: 0 toFile: f].  "fill remaining header words with zeros"
	successFlag ifFalse: [
		"file write or seek failure"
		self cCode: 'sqImageFileClose(f)'.
		^ nil].

	"position file after the header"
	self sqImageFile: f Seek: headerStart + headerSize.

	"write the image data"
	bytesWritten _ self cCode: 'sqImageFileWrite(memory, sizeof(unsigned char), imageBytes, f)'.
	self success: bytesWritten = imageBytes.
	self cCode: 'sqImageFileClose(f)'.

	"set Mac file type and creator; this is a noop on other platforms"
	self cCode: 'dir_SetMacFileTypeAndCreator(imageName, strlen(imageName), "STim", "FAST")'.
! !

!Interpreter methodsFor: 'serial port primitives' stamp: 'jm 5/17/1998 19:41'!
primitiveSerialPortClose

	| portNum |
	portNum _ self stackIntegerValue: 0.
	successFlag ifTrue: [self serialPortClose: portNum].
	successFlag ifTrue: [self pop: 1].  "pop portNum; leave rcvr on stack"
! !

!Interpreter methodsFor: 'serial port primitives' stamp: 'jm 5/17/1998 19:43'!
primitiveSerialPortOpen

	| xOffChar xOnChar inFlowControl outFlowControl dataBits
	  parityType stopBitsType baudRate portNum |
	xOffChar		_ self stackIntegerValue: 0.
	xOnChar		_ self stackIntegerValue: 1.
	outFlowControl	_ self stackIntegerValue: 2.
	inFlowControl	_ self stackIntegerValue: 3.
	dataBits			_ self stackIntegerValue: 4.
	parityType		_ self stackIntegerValue: 5.
	stopBitsType		_ self stackIntegerValue: 6.
	baudRate		_ self stackIntegerValue: 7.
	portNum		_ self stackIntegerValue: 8.
	successFlag ifTrue: [
		self cCode: 'serialPortOpen(
			portNum, baudRate, stopBitsType, parityType, dataBits,
			inFlowControl, outFlowControl, xOnChar, xOffChar)'].
	successFlag ifTrue: [self pop: 9].  "pop 9 args; leave rcvr on stack"
! !

!Interpreter methodsFor: 'serial port primitives' stamp: 'jm 5/17/1998 19:44'!
primitiveSerialPortRead

	| count startIndex array portNum fmt bytesRead |
	count		_ self stackIntegerValue: 0.
	startIndex	_ self stackIntegerValue: 1.
	array		_ self stackValue: 2.
	portNum	_ self stackIntegerValue: 3.
	fmt _ self formatOf: array.
	self success: (fmt >= 8 and: [fmt <= 11]).  "bytes array, not CompiledMethod"
	self success: (
		(startIndex >= 1) and:
		[(startIndex + count - 1) <= (self lengthOf: array)]).
	successFlag ifTrue: [
		bytesRead _ self serialPort: portNum
			Read: count
			Into: array + BaseHeaderSize + startIndex - 1].  "adjust for zero-origin indexing"
	successFlag ifTrue: [
		self pop: 5.  "pop rcvr, portNum, array, startIndex, count"
		self pushInteger: bytesRead].
! !

!Interpreter methodsFor: 'serial port primitives' stamp: 'jm 5/17/1998 19:45'!
primitiveSerialPortWrite

	| count startIndex array portNum fmt bytesWritten |
	count		_ self stackIntegerValue: 0.
	startIndex	_ self stackIntegerValue: 1.
	array		_ self stackValue: 2.
	portNum	_ self stackIntegerValue: 3.
	fmt _ self formatOf: array.
	self success: (fmt >= 8 and: [fmt <= 11]).  "bytes array, not CompiledMethod"
	self success: (
		(startIndex >= 1) and:
		[(startIndex + count - 1) <= (self lengthOf: array)]).
	successFlag ifTrue: [
		bytesWritten _ self serialPort: portNum
			Write: count
			From: array + BaseHeaderSize + startIndex - 1].  "adjust for zero-origin indexing"
	successFlag ifTrue: [
		self pop: 5.  "pop rcvr, portNum, array, startIndex, count"
		self pushInteger: bytesWritten].
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/17/1998 21:38'!
primitiveMIDIClosePort

	| portNum |
	portNum _ self stackIntegerValue: 0.
	successFlag ifTrue: [self sqMIDIClosePort: portNum].
	successFlag ifTrue: [self pop: 1].  "pop portNum; leave rcvr on stack"
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/17/1998 20:10'!
primitiveMIDIGetClock
	"Return the value of the MIDI clock as a SmallInteger. The range is limited to SmallInteger maxVal / 2 to allow scheduling MIDI events into the future without overflowing a SmallInteger. The sqMIDIGetClock function is assumed to wrap at or before 16r20000000."

	| clockValue |
	clockValue _ self sqMIDIGetClock bitAnd: 16r1FFFFFFF.
	successFlag ifTrue: [
		self pop: 1.  "pop rcvr"
		self pushInteger: clockValue].
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/17/1998 20:11'!
primitiveMIDIGetPortCount

	| n |
	n _ self sqMIDIGetPortCount.
	successFlag ifTrue: [
		self pop: 1.  "pop rcvr"
		self pushInteger: n].
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/17/1998 20:11'!
primitiveMIDIGetPortDirectionality

	| portNum dir |
	portNum _ self stackIntegerValue: 0.
	successFlag ifTrue: [dir _ self sqMIDIGetPortDirectionality: portNum].
	successFlag ifTrue: [
		self pop: 2.  "pop rcvr, portNum"
		self pushInteger: dir].
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/17/1998 20:13'!
primitiveMIDIGetPortName

	| portName portNum sz nameObj namePtr |
	self var: #portName declareC: 'char portName[256]'.
	portNum _ self stackIntegerValue: 0.
	successFlag ifTrue: [
		sz _ self cCode: 'sqMIDIGetPortName(portNum, (int) &portName, 255)'].
	successFlag ifTrue: [
		nameObj _ self instantiateClass: (self splObj: ClassString) indexableSize: sz.
		namePtr _ nameObj + BaseHeaderSize.
		self cCode: 'memcpy((char *) namePtr, portName, sz)'].
	successFlag ifTrue: [
		self pop: 2.  "pop rcvr, portNum"
		self push: nameObj].
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/17/1998 21:39'!
primitiveMIDIOpenPort

	| clockRate semaIndex portNum |
	clockRate	_ self stackIntegerValue: 0.
	semaIndex	_ self stackIntegerValue: 1.
	portNum	_ self stackIntegerValue: 2.
	successFlag ifTrue: [
		self cCode: 'sqMIDIOpenPort(portNum, semaIndex, clockRate)'].
	successFlag ifTrue: [self pop: 3].  "pop portNum, semaIndex, clockRate; leave rcvr on stack"
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/17/1998 21:40'!
primitiveMIDIParameterGetOrSet
	"Behaviour depends on argument count:
		1 arg:	return the indicated MIDI parameter
		2 args:	set the indicated MIDI parameter to the given value"

	| whichParameter currentValue newValue |
	argumentCount = 1 ifTrue: [  "read parameter"
		whichParameter _ self stackIntegerValue: 0.
		successFlag ifFalse: [^ nil].
		currentValue _ self cCode: 'sqMIDIParameter(whichParameter, false, 0)'.
		successFlag ifTrue: [
			self pop: 2.  "pop rcvr, whichParameter"
			self pushInteger: currentValue].
		^ nil].

	argumentCount = 2 ifTrue: [  "write parameter"
		newValue			_ self stackIntegerValue: 0.
		whichParameter		_ self stackIntegerValue: 1.
		successFlag ifFalse: [^ nil].
		self cCode: 'sqMIDIParameter(whichParameter, true, newValue)'.
		successFlag ifTrue: [
			self pop: 2].  "pop whichParameter, newValue; leave rcvr on stack"
		^ nil].

	self primitiveFail.  "bad argument count"
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 15:47'!
primitiveMIDIRead

	| array portNum fmt arrayLength bytesRead |
	array		_ self stackValue: 0.
	portNum	_ self stackIntegerValue: 1.
	fmt _ self formatOf: array.
	self success: (fmt >= 8 and: [fmt <= 11]).  "bytes array, not CompiledMethod"
	successFlag ifTrue: [
		arrayLength _ self lengthOf: array.
		bytesRead _ self sqMIDIPort: portNum
			Read: arrayLength
			Into: array + BaseHeaderSize].
	successFlag ifTrue: [
		self pop: 3.  "pop rcvr, portNum, array"
		self pushInteger: bytesRead].
! !

!Interpreter methodsFor: 'midi primitives' stamp: 'jm 5/18/1998 15:48'!
primitiveMIDIWrite

	| time array portNum fmt arrayLength bytesWritten |
	time		_ self stackIntegerValue: 0.
	array		_ self stackValue: 1.
	portNum	_ self stackIntegerValue: 2.
	fmt _ self formatOf: array.
	self success: (fmt >= 8 and: [fmt <= 11]).  "bytes array, not CompiledMethod"
	successFlag ifTrue: [
		arrayLength _ self lengthOf: array.
		bytesWritten _ self sqMIDIPort: portNum
			Write: arrayLength
			From: array + BaseHeaderSize
			At: time].
	successFlag ifTrue: [
		self pop: 4.  "pop rcvr, portNum, array, time"
		self pushInteger: bytesWritten].
! !


!Interpreter class methodsFor: 'initialization' stamp: 'jm 5/18/1998 13:01'!
initializePrimitiveTable
	"This table generates a C switch statement for primitive dispatching."

	"NOTE: The real limit here is 2047, but our C compiler currently barfs over 700"
	MaxPrimitiveIndex _ 700.
	PrimitiveTable _ Array new: MaxPrimitiveIndex + 1.
	self table: PrimitiveTable from: 
	#(	"Integer Primitives (0-19)"
		(0 primitiveFail)
		(1 primitiveAdd)
		(2 primitiveSubtract)
		(3 primitiveLessThan)
		(4 primitiveGreaterThan)
		(5 primitiveLessOrEqual)
		(6 primitiveGreaterOrEqual)
		(7 primitiveEqual)
		(8 primitiveNotEqual)
		(9 primitiveMultiply)
		(10 primitiveDivide)
		(11 primitiveMod)
		(12 primitiveDiv)
		(13 primitiveQuo)
		(14 primitiveBitAnd)
		(15 primitiveBitOr)
		(16 primitiveBitXor)
		(17 primitiveBitShift)
		(18 primitiveMakePoint)
		(19 primitiveFail)

		"LargeInteger Primitives (20-39)"
		"32-bit logic is aliased to Integer prims above"
		(20 39 primitiveFail)

		"Float Primitives (40-59)"
		(40 primitiveAsFloat)
		(41 primitiveFloatAdd)
		(42 primitiveFloatSubtract)
		(43 primitiveFloatLessThan)
		(44 primitiveFloatGreaterThan)
		(45 primitiveFloatLessOrEqual)
		(46 primitiveFloatGreaterOrEqual)
		(47 primitiveFloatEqual)
		(48 primitiveFloatNotEqual)
		(49 primitiveFloatMultiply)
		(50 primitiveFloatDivide)
		(51 primitiveTruncated)
		(52 primitiveFractionalPart)
		(53 primitiveExponent)
		(54 primitiveTimesTwoPower)
		(55 primitiveSquareRoot)
		(56 primitiveSine)
		(57 primitiveArctan)
		(58 primitiveLogN)
		(59 primitiveExp)

		"Subscript and Stream Primitives (60-67)"
		(60 primitiveAt)
		(61 primitiveAtPut)
		(62 primitiveSize)
		(63 primitiveStringAt)
		(64 primitiveStringAtPut)
		(65 primitiveNext)
		(66 primitiveNextPut)
		(67 primitiveAtEnd)

		"StorageManagement Primitives (68-79)"
		(68 primitiveObjectAt)
		(69 primitiveObjectAtPut)
		(70 primitiveNew)
		(71 primitiveNewWithArg)
		(72 primitiveFail)					"Blue Book: primitiveBecome"
		(73 primitiveInstVarAt)
		(74 primitiveInstVarAtPut)
		(75 primitiveAsOop)
		(76 primitiveFail)					"Blue Book: primitiveAsObject"
		(77 primitiveSomeInstance)
		(78 primitiveNextInstance)
		(79 primitiveNewMethod)

		"Control Primitives (80-89)"
		(80 primitiveFail)   					"Blue Book:  primitiveBlockCopy"
		(81 primitiveValue)
		(82 primitiveValueWithArgs)
		(83 primitivePerform)
		(84 primitivePerformWithArgs)
		(85 primitiveSignal)
		(86 primitiveWait)
		(87 primitiveResume)
		(88 primitiveSuspend)
		(89 primitiveFlushCache)

		"Input/Output Primitives (90-109)"
		(90 primitiveMousePoint)
		(91 primitiveFail)					"Blue Book: primitiveCursorLocPut"
		(92 primitiveFail)					"Blue Book: primitiveCursorLink"
		(93 primitiveInputSemaphore)
		(94 primitiveFail)					"Blue Book: primitiveSampleInterval"
		(95 primitiveInputWord)
		(96 primitiveCopyBits)
		(97 primitiveSnapshot)
		(98 primitiveFail)					"Blue Book: primitiveTimeWordsInto"
		(99 primitiveFail)					"Blue Book: primitiveTickWordsInto"
		(100 primitiveFail)					"Blue Book: primitiveSignalAtTick"
		(101 primitiveBeCursor)
		(102 primitiveBeDisplay)
		(103 primitiveScanCharacters)
		(104 primitiveDrawLoop)
		(105 primitiveStringReplace)
		(106 primitiveScreenSize)
		(107 primitiveMouseButtons)
		(108 primitiveKbdNext)
		(109 primitiveKbdPeek)

		"System Primitives (110-119)"
		(110 primitiveEquivalent)
		(111 primitiveClass)
		(112 primitiveBytesLeft)
		(113 primitiveQuit)
		(114 primitiveExitToDebugger)
		(115 primitiveFail)					"Blue Book: primitiveOopsLeft"
		(116 primitiveFail)
		(117 primitiveFail)
		(118 primitiveDoPrimitiveWithArgs)
		(119 primitiveFlushCacheSelective)

		"Miscellaneous Primitives (120-127)"
		(120 primitiveFail)
		(121 primitiveImageName)
		(122 primitiveNoop)					"Blue Book: primitiveImageVolume"
		(123 primitiveFail)
		(124 primitiveLowSpaceSemaphore)
		(125 primitiveSignalAtBytesLeft)

		"Squeak Primitives Start Here"

		"Squeak Miscellaneous Primitives (128-149)"
		(126 primitiveDeferDisplayUpdates)
		(127 primitiveShowDisplayRect)
		(128 primitiveArrayBecome)
		(129 primitiveSpecialObjectsOop)
		(130 primitiveFullGC)
		(131 primitiveIncrementalGC)
		(132 primitiveObjectPointsTo)
		(133 primitiveSetInterruptKey)
		(134 primitiveInterruptSemaphore)
		(135 primitiveMillisecondClock)
		(136 primitiveSignalAtMilliseconds)
		(137 primitiveSecondsClock)
		(138 primitiveSomeObject)
		(139 primitiveNextObject)
		(140 primitiveBeep)
		(141 primitiveClipboardText)
		(142 primitiveVMPath)
		(143 primitiveShortAt)
		(144 primitiveShortAtPut)
		(145 primitiveConstantFill)
		(146 primitiveReadJoystick)
		(147 primitiveWarpBits)
		(148 primitiveClone)
		(149 primitiveGetAttribute)

		"File Primitives (150-169)"
		(150 primitiveFileAtEnd)
		(151 primitiveFileClose)
		(152 primitiveFileGetPosition)
		(153 primitiveFileOpen)
		(154 primitiveFileRead)
		(155 primitiveFileSetPosition)
		(156 primitiveFileDelete)
		(157 primitiveFileSize)
		(158 primitiveFileWrite)
		(159 primitiveFileRename)
		(160 primitiveDirectoryCreate)
		(161 primitiveDirectoryDelimitor)
		(162 primitiveDirectoryLookup)
		(163 168 primitiveFail)
		(169 primitiveDirectorySetMacTypeAndCreator)

		"Sound Primitives (170-199)"
		(170 primitiveSoundStart)
		(171 primitiveSoundStartWithSemaphore)
		(172 primitiveSoundStop)
		(173 primitiveSoundAvailableSpace)
		(174 primitiveSoundPlaySamples)
		(175 primitiveSoundPlaySilence)		"obsolete; will be removed in the future"
		(176 primWaveTableSoundmixSampleCountintostartingAtpan)
		(177 primFMSoundmixSampleCountintostartingAtpan)
		(178 primPluckedSoundmixSampleCountintostartingAtpan)
		(179 primSampledSoundmixSampleCountintostartingAtpan)
		(180 primFMSoundmixSampleCountintostartingAtleftVolrightVol)
		(181 primPluckedSoundmixSampleCountintostartingAtleftVolrightVol)
		(182 primSampledSoundmixSampleCountintostartingAtleftVolrightVol)
		(183 primReverbSoundapplyReverbTostartingAtcount)
		(184 188 primitiveFail)
		(189 primitiveSoundInsertSamples)
		(190 primitiveSoundStartRecording)
		(191 primitiveSoundStopRecording)
		(192 primitiveSoundGetRecordingSampleRate)
		(193 primitiveSoundRecordSamples)
		(194 primitiveSoundSetRecordLevel)
		(195 199 primitiveFail)

		"Networking Primitives (200-229)"
		(200 primitiveInitializeNetwork)
		(201 primitiveResolverStartNameLookup)
		(202 primitiveResolverNameLookupResult)
		(203 primitiveResolverStartAddressLookup)
		(204 primitiveResolverAddressLookupResult)
		(205 primitiveResolverAbortLookup)
		(206 primitiveResolverLocalAddress)
		(207 primitiveResolverStatus)
		(208 primitiveResolverError)
		(209 primitiveSocketCreate)
		(210 primitiveSocketDestroy)
		(211 primitiveSocketConnectionStatus)
		(212 primitiveSocketError)
		(213 primitiveSocketLocalAddress)
		(214 primitiveSocketLocalPort)
		(215 primitiveSocketRemoteAddress)
		(216 primitiveSocketRemotePort)
		(217 primitiveSocketConnectToPort)
		(218 primitiveSocketListenOnPort)
		(219 primitiveSocketCloseConnection)
		(220 primitiveSocketAbortConnection)
		(221 primitiveSocketReceiveDataBufCount)
		(222 primitiveSocketReceiveDataAvailable)
		(223 primitiveSocketSendDataBufCount)
		(224 primitiveSocketSendDone)
		(225 229 primitiveFail)

		"Other Primitives (230-249)"
		(230 primitiveRelinquishProcessor)
		(231 primitiveForceDisplayUpdate)
		(232 primitiveFormPrint)
		(233 primitiveSetFullScreen)
		(234 primBitmapdecompressfromByteArrayat)
		(235 primStringcomparewithcollated)
		(236 primSampledSoundconvert8bitSignedFromto16Bit)
		(237 primBitmapcompresstoByteArray)
		(238 primitiveSerialPortOpen)
		(239 primitiveSerialPortClose)
		(240 primitiveSerialPortWrite)
		(241 primitiveSerialPortRead)
		(242 249 primitiveFail)

		"VM Implementor Primitives (250-255)"
		(250 clearProfile)
		(251 dumpProfile)
		(252 startProfiling)
		(253 stopProfiling)
		(254 primitiveVMParameter)
		(255 primitiveFail)

		"Quick Push Const Methods"
		(256 primitivePushSelf)
		(257 primitivePushTrue)
		(258 primitivePushFalse)
		(259 primitivePushNil)
		(260 primitivePushMinusOne)
		(261 primitivePushZero)
		(262 primitivePushOne)
		(263 primitivePushTwo)

		"Quick Push Const Methods"
		(264 519 primitiveLoadInstVar)

		"MIDI Primitives (520-539)"
		(520 primitiveFail)
		(521 primitiveMIDIClosePort)
		(522 primitiveMIDIGetClock)
		(523 primitiveMIDIGetPortCount)
		(524 primitiveMIDIGetPortDirectionality)
		(525 primitiveMIDIGetPortName)
		(526 primitiveMIDIOpenPort)
		(527 primitiveMIDIParameterGetOrSet)
		(528 primitiveMIDIRead)
		(529 primitiveMIDIWrite)
		(530 539 primitiveFail)  "reserved for extended MIDI primitives"

		"Unassigned Primitives"
		(540 700 primitiveFail)).
! !


!InterpreterSimulator methodsFor: 'I/O primitives' stamp: 'di 9/23/97 15:26'!
showDisplayBits
	| displayObj destBits raster destDepth pixPerWord simDisp realDisp top bottom rect |
	displayObj _ self splObj: TheDisplay.
	self targetForm = displayObj ifFalse: [^ self].
	destBits _ self fetchPointer: 0 ofObject: displayObj.
	destDepth _ self fetchInteger: 3 ofObject: displayObj.
	pixPerWord _ 32 // destDepth.
	raster _ displayForm width + (pixPerWord - 1) // pixPerWord.
	simDisp _ Form new hackBits: memory.
	realDisp _ Form new hackBits: displayForm bits.
	top _ myBitBlt affectedTop.
	bottom _ myBitBlt affectedBottom.
	realDisp
		copy: (0 @ (top * raster) extent: 4 @ (bottom - top * raster))
		from: 0 @ (destBits + 4 // 4 + (top * raster))
		in: simDisp
		rule: Form over.
	rect _ 0 @ top corner: displayForm width @ bottom.
	Display
		copy: (rect translateBy: self displayLocation)
		from: rect topLeft
		in: displayForm
		rule: Form over! !


!MidiPrimTester commentStamp: 'jm 5/19/1998 14:15' prior: 0!
This class simply demonstrates and tests the MIDI primitives. MIDI applications should use Stephen Pope's MIDIPort class, which will replace this one.

The Macintosh, and perhaps some other platforms, can send and receive MIDI data over a serial port by using an external clock signal supplied by an external MIDI adapter to generate the correct MIDI baud rate. Typical clock speeds of such adapters are 1, 2, or 0.5 MHz. This clock speed can be specified when a MIDI port is opened. On other platforms, this clock speed parameter is ignored.
!

!MidiPrimTester reorganize!
('tests' getDriverParameters getInputForSeconds:onPort: getPortList playDrumRoll:count:onPort: playNoteOnPort: playScale:onPort:)
('primitives' primMIDIClosePort: primMIDIGetClock primMIDIGetPortCount primMIDIGetPortDirectionality: primMIDIGetPortName: primMIDIOpenPort:readSemaIndex:interfaceClockRate: primMIDIParameterGet: primMIDIParameterSet:to: primMIDIReadPort:into: primMIDIWritePort:from:at:)
('private' bufferTimeStampFrom: canTurnOnParameter: openPort:andDo:)
!


!MidiPrimTester methodsFor: 'tests' stamp: 'jm 5/18/1998 10:30'!
getDriverParameters
	"Return a string that describes this platform's MIDI parameters."
	"MidiPrimTester new getDriverParameters"

	| s parameterNames v |
	parameterNames _ #(Installed Version HasBuffer HasDurs CanSetClock CanUseSemaphore EchoOn UseControllerCache EventsAvailable FlushDriver ClockTicksPerSec HasInputClock).

	s _ WriteStream on: String new.
	s cr.
	1 to: parameterNames size do: [:i |
		v _ self primMIDIParameterGet: i.
		s nextPutAll: (parameterNames at: i).
		s nextPutAll: ' = '.
		s print: v; cr].

	s nextPutAll: 'MIDI Echoing is '.
	(self canTurnOnParameter: EchoOn)
		ifTrue: [s nextPutAll: 'supported.'; cr]
		ifFalse: [s nextPutAll: 'not supported.'; cr].

	s nextPutAll: 'Controller Caching is '.
	(self canTurnOnParameter: UseControllerCache)
		ifTrue: [s nextPutAll: 'supported.'; cr]
		ifFalse: [s nextPutAll: 'not supported.'; cr].

	^ s contents
! !

!MidiPrimTester methodsFor: 'tests' stamp: 'jm 5/18/1998 15:33'!
getInputForSeconds: seconds onPort: portNum
	"Collect MIDI input from the given port for the given number of seconds, and answer a string describing the data read."
	"MidiPrimTester new getInputForSeconds: 5 onPort: 0"

	| buf bufList endTime n midiStartTime s t |
	"collect the data"
	self openPort: portNum andDo: [
		buf _ ByteArray new: 1000.
		bufList _ OrderedCollection new.
		midiStartTime _ self primMIDIGetClock.
		endTime _ Time millisecondClockValue + (seconds * 1000).
		[Time millisecondClockValue < endTime] whileTrue: [
			n _ self primMIDIReadPort: portNum into: buf.
			n > 0 ifTrue: [bufList add: (buf copyFrom: 1 to: n)].
			(Delay forMilliseconds: 5) wait]].

	"format the data into a string"
	s _ WriteStream on: String new.
	s cr.
	bufList do: [:b |
		t _ (self bufferTimeStampFrom: b) - midiStartTime.
		s print: t.
		s nextPutAll: ': '.
		5 to: b size do: [:i | s print: (b at: i); space].
		s cr].
	^ s contents
! !

!MidiPrimTester methodsFor: 'tests' stamp: 'jm 5/18/1998 10:05'!
getPortList
	"Return a string that describes this platform's MIDI ports."
	"MidiPrimTester new getPortList"

	| s portCount dir directionString |
	s _ WriteStream on: String new.
	s cr; nextPutAll: 'MIDI Ports:'; cr.
	portCount _ self primMIDIGetPortCount.
	0 to: portCount - 1 do: [:i |
		s tab.
		s print: i; nextPutAll: ': '. 
		s nextPutAll: (self primMIDIGetPortName: i).
		dir _ self primMIDIGetPortDirectionality: i.
		directionString _ dir printString.  "default"
		dir = 1 ifTrue: [directionString _ '(in)'].
		dir = 2 ifTrue: [directionString _ '(out)'].
		dir = 3 ifTrue: [directionString _ '(in/out)'].
		s space; nextPutAll: directionString; cr].
	^ s contents
! !

!MidiPrimTester methodsFor: 'tests' stamp: 'jm 5/18/1998 11:24'!
playDrumRoll: mSecsBetweenNotes count: tapCount onPort: portNum
	"MidiPrimTester new playDrumRoll: 75 count: 64 onPort: 0"
	"Play middle-C tapCount times with the given space between notes. This example works best with a short percussive voice, like a drum."
	"Details: This test can be used to investigate the real-time performance of your system. On a 110 MHz PowerPC Mac, this method can genererate very fast and smooth drum rolls up to about 100 beats/sec (10 mSecs between notes). However, many factors can prevent one from seeing this level of performance including a slow CPU, lack of a level-2 cache, networking or other background processes stealing chunks of processor time from Squeak, or a sluggish MIDI synthesizer."
	"Details: By default, this method does an incremental GC on every note. While not really needed for this example, it illustrates a useful technique for real-time processing in Squeak: do an incremental GC when you know you have a few milliseconds of idle time to avoid triggering one during a time-critical task. In this case, we're also using the GC time to provide a small delay between the note-on and note-off events. If the GC time is too short, as it could be on a fast machine, the note may not sound at all unless you add a few milliseconds of additional delay!!"
	"Note: This example works best if the VM's millisecond clock has 1 millisecond resolution."

	| gcDuringNote noteOn noteOff endTime waitTime |
	gcDuringNote _ true.
	"these events use running status, so the command byte is omitted"
	noteOn _ #(60 100) as: ByteArray.
	noteOff _ #(60 0) as: ByteArray.
	self primMIDIOpenPort: portNum readSemaIndex: 0 interfaceClockRate: 1000000.

	"send an initial event with command byte to initiate running status"
	self primMIDIWritePort: portNum from: (#(144 60 0) as: ByteArray) at: 0.

	1 to: tapCount do: [:i |
		endTime _ Time millisecondClockValue + mSecsBetweenNotes.
		self primMIDIWritePort: portNum from: noteOn at: 0.
		gcDuringNote
			ifTrue: [
				"do quick GC; takes a few milliseconds and provides the note-down time"
				"Note: if GC is too fast on your machine, you need to add a few mSecs delay!!"
				Smalltalk garbageCollectMost]
			ifFalse: [(Delay forMilliseconds: 3) wait].

		self primMIDIWritePort: portNum from: noteOff at: 0.
		waitTime _ endTime - Time millisecondClockValue.
		waitTime > 0 ifTrue: [(Delay forMilliseconds: waitTime) wait]].

	self primMIDIClosePort: portNum.
! !

!MidiPrimTester methodsFor: 'tests' stamp: 'jm 5/18/1998 15:16'!
playNoteOnPort: portNum
	"MidiPrimTester new playNoteOnPort: 0"

	| noteOn noteOff bytesWritten |
	noteOn _ #(144 60 100) as: ByteArray.
	noteOff _ #(144 60 0) as: ByteArray.
	self openPort: portNum andDo: [
		bytesWritten _ self primMIDIWritePort: portNum from: noteOn at: 0.
		(Delay forMilliseconds: 500) wait.
		bytesWritten _ bytesWritten + (self primMIDIWritePort: portNum from: noteOff at: 0)].

	bytesWritten = 6 ifFalse: [self error: 'not all bytes were sent'].
! !

!MidiPrimTester methodsFor: 'tests' stamp: 'jm 5/18/1998 15:17'!
playScale: mSecsPerNote onPort: portNum
	"MidiPrimTester new playScale: 130 onPort: 0"

	| noteOn noteOff |
	noteOn _ #(144 0 100) as: ByteArray.
	noteOff _ #(144 0 0) as: ByteArray.
	self openPort: portNum andDo: [
		#(60 62 64 65 67 69 71 72 74 72 71 69 67 65 64 62 60) do: [:midiKey | 
			noteOn at: 2 put: midiKey.
			noteOff at: 2 put: midiKey.
			self primMIDIWritePort: portNum from: noteOn at: 0.
			(Delay forMilliseconds: mSecsPerNote - 10) wait.
			self primMIDIWritePort: portNum from: noteOff at: 0.
			(Delay forMilliseconds: 10) wait]].
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/17/1998 21:36'!
primMIDIClosePort: portNum

	<primitive: 521>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/17/1998 21:36'!
primMIDIGetClock

	<primitive: 522>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/17/1998 21:37'!
primMIDIGetPortCount

	<primitive: 523>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/17/1998 21:37'!
primMIDIGetPortDirectionality: portNum

	<primitive: 524>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/17/1998 21:37'!
primMIDIGetPortName: portNum

	<primitive: 525>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/17/1998 21:37'!
primMIDIOpenPort: portNum readSemaIndex: readSemaIndex interfaceClockRate: interfaceClockRate
	"Open the given MIDI port. If non-zero, readSemaIndex specifies the index in the external objects array of a semaphore to be signalled when incoming MIDI data is available. Not all platforms support signalling the read semaphore. InterfaceClockRate specifies the clock rate of the external MIDI interface adaptor on Macintosh computers; it is ignored on other platforms."

	<primitive: 526>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/17/1998 21:37'!
primMIDIParameterGet: whichParameter

	<primitive: 527>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/17/1998 21:37'!
primMIDIParameterSet: whichParameter to: newValue

	<primitive: 527>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/18/1998 11:31'!
primMIDIReadPort: portNum into: byteArray

	<primitive: 528>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'primitives' stamp: 'jm 5/18/1998 11:31'!
primMIDIWritePort: portNum from: byteArray at: midiClockValue

	<primitive: 529>
	self primitiveFailed.
! !

!MidiPrimTester methodsFor: 'private' stamp: 'jm 5/18/1998 12:48'!
bufferTimeStampFrom: aByteArray
	"Return the timestamp from the given MIDI input buffer. Assume the given buffer is at least 4 bytes long."

	^ ((aByteArray at: 1) bitShift: 24) +
	  ((aByteArray at: 2) bitShift: 16) +
	  ((aByteArray at: 3) bitShift: 8) +
	   (aByteArray at: 4)
! !

!MidiPrimTester methodsFor: 'private' stamp: 'jm 5/18/1998 12:48'!
canTurnOnParameter: whichParameter
	"Return true if the given MIDI parameter can be turned on. Leave the parameter in its orginal state."

	| old canSet |
	old _ self primMIDIParameterGet: whichParameter.
	self primMIDIParameterSet: whichParameter to: 1.
	canSet _ (self primMIDIParameterGet: whichParameter) = 1.
	self primMIDIParameterSet: whichParameter to: old.
	^ canSet
! !

!MidiPrimTester methodsFor: 'private' stamp: 'jm 5/18/1998 15:32'!
openPort: portNum andDo: aBlock
	"Open the given MIDI port, evaluate the block, and close the port again. Answer the value of the block."

	| result |
	self primMIDIClosePort: portNum.
	self primMIDIOpenPort: portNum readSemaIndex: 0 interfaceClockRate: 1000000.
	result _ aBlock value.
	self primMIDIClosePort: portNum.
	^ result
! !


!MidiPrimTester class methodsFor: 'class initialization' stamp: 'jm 5/18/1998 09:50'!
initialize
	"Initialize the MIDI parameter constants."
	"MidiPrimTester initialize"

	Installed _ 1.
		"Read-only. Return 1 if a MIDI driver is installed, 0 if not.
		 On OMS-based MIDI drivers, this returns 1 only if the OMS
		 system is properly installed and configured."

	Version _ 2.
		"Read-only. Return the integer version number of this MIDI driver.
		 The version numbering sequence is relative to a particular driver.
		 That is, version 3 of the Macintosh MIDI driver is not necessarily
		 related to version 3 of the Win95 MIDI driver."

	HasBuffer _ 3.
		"Read-only. Return 1 if this MIDI driver has a time-stamped output
		 buffer, 0 otherwise. Such a buffer allows the client to schedule
		 MIDI output packets to be sent later. This can allow more precise
		 timing, since the driver uses timer interrupts to send the data
		 at the right time even if the processor is in the midst of a
		 long-running Squeak primitive or is running some other application
		 or system task."

	HasDurs _ 4.
		"Read-only. Return 1 if this MIDI driver supports an extended
		 primitive for note-playing that includes the note duration and
		 schedules both the note-on and the note-off messages in the
		 driver. Otherwise, return 0."

	CanSetClock _ 5.
		"Read-only. Return 1 if this MIDI drivers clock can be set
		 via an extended primitive, 0 if not."

	CanUseSemaphore _ 6.
		"Read-only. Return 1 if this MIDI driver can signal a semaphore
		 when MIDI input arrives. Otherwise, return 0. If this driver
		 supports controller caching and it is enabled, then incoming
		 controller messages will not signal the semaphore."

	EchoOn _ 7.
		"Read-write. If this flag is set to a non-zero value, and if
		 the driver supports echoing, then incoming MIDI events will
		 be echoed immediately. If this driver does not support echoing,
		 then queries of this parameter will always return 0 and
		 attempts to change its value will do nothing."

	UseControllerCache _ 8.
		"Read-write. If this flag is set to a non-zero value, and if
		 the driver supports a controller cache, then the driver will
		 maintain a cache of the latest value seen for each MIDI controller,
		 and control update messages will be filtered out of the incoming
		 MIDI stream. An extended MIDI primitive allows the client to
		 poll the driver for the current value of each controller. If
		 this driver does not support a controller cache, then queries
		 of this parameter will always return 0 and attempts to change
		 its value will do nothing."

	EventsAvailable _ 9.
		"Read-only. Return the number of MIDI packets in the input queue."

	FlushDriver _ 10.
		"Write-only. Setting this parameter to any value forces the driver
		 to flush its I/0 buffer, discarding all unprocessed data. Reading
		 this parameter returns 0. Setting this parameter will do nothing
		 if the driver does not support buffer flushing."

	ClockTicksPerSec _ 11.
		"Read-only. Return the MIDI clock rate in ticks per second."

	HasInputClock _ 12.
		"Read-only. Return 1 if this MIDI driver timestamps incoming
		 MIDI data with the current value of the MIDI clock, 0 otherwise.
		 If the driver does not support such timestamping, then the
		 client must read input data frequently and provide its own
		 timestamping."
! !


!SerialPort commentStamp: 'jm 5/19/1998 14:15' prior: 0!
This class supports a simple interface to the serial ports of the underlying platform, if it supports serial ports. The mapping of port numbers to hardware ports is platform specific, but typically follows platform ordering conventions. For example, on the Macintosh, port 0 is the modem port and port 1 is the printer port, since in the programmers documentation these ports are referred to as ports A and B.
!

!SerialPort methodsFor: 'open/close' stamp: 'jm 5/18/1998 15:40'!
close
	"Close the serial port. Do nothing if the port is not open."

	port ifNotNil: [self primClosePort: port].
	port _ nil.
! !

!SerialPort methodsFor: 'open/close' stamp: 'jm 5/18/1998 15:37'!
openPort: portNumber
	"Open the given serial port, using the settings specified by my instance variables."

	self close.
	self primClosePort: portNumber.
	self primOpenPort: portNumber
		baudRate: baudRate
		stopBitsType: stopBitsType
		parityType: parityType
		dataBits: dataBits
		inFlowControlType: inputFlowControlType
		outFlowControlType: outputFlowControlType
		xOnByte: xOnByte
		xOffByte: xOffByte.
	port _ portNumber.
! !

!SerialPort methodsFor: 'input/output' stamp: 'jm 5/18/1998 15:41'!
nextPutAll: aStringOrByteArray
	"Send the given bytes out this serial port. The port must be open."

	self primWritePort: port
		from: aStringOrByteArray
		startingAt: 1
		count: aStringOrByteArray size.
! !

!SerialPort methodsFor: 'input/output' stamp: 'jm 5/18/1998 15:44'!
readByteArray
	"Answer a ByteArray read from this serial port. Answer an empty ByteArray if no data is available. The port must be open."

	| buf count |
	buf _ ByteArray new: 1000.
	count _ self primReadPort: port into: buf startingAt: 1 count: buf size.
	^ buf copyFrom: 1 to: count
! !

!SerialPort methodsFor: 'input/output' stamp: 'jm 5/18/1998 15:46'!
readInto: aStringOrByteArray startingAt: index
	"Read data into the given String or ByteArray object starting at the given index, and answer the number of bytes read. Does not go past the end of the given String or ByteArray."

	^ self primReadPort: port
		into: aStringOrByteArray
		startingAt: index
		count: (aStringOrByteArray size - index) + 1.
! !

!SerialPort methodsFor: 'input/output' stamp: 'jm 5/18/1998 15:43'!
readString
	"Answer a String read from this serial port. Answer the empty String if no data is available. The port must be open."

	| buf count |
	buf _ String new: 1000.
	count _ self primReadPort: port into: buf startingAt: 1 count: buf size.
	^ buf copyFrom: 1 to: count
! !

!SerialPort methodsFor: 'primitives' stamp: 'jm 5/18/1998 12:40'!
primWritePort: portNumber from: byteArray startingAt: startIndex count: count

	<primitive: 240>
	self primitiveFailed.
! !


!SerialPort class reorganize!
('instance creation' new)
!


DynamicInterpreter removeSelector: #primitiveSerialPortMIDIMode!
Interpreter removeSelector: #primitiveSerialPortMIDIMode!
MidiPrimTester initialize!
SerialPort removeSelector: #midiDrumRoll:count:!
SerialPort removeSelector: #primMIDIModePort:interfaceClockRate:!
SerialPort removeSelector: #openMIDIPort:midiInterfaceClockRate:!
SerialPort removeSelector: #openMIDIPort:!
SerialPort removeSelector: #midiPlayNote:!
SerialPort removeSelector: #midiPlayScale:!
SerialPort class removeSelector: #midiTest:onPort:!
