'From Squeak2.6 of 11 October 1999 [latest update: #1658] on 27 November 1999 at 6:27:02 pm'!
"Change Set:		BrownDragFix
Date:			27 November 1999
Author:			Bob Arning

Fixes a problem reported by Tansel Ersavas that constrainted dragging was broken (can't drag in a flap, brown-drag in any pasteUpMorph doesn't work).
"!


!Morph methodsFor: 'geometry' stamp: 'RAA 11/27/1999 19:16'!
setConstrainedPositionFrom: aPoint
	"Change the position of this morph and and all of its submorphs to aPoint, but don't let me go outside my owner's bounds."

	| trialRect delta boundingMorph |
	trialRect _ aPoint extent: self bounds extent.
	boundingMorph _ self owner topRendererOrSelf.
	delta _ boundingMorph
			ifNil:    [0@0]
			ifNotNil: [trialRect amountToTranslateWithin: boundingMorph bounds].
	self position: aPoint + delta.
	self layoutChanged  "So that, eg, surrounding text will readjust"
! !


