'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 26 February 2000 at 7:11:59 pm'!
"Change Set:		07LastUpdString-sma
Date:			6 February 2000
Author:			Stefan Matthias Aust

I tried a ''Smalltalk majorShrink; abandonSources; lastRemoval'' on a 2.8a/1789 image and noticed that here's an error in SystemDictionary>>lastUpdateString which is called from condenseChanges during abandonSources.  When this method tries to determine the patch level by calling ''ChangeSorter highestNumberedChangeSet'' the ChangeSorter class has already been stripped.

This changeset works around this problem."!


!SystemDictionary methodsFor: 'sources, change log' stamp: 'sma 2/12/2000 12:42'!
lastUpdateString
	"Smalltalk lastUpdateString"
	| aNumber |
	aNumber _ (Smalltalk
		at: #ChangeSorter
		ifAbsent: [^ 'Update # unknown']) highestNumberedChangeSet.
	^ (aNumber notNil and: [aNumber > 0])
		ifTrue: ['latest update: #' , aNumber printString]
		ifFalse: ['No updates present.']! !


