'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 26 February 2000 at 7:12:07 pm'!
"Change Set:		09BlobEnh-dns
Date:			9 February 2000
Author:			David N Smith

Blobs stay upfront now and you can click through them (use Cmd-click to get them). They also don't show handles when opened from the ''new morph'' menu (sma)."!


!BlobMorph methodsFor: 'initialization' stamp: 'dns 2/9/2000 16:37'!
initializeColor
	color _ random next < 0.25
		ifTrue: [Color random]
		ifFalse: [Color random alpha: random next * 0.4 + 0.4]! !

!BlobMorph methodsFor: 'stepping' stamp: 'sma 2/12/2000 13:09'!
step
	| verts |
	self comeToFront.
	self mergeBlobs.
	verts := vertices copy.

	" change two points at random to cause oozing across screen "
	self oozeAFewPointsOf: verts.

	" limit radius and interpoint angle "
	verts := self limitRange: verts.

	" Set new vertices; bounce off a wall if necessary "
	self setVertices: verts.
	self bounceOffWalls.
	self adjustColors
! !

!BlobMorph methodsFor: 'debug and other' stamp: 'sma 2/12/2000 13:08'!
installModelIn: aWorld
	"Overwritten to not add handles to the receiver."! !

!BlobMorph methodsFor: 'geometry testing' stamp: 'sma 2/12/2000 13:10'!
containsPoint: aPoint
	(self color alpha = 1.0 or: [Sensor blueButtonPressed])
		ifTrue: [^ super containsPoint: aPoint].
	^ false! !


