'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 26 February 2000 at 7:47:33 pm'!
"Change Set:		18EnhTranscript-sma
Date:			26 February 2000
Author:			Stefan Matthias Aust

Now, show: can show any object, not just Strings.
Also added method categories to the Transcripter class."!


!TranscriptStream methodsFor: 'stream extensions' stamp: 'sma 2/26/2000 19:31'!
show: anObject  "TextCollector compatibility"
	self nextPutAll: anObject asString; endEntry! !


!Transcripter reorganize!
('initialization' initInFrame:)
('accessing' clear endEntry show:)
('command line' confirm: readEvalPrint request:)
('private' black white)
!


!Transcripter methodsFor: 'accessing' stamp: 'sma 2/26/2000 19:35'!
show: anObject
	self nextPutAll: anObject asString; endEntry! !

!Transcripter methodsFor: 'command line' stamp: 'sma 2/26/2000 19:40'!
readEvalPrint
	| line |
	[#('quit' 'exit' 'done' ) includes: (line _ self request: '>')]
		whileFalse: [self cr; show: (Compiler evaluate: line)]! !

!Transcripter methodsFor: 'command line' stamp: 'sma 2/26/2000 19:39'!
request: prompt
	| startPos char contents | 
	self cr; show: prompt.
	startPos _ position.
	[[Sensor keyboardPressed] whileFalse.
	(char _ Sensor keyboard) = Character cr]
		whileFalse:
		[char = Character backspace
			ifTrue: [readLimit _ position _ (position - 1 max: startPos)]
			ifFalse: [self nextPut: char].
		self endEntry].
	contents _ self contents.
	^ contents copyFrom: startPos + 1 to: contents size! !


