'From Squeak2.8alpha of 13 January 2000 [latest update: #1919] on 8 March 2000 at 3:34:52 pm'!
"Change Set:		miscFixes-sw
Date:			8 March 2000
Author:			Scott Wallace

Fixes bug that had put up redundant second set of optional handles on halos.

Fixes a nil-size bug introduced in update 1898"!


!BlockNode methodsFor: 'printing' stamp: 'sw 3/1/2000 14:58'!
printTemporariesOn: aStream indent: level

	temporaries isEmptyOrNil
		ifFalse: 
			[aStream nextPut: $|.
			temporaries do: 
				[:arg | 
				aStream
					space;
					withAttributes: (Preferences syntaxAttributesFor: #temporaryVariable)
					do: [aStream nextPutAll: arg key]].
			aStream nextPutAll: ' | '.
			"If >0 args and >1 statement, put all statements on separate lines"
			statements size > 1 ifTrue: [aStream crtab: level]]! !


!HaloMorph methodsFor: 'private' stamp: 'sw 3/1/2000 00:51'!
addCircleHandles
	| box |
	simpleMode _ false.
	target isWorldMorph ifTrue: [^ self addHandlesForWorldHalos].

	self removeAllMorphs.  "remove old handles, if any"
	self bounds: target renderedMorph fullBoundsInWorld.  "update my size"
	box _ self basicBox.

	target addHandlesTo: self box: box.

	self addName.
	growingOrRotating _ false.
	self layoutChanged.
	self changed.
! !


