'From Squeak2.8alpha of 4 February 2000 [latest update: #1919] on 15 March 2000 at 10:58:12 pm'!
"Change Set:		quoFix
Date:			6 February 2000
Author:			Torge Husfeldt

Why should Smallinteger quo: fail only
because it has to answer a LargePositiveInteger?"!


!SmallInteger methodsFor: 'arithmetic' stamp: 'th 2/6/2000 19:04'!
quo: aNumber 
	"Primitive. Divide the receiver by the argument and answer with the
	result. Round the result down towards zero to make it a whole integer.
	Fail if the argument is 0 or is not a SmallInteger. Optional. See Object
	documentation whatIsAPrimitive."

	<primitive: 13>
	aNumber = 0 ifTrue: [^self error: 'Attempt to divide by zero'].
	(aNumber isMemberOf: SmallInteger)
		ifFalse: [^super quo: aNumber].
	(aNumber == -1 and:[self == self class minVal])
		ifTrue:[^self abs].
	self primitiveFailed
! !


