'From Squeak2.8alpha of 12 January 2000 [latest update: #2044] on 28 April 2000 at 4:13:32 pm'!
"Change Set:		FixResidentFonts
Date:			28 April 2000
Author:			Dan Ingalls

Fixes artifacts in bold and italic fonts due to lack of leading on 1-wide characters introduced in update #1975.
"!


!StrikeFont methodsFor: 'character shapes' stamp: 'di 4/28/2000 16:10'!
fixOneWideChars 
	"This fixes all 1-wide characters to be 2 wide with blank on the right
	so as not to cause artifacts in neighboring characters in bold or italic."
	| twoWide |
	minAscii to: maxAscii do:
		[:i | (self widthOf: (Character value: i)) = 1 ifTrue:
			[twoWide _ Form extent: 2@glyphs height.
			(self characterFormAt: (Character value: i)) displayOn: twoWide at: 0@0.
			self characterFormAt: (Character value: i) put: twoWide]].
"
StrikeFont allInstancesDo: [:f | f fixOneWideChars].
StrikeFont shutDown.  'Flush synthetic fonts'.
"
! !

"Postscript:
Patch existing fonts and flush any synthetic fonts."
StrikeFont allInstancesDo: [:f | f fixOneWideChars].
StrikeFont shutDown.
!

