'From Squeak2.8alpha of 4 February 2000 [latest update: #2052] on 3 May 2000 at 11:16:55 pm'!
"Change Set:		035SketchToBgGrnd-jcg
Date:			3 May 2000
Author:			Joshua Gargus

Adds a menu item to SketchMorph to allow you to use it as the World's background.  Move the code to set the background from FileList into Form so that both FileList and SketchMorph can use it."!


!FileList methodsFor: 'file list menu' stamp: 'jcg 5/1/2000 23:09'!
openAsBackground
	"Set an image as a background image.  Support Squeak's common file format 
	(GIF, JPG, PNG, 'Form stoteOn: (run coded)' and BMP)"

	(Form fromFileNamed: self fullName) setAsBackground! !


!Form methodsFor: 'displaying' stamp: 'sma 5/3/2000 22:31'!
setAsBackground
	"Set this form as a background image."

	Smalltalk isMorphic 
		ifTrue: [self currentWorld color: (InfiniteForm with: self)]
		ifFalse:
			[ScheduledControllers screenController model form: self.
			Display restoreAfter: []]! !


!SketchMorph methodsFor: 'menu' stamp: 'jcg 5/1/2000 23:12'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'choose new graphic...' target: self action: #chooseNewGraphic.
	aCustomMenu add: 'set as background' target: rotatedForm action: #setAsBackground.
	self addPaintingItemsTo: aCustomMenu hand: aHandMorph! !

