'From Squeak2.8alpha of 4 February 2000 [latest update: #2310] on 12 June 2000 at 1:00:00 pm'!
"Change Set:		134FasterUppercase-sma
Date:			12 June 2000
Author:			Stefan Matthias Aust

I noticed that implementing #asUppercase with #collect: instead of with a WriteStream improved performance by 30%.  One could even get additional 20% by open-coding the collect method but I think shorter is better here.  If you need a really fast implmentation, do it like #asLowercase which is still 45 times (!!) faster."
!


!String methodsFor: 'converting' stamp: 'sma 6/12/2000 11:40'!
asLowercase
	"Answer a String made up from the receiver whose characters are all 
	lowercase."

	^ self copy asString translateToLowercase! !

!String methodsFor: 'converting' stamp: 'sma 6/12/2000 11:41'!
asUppercase
	"Answer a String made up from the receiver whose characters are all 
	uppercase."

	^ self collect: [:each | each asUppercase]! !

