'From Squeak2.9alpha of 12 June 2000 [latest update: #2537] on 30 August 2000 at 8:58:02 am'!

!Morph methodsFor: 'geometry' stamp: 'di 8/30/2000 08:55'!
position: aPoint
	"Change the position of this morph and and all of its submorphs."

	| delta |
	delta _ aPoint - bounds topLeft.
	(delta x = 0 and: [delta y = 0]) ifTrue: [^ self].  "Null change"
	self changed.
	self privateFullMoveBy: delta.
	self changed.
! !

!Morph methodsFor: 'e-toy support' stamp: 'di 8/30/2000 07:52'!
makeGraphPaperGrid: smallGrid background: backColor line: lineColor

	| gridForm |
	gridForm _ self gridFormOrigin: 0@0 grid: smallGrid asPoint background: backColor line: lineColor.
	self color: (InfiniteForm with: gridForm).
	self world ifNotNil: [self world fullRepaintNeeded].
	self changed: #newColor.  "propagate to view"
! !


!StrikeFont methodsFor: 'character shapes' stamp: 'di 8/30/2000 08:57'!
ensureCleanBold 
	"This ensures that all character glyphs have at least one pixel of white space on the right
	so as not to cause artifacts in neighboring characters in bold or italic."
	| wider glyph |

true ifTrue: [^ self].  "DEFEATED FOR NOW"

	emphasis = 0 ifFalse: [^ self].
	minAscii to: maxAscii do:
		[:i | glyph _ self characterFormAt: (Character value: i).
		(glyph copy: (glyph boundingBox topRight - (1@0)
					corner: glyph boundingBox bottomRight)) isAllWhite ifFalse:
			[wider _ Form extent: (glyph width + 1)@glyph height.
			glyph displayOn: wider at: 0@0.
			self characterFormAt: (Character value: i) put: wider]].
"
StrikeFont allInstancesDo: [:f | f ensureCleanBold].
(StrikeFont familyName: 'NewYork' size: 21) ensureCleanBold.
StrikeFont shutDown.  'Flush synthetic fonts'.
"
! !

