'From Squeak2.9alpha of 13 June 2000 [latest update: #2853] on 10 October 2000 at 7:39:26 pm'!
"Change Set:		DupFix-ar
Date:			10 October 2000
Author:			Andreas Raab

Fixes two problems in morph duplication.
#1: The owner was still set after duplication which leads to strange effects since the duplicated morph should really be ownerless.
#2: The parts donor property was copied which could lead to other weird effects."
!


!Morph methodsFor: 'copying' stamp: 'ar 10/10/2000 19:33'!
duplicate
	"Make and return a duplicate of the receiver"

	| newMorph aName w |
	self okayToDuplicate ifFalse:[^self].
	aName _ (w _ self world) ifNotNil:[w nameForCopyIfAlreadyNamed: self].
	newMorph _ self veryDeepCopy.
	aName ifNotNil: [newMorph setNameTo: aName].
	newMorph player ifNotNil: [newMorph player startRunning].
	newMorph privateOwner: nil. "no longer in world"
	newMorph isPartsDonor: false. "no longer parts donor"
	^ newMorph! !

