'From Squeak2.9alpha of 13 June 2000 [latest update: #2969] on 7 November 2000 at 3:26:21 pm'!
"Change Set:		BgTweak-ar
Date:			7 November 2000
Author:			Andreas Raab

Fixes an accidental cache hit from the last CS."!


!WonderlandCameraMorph methodsFor: 'drawing' stamp: 'ar 11/7/2000 15:24'!
bgCacheValid
	| bg |
	bg _ self valueOfProperty: #backgroundSnapshot ifAbsent:[^false].
	^bg extent = self extent and:[bg depth = Display depth and:[Display isB3DDisplayScreen == bg isExternalForm]]! !

!WonderlandCameraMorph methodsFor: 'drawing' stamp: 'ar 11/7/2000 15:24'!
drawOn: aCanvas 
	| bg |
	bg _ self valueOfProperty: #backgroundSnapshot.
	bg == nil ifFalse:[
		(self bgCacheValid) ifFalse:[
			bg _ Display allocateForm: self extent.
			Display displayOn: bg at: bounds origin negated.
			self setProperty: #backgroundSnapshot toValue: bg.
		].
		aCanvas drawImage: bg at: bounds origin.
	].
	aCanvas asBalloonCanvas render: self.
	self outline ifNotNil: [self sketchOn: aCanvas].
	"*** hack ***"
	pickedPoint _ nil.! !

