'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 11 November 2000 at 11:45:26 pm'!
"Change Set:		221HalloweenFixes-bf
Date:			1 November 2000
Author:			Bert Freudenberg

Buglets fixed: 
* Magnifier used Hand>>lastEvent for no good reason.
* A scheduled balloon popup would fail when the morph was deleted in the mean time."!


!Morph methodsFor: 'halos and balloon help' stamp: 'bf 11/1/2000 15:58'!
showBalloon: msgString hand: aHand
	"Pop up a balloon containing the given string,
	first removing any existing BalloonMorphs in the world."

	| w balloon h |
	(w _ self world) ifNil: [^ self].
	h _ aHand.
	h ifNil:[
		h _ w activeHand].
	balloon _ BalloonMorph string: msgString for: self balloonHelpAligner.
	balloon popUpFor: self hand: h.! !


!MagnifierMorph methodsFor: 'magnifying' stamp: 'bf 11/1/2000 16:02'!
sourcePoint
	"If we are being dragged use our center, otherwise use pointer position"
	^(trackPointer not or: [owner notNil and: [owner isHandMorph]])
		ifTrue: [self center]
		ifFalse: [self currentHand position]! !

