'From Squeak2.9alpha of 17 July 2000 [latest update: #3185] on 18 December 2000 at 8:01:10 am'!
"Change Set:		fixLastRemoval
Date:			18 December 2000
Author:			Bob Arning

- fix to allow 'Smalltalk lastRemoval' to run in a reasonable time. The former code

	Set allSubInstancesDo: [:each | each rehash].

would takes us to #allInstancesDo: which would find the sets that were created by previous rehashes and then rehash them and then find the sets created by these rehashes, etc...

this bring us to 946,356 bytes for

	Smalltalk majorShrink; abandonSources; lastRemoval
"!


!SystemDictionary methodsFor: 'shrinking' stamp: 'RAA 12/18/2000 07:56'!
lastRemoval			"Smalltalk lastRemoval"

	 | oldDicts newDicts |

	"Some explicit removals - add unwanted methods keeping other methods."
	#(abandonSources printSpaceAnalysis)
		do: [:each | self class removeSelector: each].

	"Get rid of all unsent methods."
	[self removeAllUnSentMessages > 0] whileTrue.

	"Shrink method dictionaries."
	Smalltalk garbageCollect.
	oldDicts _ MethodDictionary allInstances.
	newDicts _ Array new: oldDicts size.
	oldDicts withIndexDo: [:d :index | 
		newDicts at: index put: d rehashWithoutBecome.
	].
	oldDicts elementsExchangeIdentityWith: newDicts.
	oldDicts _ newDicts _ nil.

	Smalltalk allClassesDo: [:c | c zapOrganization].
	SystemOrganization _ nil.

	Smalltalk changes initialize! !

