'From Squeak2.9alpha of 5 August 2000 [latest update: #3208] on 28 December 2000 at 11:50:50 am'!
"Change Set:		messageCount-sw
Date:			28 December 2000
Author:			Scott Wallace

If a message-list menu is requested when the message-list has no selection, the title of the resulting menu will report the size of the list"!


!StringHolder methodsFor: 'message list menu' stamp: 'sw 12/28/2000 11:49'!
messageListSelectorTitle
	| selector aString aStamp aSize |

	(selector _ self selectedMessageName)
		ifNil:
			[aSize _ self messageList size.
			^ (aSize == 0 ifTrue: ['no'] ifFalse: [aSize printString]), ' message', (aSize == 1 ifTrue: [''] ifFalse: ['s'])]
		ifNotNil:
			[Preferences timeStampsInMenuTitles
				ifFalse:	[^ nil].
			aString _ selector truncateWithElipsisTo: 28.
			^ (aStamp _ self timeStamp) size > 0
				ifTrue:
					[aString, String cr, aStamp]
				ifFalse:
					[aString]]! !

