'From Squeak2.9alpha of 17 July 2000 [latest update: #3208] on 28 December 2000 at 4:50:43 pm'!
"Change Set:		nameForSwiki
Date:			28 December 2000
Author:			Bob Arning

- send name of submitter along with project info so that the swiki updated by will look better"!


!SuperSwikiServer methodsFor: 'for real' stamp: 'RAA 12/28/2000 16:36'!
updateProjectInfoFor: aProject

	| data details projectLinks linkString |

	data _ OrderedCollection new.
	data add: 'action: updatepage'.
	data add: 'projectimage: ',aProject name,'.gif'.
	Utilities authorNamePerSe ifNotNil: [
		data add: 'submittedBy: ',Utilities authorNamePerSe.
	].
	projectLinks _ Set new.
	aProject world allMorphsDo: [ :each |
		(each isKindOf: ProjectViewMorph) ifTrue: [
			projectLinks add: each safeProjectName.
		].
	].
	details _ aProject world valueOfProperty: #ProjectDetails ifAbsent: [Dictionary new].
	details at: 'projectname' ifAbsentPut: [aProject name].
	projectLinks isEmpty ifTrue: [
		details removeKey: 'projectlinks' ifAbsent: []
	] ifFalse: [
		linkString _ String streamContents: [ :strm |
			projectLinks asSortedCollection do: [ :each |
				strm nextPutAll: each
			] separatedBy: [
				strm nextPut: $.
			].
		].
		details at: 'projectlinks' put: linkString
	].
	details keysAndValuesDo: [ :k :v |
		data add: k , ': ' , v
	].
	^self sendToSwikiProjectServer: data.
! !


!Utilities class methodsFor: 'identification' stamp: 'RAA 12/28/2000 16:32'!
authorNamePerSe

	^ AuthorName! !

