'From Squeak2.9alpha of 17 July 2000 [latest update: #3360] on 1 February 2001 at 7:29:52 pm'!
"Change Set:		navToSwiki2
Date:			1 February 2001
Author:			Bob Arning

Modify InternalThreadNavigationMorph to try to get project from current server if not already loaded. Hope it's right this time"!


!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 2/1/2001 19:29'!
loadPageWithProgress

	| projectInfo projectName |

	projectInfo _ listOfPages at: currentIndex.
	projectName _ projectInfo at: 1.
	loadedProject _ Project named: projectName.
	self class know: listOfPages as: threadName.
	WorldState addDeferredUIMessage: [
		InternalThreadNavigationMorph openThreadNamed: threadName
	].

	loadedProject ifNil: [
		ComplexProgressIndicator new 
			targetMorph: self;
			historyCategory: 'project loading';
			withProgressDo: [
				[
					loadedProject _ CurrentProjectRefactoring 
							currentFromMyServerLoad: projectName
				] 
					on: ProjectViewOpenNotification
					do: [ :ex | ex resume: false]		
						"we probably don't want a project view morph in this case"
			].
	].
	loadedProject ifNil: [
		^self inform: 'I cannot find that project'
	].
	self delete.

	loadedProject enter.
! !

