'From Squeak2.9alpha of 17 July 2000 [latest update: #3370] on 2 February 2001 at 7:13:47 am'!
"Change Set:		passivateTweak
Date:			2 February 2001
Author:			Bob Arning

Since the close and collapse controls are now in an AlignmentMorph, their selective locking/unlocking is refined a bit"!


!SystemWindow methodsFor: 'top window' stamp: 'RAA 2/2/2001 07:10'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"
	| oldTop outerMorph sketchEditor pal |
	outerMorph _ self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop _ TopWindow.
	TopWindow _ self.
	oldTop ifNotNil: [oldTop passivate].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock].
	labelArea submorphsDo: [:m | m unlock].
	self setStripeColorsFrom: self paneColorToUse.
	self isCollapsed ifFalse:
		[model modelWakeUpIn: self.
		self positionSubmorphs].

	(sketchEditor _ self extantSketchEditor) ifNotNil:
		[sketchEditor comeToFront.
		(pal _ self world findA: PaintBoxMorph) ifNotNil:
			[pal comeToFront]].
! !

!SystemWindow methodsFor: 'top window' stamp: 'RAA 2/2/2001 07:09'!
passivate
	"Make me unable to respond to mouse and keyboard"
	self setStripeColorsFrom: self paneColorToUse.
	model modelSleep.

	"Control boxes remain active, except in novice mode"
	self submorphsDo: [:m |
		m == labelArea ifFalse: [
			m lock
		]
	].
	labelArea submorphsDo: [:m |
		(m == closeBox or: [m == collapseBox]) ifTrue: [
			Preferences noviceMode ifTrue: [m lock]
		] ifFalse: [
			m lock
		]
	].
	self world ifNotNil:  "clean damage now, so dont merge this rect with new top window"
		[self world == Display bestGuessOfCurrentWorld ifTrue: [self world displayWorld]].
! !

