'From Squeak 2.2 of Sept 23, 1998 on 6 October 1998 at 2:53:22 pm'!
"Change Set:		projChangeSet-sw
Date:			6 October 1998
Author:			Scott Wallace

Fixes the long-standing bug whereby you often weren't allowed to delete a change set because you were told that it belonged to a project when in fact it no longer did.  (The old workaround was to exit and reenter the project!!)  The fix consists of eagerly updating the project's change set whenever Smalltalk newChanges: is called, rather than only upon project exit."!


!SystemDictionary methodsFor: 'sources, change log' stamp: 'sw 10/6/1998 14:36'!
newChanges: aChangeSet 
	"Set the system ChangeSet to be the argument, aChangeSet.  Tell the current project that aChangeSet is now its change set.  When called from Project enter:, the setChangeSet: call is redundant but harmless; when called from code that changes the current-change-set from within a project, it's vital"

	SystemChanges _ aChangeSet.
	Project current setChangeSet: aChangeSet! !


