'From Squeak3.1alpha of 5 February 2001 [latest update: #3838] on 14 March 2001 at 6:07:20 pm'!
"Change Set:		minorCeleste
Date:			14 March 2001
Author:			Bob Arning

removed a reference to an undeclared variable"!


!Celeste methodsFor: 'categories pane' stamp: 'RAA 3/14/2001 18:05'!
setCategory: newCategory 
	"Change the currently selected category. We must also compute the table  
	of contents and message list for the new category."
	| messageCount |
	currentCategory _ newCategory.
	newCategory isNil
		ifTrue: [currentMessages _ currentMsgID _ nil.
			self class includeStatusPane
				ifTrue: [status _ nil]]
		ifFalse: [currentMessages _ self filteredMessagesIn: newCategory.
			messageCount _ currentMessages size.
			messageCount > self maxMessagesToDisplay
				ifTrue: [self messages: self maxMessagesToDisplay from: messageCount.
					currentMessages _ currentMessages copyLast: self maxMessagesToDisplay]
				ifFalse: [self messages: messageCount from: messageCount].
			self cacheTOC].
	self changed: #category.
	self changed: #tocEntryList.
	self changed: #tocEntry.
	self changed: #messageText.
	self changed: #status.
	self changed: #outBoxStatus! !

