'From Squeak3.1alpha of 28 February 2001 [latest update: #4081] on 25 May 2001 at 3:32:01 pm'!
"Change Set:		CursorWrapped-ar
Date:			25 May 2001
Author:			Andreas Raab

Fixes a problem when a cursor is modified in a morph with no submorphs."!


!PasteUpMorph methodsFor: 'cursor' stamp: 'ar 5/25/2001 15:30'!
cursorWrapped: aNumber
	"Set the cursor to the given number, modulo the number of items I contain. Fractional cursor values are allowed."

	| truncP oldRect newRect |
	cursor ~= aNumber ifTrue:[
		self hasSubmorphs 
			ifTrue:[oldRect _ self selectedRect].
		cursor _ self asNumber: aNumber.
		truncP _ cursor truncated.
		truncP > submorphs size ifTrue:
			[submorphs size > 0
				ifTrue: [cursor _ cursor \\ submorphs size]
				ifFalse: [cursor _ 1]].
		truncP < 0 ifTrue: [cursor _ 1].
		self hasSubmorphs ifTrue:[
			newRect _ self selectedRect.
			self indicateCursor 
				ifTrue:[self invalidRect: oldRect; invalidRect: newRect]]].! !

