'From Squeak3.1alpha of 28 February 2001 [latest update: #4061] on 4 June 2001 at 11:03:15 am'!
"Change Set:		moviePlayerFix-mir
Date:			4 June 2001
Author:			Michael Rueger

Fixes the problem with running movies in the browser plugin. It turned out that AsycFile wants a full file name."!


!MoviePlayerMorph methodsFor: 'stepping' stamp: 'mir 6/4/2001 11:02'!
startRunning

	| ms |
	(frameBufferIfScaled ifNil: [currentPage image]) unhibernate.
	movieFile _ AsyncFile new open: (FileDirectory default fullNameFor: movieFileName) forWrite: false.
	movieFile primReadStart: movieFile fileHandle
			fPosition: (self filePosForFrameNo: frameNumber)
			count: self fileByteCountPerFrame.
	scorePlayer == nil
		ifTrue: [ms _ Time millisecondClockValue.
				msAtStart _ ms - ((frameNumber-1) * msPerFrame).
				msAtLastSync _ ms - msAtStart.
				frameAtLastSync _ frameNumber]
		ifFalse: [(playDirection > 0 and: [scorePlayer isKindOf: SampledSound]) ifTrue:
					[scorePlayer reset;
							playSilentlyUntil: (frameNumber - 1 * msPerFrame / 1000.0);						initialVolume: 1.0.
					[scorePlayer resumePlaying.
					msAtLastSync _ scorePlayer millisecondsSinceStart]
						forkAt: Processor userInterruptPriority].
				msAtLastSync _ scorePlayer millisecondsSinceStart.
				frameAtLastSync _ frameNumber]! !

