'From Squeak3.1alpha of 28 February 2001 [latest update: #4215] on 27 July 2001 at 6:20:33 pm'!
"Change Set:		floatPrecision-sw
Date:			27 July 2001
Author:			Scott Wallace

Bulletproofs against errant values in the floatPrecision inst variable of both UpdatingStringMorphs and SlotInformation objects, which could be there because of an earlier bug recently fixed in update 4214"!


!SlotInformation methodsFor: 'as yet unclassified' stamp: 'sw 7/27/2001 18:19'!
floatPrecision
	"Answer the floatPrecision for the slot:
		1.0 ->	show whole number
		0.1	->	show one digit of precision
		.01 ->	show two digits of precision
		etc.
	Initialize the precision to 1 if it is not present"

	^ floatPrecision isNumber ifTrue: [floatPrecision] ifFalse: [floatPrecision _ 1]! !


!UpdatingStringMorph methodsFor: 'accessing' stamp: 'sw 7/27/2001 18:20'!
floatPrecision
	"Answer the floatPrecision to use:
		1.0 ->	show whole number
		0.1	->	show one digit of precision
		.01 ->	show two digits of precision
		etc.
	Initialize the floatPrecision to 1 if it is not already defined"

	floatPrecision isNumber ifFalse:
		[self target: target].  "Fixes up errant cases from earlier bug"
	^ floatPrecision
! !

