'From Squeak3.1alpha of 7 March 2001 [latest update: #4261] on 21 August 2001 at 10:07:30 pm'!
"Change Set:		ServerDirectory-sbw
Date:			21 August 2001
Author:			Stephan B. Wessels

Fixes a bug when using remote FTP from FileList.  The first time you select a directory on a newly added FTP server the name was decoded improperly."!


!ServerDirectory methodsFor: 'file directory' stamp: 'sbw 8/21/2001 09:36'!
directoryNamed: localFileName 
	"Return a copy of me pointing at this directory below me"
	| new newPath |
	new _ self copy.
	urlObject
		ifNotNil: [new urlObject path: new urlObject path copy.
			new urlObject path removeLast; addLast: localFileName; addLast: ''.
			^ new].
	"sbw.  When working from an FTP server, the first time we access
	a subdirectory the <directory> variable is empty.  In that case we
	cannot begin with a leading path delimiter since that leads us to
	the wrong place."
	newPath _ directory isEmpty
				ifTrue: [localFileName]
				ifFalse: [directory , self pathNameDelimiter asString , localFileName].
	new directory: newPath.
	^ new! !

