'From Squeak3.4beta of ''1 December 2002'' [latest update: #5156] on 6 January 2003 at 9:28:51 pm'!
"Change Set:		makeSeedFix-sw
Date:			6 January 2003
Author:			Doug Way

Remove the dependency of UUIDGenerator >> makeSeed  on the presence of a TimeStamp class by calling Time totalSeconds rather than TimeStamp current asSeconds"!


!UUIDGenerator methodsFor: 'random seed' stamp: 'sw 1/6/2003 21:27'!
makeSeed
	"Try various methods of getting good seeds"
	| seed |
	seed := self makeUnixSeed.
	seed ifNotNil: [^seed].

	seed := self makeSeedFromSound.
	seed ifNotNil: [^seed].
	
	"default"
	[seed := (Time millisecondClockValue bitAnd: 16r3FFFFFFF) bitXor: self hash.
	seed := seed bitXor: (Time totalSeconds bitAnd: 16r3FFFFFFF).
	seed = 0] whileTrue: ["Try again if ever get a seed = 0"].

	^seed
! !

