'From Squeak 2.3 of January 14, 1999 on 4 February 1999 at 6:18:55 am'!
"Change Set:		FileContentsBrowser Fixes
Date:			3 February 1999
Author:			Yoshiki Oshima

Defines InterpreterSimulator>>primStringtranslatefromtotable (simple failure).

Makes compact class assignments in the SystemTracer consistent with the 2.3 release.
(this is not really necessary)

Makes maxFileNameLength for Unix not be limited to 31.
"!


!InterpreterSimulator methodsFor: 'other primitives' stamp: 'yo 1/29/1999 21:37'!
primStringtranslatefromtotable
	^ self primitiveFail! !

!SystemTracer methodsFor: 'initialization' stamp: 'yo 2/4/1999 06:22'!
initCompactClasses 
	"NOTE: at present the VM counts on BlockContext and MethodContext keeping their present compact class indices."
	| c |
	c _ Array new: 31.	
	"These classes have a short name (their index in this table.  It is not their oop.)
	Thus their instances can use just a single word as their header in memory."
	c at: 1 put: CompiledMethod.  c at: 2 put: Symbol. c at: 3 put: Array.
	c at: 4 put: PseudoContext.  c at: 5 put: LargePositiveInteger.  c at: 6 put: Float.
	c at: 7 put: MethodDictionary.  c at: 8 put: Association.  c at: 9 put: Point.
	c at: 10 put: Rectangle.  c at: 11 put: String.  c at: 12 put: TranslatedMethod.
	c at: 13 put: BlockContext.  c at: 14 put: MethodContext.  c at: 15 put: Color.
	c at: 16 put: Bitmap.
	compactClasses _ c.
	"Leave 16 to 31 for user defined compact classes."

	"Attempt to correctly write contextCache image.."
	"compactClasses _ Smalltalk compactClassesArray"! !

!UnixFileDirectory class methodsFor: 'platform specific' stamp: 'yo 2/4/1999 06:40'!
maxFileNameLength

	^ 255! !
