'From Squeak3.0 of 4 February 2001 [latest update: #3512] on 15 February 2001 at 9:34:32 pm'!

!Preferences class methodsFor: 'initial values' stamp: 'di 2/15/2001 21:34'!
initialValuesThreePointOh
	^ #(#(#alternativeBrowseIt #false #(#browsing) 'alternativeBrowseIt:
		if true, then the "browse it" (cmd-b) feature in the text editor will offer you a list of class names matching the selection, if appropriate') #(#annotationPanes #false #(#browsing) 'annotationPanes:
		If true, a thin horizontal annotation pane is used in browsers.') #(#autoAccessors #false #(#general) 'autoAccessors:
		If true, an attempt to call a message which is not understood by an object but whose selector is the same as an inst var of the object will result in automatic compilation of an accessor method for that object''s class') #(#automaticPlatformSettings #true #(#general) 'automaticPlatformSettings:
		If true, certain preferences are automatically set according to the current platform.') #(#automaticViewerPlacement #true #(#scripting) 'automaticViewerPlacement:
		If true, new viewers are automatically positioned near the objects they view; if false, new viewers are attached to the hand, from whence you much choose a destination for them') #(#balloonHelpEnabled #true #(#morphic) 'balloonHelpEnabled:
		Whether balloon help should be offered when the cursor lingers over certain objects.') #(#batchPenTrails #false #(#scripting) 'batchPenTrails:
		Ignores the detailed movement of pens between display updates.  Thus multiple line segments drawn within a script may not be seen individually.') #(#browseWithDragNDrop #true #(#browsing) 'browseWithDragNDrop:
		If true, drag&drop browsing is enabled, new Browser are opened with drag&drop functionality (only in Morphic).') #(#browseWithPrettyPrint #false #(#browsing) 'browseWithPrettyPrint:
		If true, browsers will automatically format their contents') #(#browserShowsPackagePane #false #(#browsing) 'browserShowsPackagePane:
		If true, then the various ''browse full'' and ''browse it'' commands (usually invoked via cmd-b) will open a Package Browser rather than a System Browser.  The Package Browser includes a package pane which groups system categories into packages based on the initial portion of their category name.') #(#canRecordWhilePlaying #false #(#media) 'canRecordWhilePlaying:
		If true, recording and playing sounds concurrently are permitted (platform dependent).') #(#capitalizedReferences #true #(#scripting) 'capitalizedReferences:
		if true, then object references in scripts will appear as capitalized names, a scheme which makes scripts look ''right'' but which still requires some engineering') #(#caseSensitiveFinds #false #(#general) 'caseSensitiveFinds:
		If true, then the "find" command in text will always make its searches in a case-sensitive fashion') #(#cautionBeforeClosing #false #(#windows) 'cautionBeforeClosing:
		If true, Morphic windows seen in an mvc project will put up a warning before allowing themselves to be dismissed') #(#celesteHasStatusPane #false #(#general) 'celesteHasStatusPane:
		If true, Celeste (e-mail reader) includes a status pane.') #(#changeSetVersionNumbers #true #(#fileout) 'changeSetVersionNumbers:
		If true, version-number extensions will be used when constructing names for change-set fileouts.  If false, timestamp extensions are used.') #(#checkForSlips #true #(#fileout) 'checkForSlips:
		If true, then whenever you file out a change set, it is checked for ''slips'' and if any are found, you are so informed and given a chance to open a browser on them') #(#checkForUnsavedProjects #true #(#general) 'checkForUnsavedProjects:
		If enabled, then ask before quitting Squeak if there are unsaved projects (the definition of unsaved is fuzzy at the moment and this preference may not be honored everywhere)') #(#clickOnLabelToEdit #false #(#windows) 'clickOnLabelToEdit:
		If true, a click on the label of a system window lets you edit it; if false, allow dragging of system windows when clicking on the label') #(#cmdDotEnabled #true #(#debug) 'cmdDotEnabled:
		If true, cmd-dot brings up a debugger;
if false, the cmd-dot interrupt is disabled') #(#colorWhenPrettyPrinting #false #(#browsing) 'colorWhenPrettyPrinting:
		If true, then when browseWithPrettyPrint is in effect, the pretty-printing will be presented in color') #(#compactViewerFlaps #false #(#scripting) 'compactViewerFlaps:
		Determines whether a viewer flap should fit tightly around the viewer') #(#compressFlashImages #false #(#media) 'compressFlashImages:
		If true, flash images will automatically be reduced to 8-bit color depth upon being read') #(#confirmFirstUseOfStyle #true #(#browsing) 'confirmFirstUseOfStyle:
		If true, the first attempt to submit a method with non-standard style will bring up a confirmation dialog') #(#conversionMethodsAtFileOut #false #(#fileout) 'conversionMethodsAtFileOut:
		Governs whether at fileout time you should be prompted to define conversion methods where deemed appropriate.') #(#debugHaloHandle #true #(#debug #halos) 'debugHaloHandle:
		If true, a special debugging halo handle is displayed at the right of the halo; if false, no such handle is shown.') #(#debugShowDamage #false #(#debug) 'debugShowDamage:
		If true, every changed region of the morphic display will be flashed black before updating.') #(#decorateBrowserButtons #false #(#browsing) 'decorateBrowserButtons:
		Governs whether certain buttons, such as the Inheritance button, should bear colors that provide user feedback on their applicability') #(#diffsInChangeList #true #(#browsing) 'diffsInChangeList:
		If true, changeList browsers and Versions browsers will open up by default showing diffs, i.e. revealing the differences between successive versions or between the in-memory code and the code on disk') #(#diffsWithPrettyPrint #false #(#browsing) 'diffsWithPrettyPrint:
		if true, displays of source code differences will be pretty-printed first') #(#dismissAllOnOptionClose #false #(#windows) 'dismissAllOnOptionClose:
		Mac-specific: if true, then a click on a morphic SystemWindow''s close-box while the mac option is held down will result in a dismissal of all unchanged windows') #(#dragNDropWithAnimation #false #(#browsing) 'dragNDropWithAnimation:
		If true, drag&drop is animated.') #(#eToyFriendly #false #(#scripting) 'eToyFriendly:
		If true, then the system is configured in ways suitable for etoy users') #(#extractFlashInHighQuality #true #(#media) 'extractFlashInHighQuality:
		Whether flash graphics should be extracted in high quality.') #(#extractFlashInHighestQuality #false #(#media) 'extractFlashInHighestQuality:
		Whether flash graphics should be extracted in highest possible quality.') #(#fastDragWindowForMorphic #true #(#windows) 'fastDragWindowForMorphic:
		If true, morphic window drag will be done by dragging an outline of the window.') #(#fenceEnabled #true #(#scripting) 'fenceEnabled:
		Whether an object obeying motion scripts should stop moving when it reaches the edge of its container.') #(#fullScreenLeavesDeskMargins #true #(#windows) 'fullScreenLeavesDeskMargins:
		If true, a Full Screen request to a Window to will leave margins around it. 
If false, the Window will fill the Screen unless the Global Flaps are showing.') #(#hiddenScrollBars #false #(#scrolling) 'hiddenScrollBars:
		If true, then scrollbars will only be shown if a pane''s contents are too large to fit inside the pane.') #(#higherPerformance #false #(#performance) 'higherPerformance:
		May offer higer performance at the expense of other applications on your computer. See the comment in EventSensor>>higherPerformanceNotes for more details. NOT advised when running in MVC!!') #(#ignoreStyleIfOnlyBold #true #(#browsing) 'ignoreStyleIfOnlyBold:
		If true, then any method submission in which the only style change is for bolding will be treated as a method with no style specifications') #(#inboardScrollbars #false #(#scrolling) 'inboardScrollbars:
		If true, then ScrollPane will place scrollbars inside on the right and will not hide them on exit') #(#infiniteUndo #false #(#general) 'infiniteUndo:
		if true, then where supported you will be able to roll back to prior states via repeated uses of undo.  Undo history will be purged at save/quit') #(#logDebuggerStackToFile #true #(#debug) 'logDebuggerStackToFile:
		If true, whenever you fall into a debugger a summary of its stack will be written to a file named
''SqueakDebug.log''') #(#menuColorFromWorld #true #(#menus) 'menuColorFromWorld:
		Governs whether the colors used in morphic menus should be derived from the color of the world background.') #(#modalColorPickers #true #(#general) 'modalColorPickers:
		If true, color choices in Morphic will be made via color-pickers that take control of the mouse and immediately return the color selected upon mouseup') #(#mvcProjectsAllowed #true #(#general) 'mvcProjectsAllowed:
		If true, the open... menu will offer you the chance to open an mvc project.') #(#noviceMode #false #(#general) 'noviceMode:
		If true, certain novice-mode accommodations are made.') #(#okToReinitializeFlaps #true #(#morphic) 'okToReinitializeFlaps:
		if true, then then code in updates will feel free to reinitialize the global flaps; if false, flaps will never be reinitialized by updates -- thus, set it to false if you have a serious investment in the content of the global flaps in your configuration, strong enough that you don''t want your flaps modernized when advances would otherwise indicate a need to') #(#oneViewerFlapAtATime #true #(#scripting) 'oneViewerFlapAtATime:
		If true, opening up one viewer flap will close all other such flaps.') #(#optionalButtons #true #(#general) 'optionalButtons:
		If true, then optional buttons will be used in certain standard tools, including browsers, message lists, fileLists, changeLists, and debuggers') #(#personalizedWorldMenu #true #(#menus) 'personalizedWorldMenu:
		If true, then a right-click (Mac option-click) on the morphic desktop will bring up the customizable "personalized" menu; if false, then it will bring up the standard world menu.') #(#postscriptStoredAsEPS #false #(#printing) 'postscriptStoredAsEPS:
		When printing a morph as PostScript, offers the choice of (true) an EPS file suitable for incorporating in a larger job or (false) a DSC file that is a standalone file') #(#preserveTrash #false #(#morphic) 'preserveTrash:
		Whether morphs dismissed via halo or dragged into the Trash should be preserved in the TrashCan for possible future retrieval.  If false, they are not preserved.') #(#printAlternateSyntax #false #(#browsing) 'printAlternateSyntax:
		If true, then
prettyPrint using experimental syntax.
Otherwise use normal ST-80 syntax.') #(#projectViewsInWindows #true #(#general) 'projectViewsInWindows:
		New Project view are created in a system window.') #(#projectZoom #true #(#general) 'projectZoom:
		If true, then show a zoom effect when entering or leaving projects.  This can be costly of memory (at least an extra screen buffer) so dont use it in low space situations.  But it is cool.') #(#projectsSentToDisk #false #(#general) 'projectsSentToDisk:
		If true, entering a new project swaps it in and swaps out other projects as appropriate. Projects are swapped in and out as ImageSegments, stored as files on disk in an image segment folder associated with the current image.') #(#promptForUpdateServer #true #(#updates) 'promptForUpdateServer:
		If false, the prompt for server choice when updating code from the server is suppressed.  Set this to false to leave the server choice unchanged from update to update.') #(#reverseWindowStagger #true #(#windows) 'reverseWindowStagger:
		If true, a reverse-stagger strategy  is used for determining where newly launched windows will be placed; if false, a direct- stagger strategy is used.') #(#roundedMenuCorners #true #(#menus) 'roundedMenuCorners:
		Whether morphic menus should have rounded corners') #(#roundedWindowCorners #true #(#windows) 'roundedWindowCorners:
		Governs whether morphic system windows should have rounded corners') #(#scrollBarsNarrow #true #(#scrolling) 'scrollBarsNarrow:
		If true, morphic scrollbars will be narrow.') #(#scrollBarsOnRight #false #(#scrolling) 'scrollBarsOnRight:
		If true, morphic scrollbars in subsequently opened windows will appear on the right side of their pane.') #(#scrollBarsWithoutMenuButton #false #(#menus #scrolling) 'scrollBarsWithoutMenuButton:
		If true, morphic scrollbars in subsequently opened windows will not include a menu button.') #(#showBoundsInHalo #false #(#halos) 'showBoundsInHalo:
		If true, halos will include a fine rectangle around the bounds of the target morph.') #(#showDirectionForSketches #false #(#halos) 'showDirectionForSketches:
		If enabled, direction handles are always shown for SketchMorphs.  If disabled, direction handles can be shown by the ''show direction handles'' command in the red menu.') #(#showDirectionHandles #false #(#halos) 'showDirectionHandles:
		If enabled, direction handles are always shown with halos.  If disabled, direction handles can be shown by the ''show direction handles'' command in the red menu.') #(#showFlapsWhenPublishing #false #(#publishing) 'showFlapsWhenPublishing:
		If true, show global flaps and project navigator -- otherwise suppress both to give the illusion that we are still in the same project') #(#showProjectNavigator #true #(#morphic) 'showProjectNavigator:
		If true, then show a nifty project navigator control in the world''s bottom left corner.') #(#simpleMenus #false #(#menus) 'simpleMenus:
		If true, simpler menus are presented.') #(#smartUpdating #true #(#browsing) 'smartUpdating:
		If true, then morphic tools such as browsers and inspectors will keep their contents up to date automatically, so that if something changes anywhere, the change will be reflected everywhere.') #(#soundQuickStart #false #(#media) 'soundQuickStart:
		If true, attempt to start playing sounds using optional "quick start"') #(#soundStopWhenDone #false #(#media) 'soundStopWhenDone:
		If true, the sound player is shut down after playing finished.') #(#soundsEnabled #true #(#media) 'soundsEnabled:
		If false, all sound playing is disabled') #(#sourceCommentToggleInBrowsers #false #(#browsing) 'sourceCommentToggleInBrowsers:
		If true, then optional button panes in code browsers in morphic will exhibit a checkbox labeled "source" which allows the user to toggle between viewing source code and just viewing method comments') #(#systemWindowEmbedOK #false #(#windows) 'systemWindowEmbedOK:
		Determines whether, in Morphic, when a SystemWindow or MenuMorph is dropped onto a willing receptor, it should be deposited into that receptor.') #(#thoroughSenders #true #(#general) 'thoroughSenders:
		If true, then ''senders'' browsers will dive inside structured literals in their search') #(#timeStampsInMenuTitles #false #(#menus) 'timeStampsInMenuTitles:
		If true, then the author''s timestamp is displayed as the menu title of any message list; if false, no author''s timestamps are shown') #(#turnOffPowerManager #false #(#performance) 'turnOffPowerManager:
		May offer higer performance at the expense of the life of your Battery (macintosh only in 3.VM)') #(#twentyFourHourFileStamps #true #(#fileout) 'twentyFourHourFileStamps:
		If #changeSetVersionNumbers is false, this preference determines whether the date/time suffix used with changeset fileouts is based on a 24-hr clock or a 12-hr clock.') #(#uniqueNamesInHalos #false #(#halos) 'uniqueNamesInHalos:
		if true, then when you put up a halo for any morph, it is assigned a unique name (if it doesn''t already have one) which will stick with it.') #(#unlimitedPaintArea #false #(#morphic) 'unlimitedPaintArea:
		If true, the painting area for a new drawing will not be limited in size; if false, a reasonable
limit will be applied, in an attempt to hold down memory and time price.') #(#updateSavesFile #false #(#updates) 'updateSavesFile:
		If true, then when an update is loaded from the server, a copy of it will automatically be saved on a local file as well.') #(#useGlobalFlaps #true #(#morphic) 'useGlobalFlaps:
		If true, then flaps are shown along the edges of Morphic projects.') #(#useUndo #true #(#general) 'useUndo:
		if true, then undo will generally be available in morphic') #(#viewersInFlaps #true #(#scripting) 'viewersInFlaps:
		If true, viewers are projected into flaps along the right edge of the screen') #(#warnIfNoChangesFile #true #(#general) 'warnIfNoChangesFile:
		If true, then you will be warned, whenever you start up, if no changes file
can be found') #(#warnIfNoSourcesFile #true #(#general) 'warnIfNoSourcesFile:
		If true, then you will be warned, whenever you start up, if no sources file can be found') )! !
