'From Squeak3.1alpha of 28 February 2001 [latest update: #4121] on 3 June 2001 at 2:02:12 pm'!
"Change Set:		KeepRunning-ar
Date:			3 June 2001
Author:			Andreas Raab

Keep scripts running when painting 3D objects."!


!PasteUpMorph methodsFor: 'painting' stamp: 'ar 6/3/2001 14:01'!
prepareToPaint
	"We're about to start painting. Do a few preparations that make the system more responsive."
	^self prepareToPaint: true.! !

!PasteUpMorph methodsFor: 'painting' stamp: 'ar 6/3/2001 14:01'!
prepareToPaint: stopRunningScripts
	"We're about to start painting. Do a few preparations that make the system more responsive."
	self hideViewerFlaps. "make room"
	stopRunningScripts ifTrue:[self stopRunningAll]. "stop scripts"
	self abandonAllHalos. "no more halos"! !


!WonderlandCameraMorph methodsFor: 'pooh' stamp: 'ar 6/3/2001 14:00'!
paintActor: anActor
	self world prepareToPaint: false.
	self mode: #paint.
	backup _ anActor getTexturePointer deepCopy.
	palette _ self world paintBox.
	palette position: self position + ((self extent x + 100) @ 0); focusMorph: self.! !

!WonderlandCameraMorph methodsFor: 'pooh' stamp: 'ar 6/3/2001 14:00'!
strokeMode
	self world prepareToPaint: false.
	self clearStroke.
	self mode: #stroke.
	Cursor crossHair beCursor.
	self removeHalo.! !

