"Change Set:		ScorePlayerMorphOpenFix-nk
Date:			8 February 2001
Author:			Ned Konz

The ScorePlayerMorph's little '<>' button opens a menu
that allows opening a MIDI file. If there are none in the current
directory, you get a walkback. (tweaked by dew)

This fixes this problem, but it should probably open a file requester."!


!ScorePlayerMorph methodsFor: 'initialization' stamp: 'nk 2/8/2001 18:04'!
openMIDIFile
	"Open a MIDI score and re-init controls..."
	| score fileName f player |
	fileName _ Utilities chooseFileWithSuffixFromList: #('.mid' '.midi')
					withCaption: 'Choose a MIDI file to open'.
	(fileName isNil or: [ fileName == #none ])
		ifTrue: [^ self inform: 'No .mid/.midi files found in the Squeak directory'].
	f _ FileStream readOnlyFileNamed: fileName.
	score _ (MIDIFileReader new readMIDIFrom: f binary) asScore.
	f close.
	player _ ScorePlayer onScore: score.
	self onScorePlayer: player title: fileName! !

