'From Squeak3.2alpha of 8 October 2001 [latest update: #4418] on 16 October 2001 at 4:22:10 pm'!
"Change Set:		Modules-2
Date:			6 September 2001
Author:			Henrik Gedenryd

Install sensitive methods that rely on others already being in place."!


!Behavior methodsFor: 'testing method dictionary' stamp: 'hg 8/30/2001 18:43'!
scopeHas: name ifTrue: assocBlock 
	"If the argument name is a variable known to the receiver, then evaluate 
	the second argument, assocBlock."

	| assoc |
	(assoc _ Smalltalk associationAt: name ifAbsent: []) == nil
		ifFalse: [assocBlock value: assoc.
				^ true].

	^false! !


!Class methodsFor: 'compiling' stamp: 'hg 10/1/2001 20:40'!
scopeHas: varName ifTrue: assocBlock

	^self lenientScopeHas: varName ifTrue: assocBlock
! !

!Class methodsFor: 'organization' stamp: 'hg 9/30/2001 16:27'!
module
 
	^module ifNil: [Module smalltalk]! !

!Class methodsFor: 'organization'!
module: mod

	module _ mod! !

"Postscript:
Run the code to initially convert the image to modules."

Module convertSystemOrganizationToModules.

FromVersion0p0000to0001 run
!

