'From Squeak3.2alpha of 3 October 2001 [latest update: #4584] on 6 February 2002 at 7:24:43 pm'!
"Change Set:		limitClass-sw
Date:			6 February 2002
Author:			Scott Wallace

Fixes a bug that had left the limitClass of newly-launched Lexicons undefined when the target class was any of a few specially-handled cases.  The result had been that various functions in the Lexicon were broken until you manually reset the limitClass, a workaround no longer necessary."!


!Lexicon methodsFor: 'limit class' stamp: 'sw 2/6/2002 19:20'!
initialLimitClass
	"Choose a plausible initial vlaue for the limit class, and answer it"

	| oneTooFar |
	limitClass _ targetClass.
	(#('ProtoObject' 'Object' 'Behavior' 'ClassDescription' 'Class' 'ProtoObject class' 'Object class') includes: targetClass name asString) ifTrue: [^ targetClass].

	oneTooFar _ (targetClass isKindOf: Metaclass)
		ifTrue:
			[Object class]
		ifFalse:
			[Object].
	[limitClass superclass ~~ oneTooFar]
		whileTrue: [limitClass _ limitClass superclass].
	^ limitClass! !

