'From Squeak3.3alpha of 11 January 2002 [latest update: #4873] on 17 May 2002 at 11:52:19 am'!
"Change Set:		addEToyFlaps-mir
Date:			17 May 2002
Author:			Michael Rueger

Refixing a problem with automatically adding etoy flaps."!


!Flaps class methodsFor: 'predefined flaps' stamp: 'mir 5/14/2002 14:37'!
addAndEnableEToyFlaps
	"Initialize the standard default out-of-box set of global flaps.  This method creates them and places them in my class variable #SharedFlapTabs, but does not itself get them displayed."

	SharedFlapTabs
		ifNotNil: [^self].
	SharedFlapTabs _ OrderedCollection new.

	SharedFlapTabs add: self newSuppliesFlap.
	SharedFlapTabs add: self newWidgetsFlap.
	SharedFlapTabs add: self newNavigatorFlap.

	self enableGlobalFlapWithID: 'Supplies'.
	self enableGlobalFlapWithID: 'Navigator'.
	self enableGlobalFlapWithID: 'Widgets'.

	SharedFlapsAllowed _ true.
	Project current flapsSuppressed: false.
	^ SharedFlapTabs

"Flaps addAndEnableEToyFlaps"! !

