'From Squeak3.3alpha of 18 January 2002 [latest update: #4971] on 9 September 2002 at 10:53:06 pm'!
"Change Set:		xmlFix-mlr
Date:			9 September 2002
Author:			Michael Rueger

Convert to uppercase before parsing numbers, in order properly to support bases > 10.
Replace 16-bit characters with spaces."!


!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 9/1/2002 10:50'!
nextCharReference
	| base numberString charValue |
	self next == $#
		ifFalse: [self errorExpected: 'character reference'].
	base _ self peek == $x
		ifTrue: [
			self next.
			16]
		ifFalse: [10].
	numberString _ (self nextUpTo: $;) asUppercase.
	charValue _ [Number readFrom: numberString base: base] on: Error do: [:ex | self errorExpected: 'Number.'].
	^charValue > 255
		ifTrue: [^Character space]
		ifFalse: [charValue asCharacter]! !

