'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 23 June 2003 at 2:59:51 pm'!
"Change Set:		GrafPort-frameRect-efc
Date:			23 June 2003
Author:			Eddie Cottongim

Changes GrafPort>>frameRect to use the same idea as Form>>border:width:rule:fillColor: to achieve a large speedup on this operation."!


!GrafPort methodsFor: 'drawing support' stamp: 'efc 6/22/2003 21:32'!
frameRect: rect borderWidth: borderWidth
	"Paint a border whose rectangular area is defined by rect. The
	width of the border of each side is borderWidth."

	sourceX _ 0.
	sourceY _ 0.
	
	"for top and bottom, the following are the same"
	height _ borderWidth. 
	width _ rect width. 
	destX _ rect left.

	"top"
	destY _ rect top.
	self copyBits.

	"bottom"
	destY _ rect bottom - borderWidth.
	self copyBits.

	"for left & right, the following are the same"
	height _ rect height. 
	width _ borderWidth. 
	destY _ rect top.

	"left"
	destX _ rect left.
	self copyBits.

	"right"
	destX _ rect right - borderWidth.
	self copyBits.! !

