'From Squeak3.6beta of ''4 July 2003'' [latest update: #5352] on 31 July 2003 at 12:30:27 pm'!
"Change Set:		ProcessBrowserDepFix-nk
Date:			31 July 2003
Author:			Ned Konz

This removes the hard-coded dependencies on SoundPlayer and CPUWatcher in ProcessBrowser.
"!


!ProcessBrowser class methodsFor: 'process control' stamp: 'nk 7/31/2003 12:28'!
nameAndRulesFor: aProcess 
	"Answer a nickname and two flags: allow-stop, and allow-debug"
	(aProcess priority = Processor timingPriority
			and: [aProcess suspendedContext receiver == Delay])
		ifTrue: [^ {'the timer interrupt watcher'. false. false}].
	^ [ aProcess caseOf: {
		[ nil ] -> [{'no process'. false. false}].
		[Smalltalk lowSpaceWatcherProcess] -> [{'the low space watcher'. false. false}].
		[WeakArray runningFinalizationProcess] -> [{'the WeakArray finalization process'. false. false}].
		[Processor activeProcess] -> [{'the UI process'. false. true}].
		[Processor backgroundProcess] -> [{'the idle process'. false. false}].
		[Sensor inputProcess] -> [{'the I/O process'. false. false}].
		[Sensor interruptWatcherProcess] -> [{'the user interrupt watcher'. false. false}].
		[Project uiProcess] -> [{'the inactive Morphic UI process'. false. false}].
		[ Smalltalk at: #SoundPlayer ifPresent: [ :sp | sp playerProcess ] ] -> [{'the Sound Player'. false. false}].
		[ScheduledControllers ifNotNil: [ ScheduledControllers activeControllerProcess ] ] -> [{'the inactive MVC controller process'. false. true}].
		[ Smalltalk at: #CPUWatcher ifPresent: [ :cw | cw currentWatcherProcess ] ] -> [{'the CPUWatcher' . false . false}]
	}
		 otherwise: [{aProcess suspendedContext asString. true. true}] ]
			ifError: [ :err :rcvr | {aProcess suspendedContext asString. true. true} ]! !

