'From Squeak3.6beta of ''4 July 2003'' [latest update: #5387] on 17 September 2003 at 5:20:45 am'!
"Change Set:		VisibleProgress
Date:			17 September 2003
Author:			Daniel Vainsencher

Makes ProgressMorph have a non-transparent color so that it is more clearly visible. (merged with recent change to initProgressMorph in 5434ProgressBarMorph-dgd. -dew)"!


!ProgressMorph methodsFor: 'initialization' stamp: 'dvf 9/17/2003 05:14'!
initProgressMorph
	progress := ProgressBarMorph new.
	progress borderWidth: 1.
	progress color: Color white.
	progress progressColor: Color gray.
	progress extent: 200 @ 15.
! !

!ProgressMorph methodsFor: 'initialization' stamp: 'dvf 9/17/2003 05:15'!
setupMorphs
	| container  |
	self initProgressMorph.
	container _ AlignmentMorph newColumn.
	container
		wrapCentering: #center; cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: Color yellow muchLighter.

	container addMorphBack: self labelMorph.
	container addMorphBack: self subLabelMorph.
	container addMorphBack: self progress.

	self addMorph: container.
	self borderWidth: 2.
	self borderColor: Color black.

	self extent: container extent.
	self color: Color veryLightGray.
	self align: self fullBounds center with: Display boundingBox center
! !

