'From Squeak3.7alpha of ''15 October 2003'' [latest update: #5595] on 5 December 2003 at 10:33:17 pm'!
"Change Set:		exploreInMVC
Date:			5 December 2003
Author:			Boris Gaertner

This fixes an error that occurs when we are in a MVC project and try to open a Morphic window. This was fixed earlier, in Squeak 3.6 #5424, we find this comment: 
	I encountered a case where the hand was nil, so I put in a little 
	protection - raa
"!


!Morph methodsFor: 'submorphs-add/remove' stamp: 'BG 12/5/2003 22:31'!
delete
	"Remove the receiver as a submorph of its owner and make its 
	new owner be nil."

	| aWorld |
	aWorld := self world ifNil: [World].
	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little 
	protection - raa "
	" This happens when we are in an MVC project and open
	  a morphic window. - BG "
	aWorld ifNotNil:
	  [self disableSubmorphFocusForHand: self activeHand.
	  self activeHand releaseKeyboardFocus: self;
		  releaseMouseFocus: self.].
	owner ifNotNil:[ self privateDelete.
		self player ifNotNilDo: [ :player |
			"Player must be notified"
			player noteDeletionOf: self fromWorld: aWorld]].! !


