'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 11 December 2003 at 1:05:46 pm'!
"Change Set:		ObjToolsAndBabelFixes-dgd
Date:			11 December 2003
Author:			Diego Gomez Deck <DiegoGomezDeck@ConsultAr.com>

Fixes the problem in the alphabetic and search tab (in ObjectTools) that considered the english morph name but the translation"!


!ObjectsTool methodsFor: 'alphabetic' stamp: 'dgd 12/11/2003 12:58'!
showAlphabeticCategory: aString fromButton: aButton
	"Blast items beginning with a given letter into my lower pane"

	| eligibleClasses quads uc |
	submorphs last removeAllMorphs.
	uc _ aString asUppercase asCharacter.
	eligibleClasses _ Morph withAllSubclasses.

	quads _ OrderedCollection new.
	eligibleClasses do:
		[:aClass |
			aClass theNonMetaClass addPartsDescriptorQuadsTo: quads if:
				[:info | info formalName translated asUppercase first  = uc]].
	self installQuads: quads fromButton: aButton! !

!ObjectsTool methodsFor: 'search' stamp: 'dgd 12/11/2003 13:01'!
showMorphsMatchingSearchString
	"Put items matching the search string into my lower pane"

	| quads |
	self setSearchStringFromSearchPane.
	submorphs last removeAllMorphs.
	searchString isEmpty ifTrue: [^ self].
	quads _ OrderedCollection new.
	Morph withAllSubclasses do:
		[:aClass |
			aClass addPartsDescriptorQuadsTo: quads if:
				[:info | info formalName translated includesSubstring:  searchString caseSensitive: false]].

	self installQuads: quads fromButton: nil! !

