'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5623] on 3 January 2004 at 5:42:52 pm'!
"Change Set:		ProjectHistoryThumbnailFix-nk
Date:			3 January 2004
Author:			Ned Konz

Fixes a problem with the ProjectHistoryMorph where displays of projects with different display depths would have their colors corrupted.
"!


!StretchyImageMorph methodsFor: 'drawing' stamp: 'nk 1/3/2004 17:40'!
drawOn: aCanvas
| t |
"
Smalltalk at: #Q4 put: OrderedCollection new.
"
	form ifNil: [form _ (Form extent: 32@32 depth: 8) fillColor: Color green].
	(cache isNil or: [cache extent ~= bounds extent]) ifTrue: [
		t _ [cache _ Form extent: bounds extent depth: form depth.
		form displayInterpolatedIn: cache boundingBox on: cache.
		cache _ cache asFormOfDepth: aCanvas depth] timeToRun.
		"Q4 add: {t. form. cache}."
	].
	aCanvas paintImage: cache at: bounds origin.
! !

