'From Squeak3.6beta of ''4 July 2003'' [latest update: #5395] on 24 August 2003 at 9:56:32 am'!
"Change Set:		Chronology-i-ConvertTDateTTimeTTimestamp1of2
Date:			24 August 2003
Author:			Brent Pinkney

This change set it the first of two required to migrate the system from the existing Date, Time, TimeStamp classes"!

"Postscript:
Rename temporary classes TDate, TTime andTTimeStamp to Date, Time and TimeStamp."

| jdn |
jdn _ SystemVersion current date asDate julianDayNumber.

#(#Date #Time #TimeStamp) 	
	do: 	[ :s | | zname tname |
		Transcript show: (Smalltalk at: s) allInstances; cr.
		zname  _ ('Z', s) asSymbol.
		tname  _ ('T', s) asSymbol.
		(Smalltalk at: s) rename: zname.
		(Smalltalk at: tname) rename: s.
		(Smalltalk systemNavigation allCallsOn: (Smalltalk associationAt: zname))
			do: [ :ref | ref actualClass ifNotNilDo: [ :ac | ac recompile: ref methodSymbol ] ].
		Smalltalk forgetClass: (Smalltalk at: zname) logged: false.
		Transcript show: 'replaced ', s; cr ].

Transcript show: 'removing subclasses....'.
(Magnitude subclasses select: [ :sc | sc name beginsWith: 'Z' ]) 
	do:  [ :sc | Magnitude  removeSubclass: sc ].
Transcript tab; show: 'removed.'; cr.

Smalltalk removeKey: #ChronologyMigrationInProgress.
(Smalltalk at: #Date) initialize.
Duration initialize.
Month initialize.
Timespan initialize.
SystemVersion current date: ((Smalltalk at: #Date) julianDayNumber: jdn).

Undeclared removeUnreferencedKeys.
!

