'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 1 February 2004 at 6:06:09 pm'!
"Change Set:		KCP-0185-SpaceUsedFix
Date:			1 February 2004
Author:			stephane ducasse

clema spaceUsed implementation so that 
we can know it on Behavior instances too and avoid the hardcoded isKindO: Metaclass so that other extensions can use it too."!


!Behavior methodsFor: 'private' stamp: 'sd 2/1/2004 15:14'!
spaceUsed
	"Answer a rough estimate of number of bytes used by this class and its metaclass. Does not include space used by class variables."

	| space method |
	space _ 0.
	self selectorsDo: [:sel |
		space _ space + 16.  "dict and org'n space"
		method _ self compiledMethodAt: sel.
		space _ space + (method size + 6 "hdr + avg pad").
		method literals do: [:lit |
			(lit isMemberOf: Array) ifTrue: [space _ space + ((lit size + 1) * 4)].
			(lit isMemberOf: Float) ifTrue: [space _ space + 12].
			(lit isMemberOf: String) ifTrue: [space _ space + (lit size + 6)].
			(lit isMemberOf: LargeNegativeInteger) ifTrue: [space _ space + ((lit size + 1) * 4)].
			(lit isMemberOf: LargePositiveInteger) ifTrue: [space _ space + ((lit size + 1) * 4)]]].
		^ space! !


!Class methodsFor: 'private' stamp: 'sd 2/1/2004 15:18'!
spaceUsed

	"Object spaceUsed"
	^ super spaceUsed + self class spaceUsed! !

ClassDescription removeSelector: #spaceUsed!
