'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 8 March 2004 at 12:08:21 pm'!
"Change Set:		MsecClockValueOptimization-nk
Date:			8 March 2004
Author:			Ned Konz

Optimize Time>>millisecondClockValue by saving one call.

Doesn't sound like much, but makes a difference since we call it so much. Also keeps millisecondClockValue from appearing in profiler output.
"!


!Time class methodsFor: 'general inquiries' stamp: 'nk 3/8/2004 12:05'!
millisecondClockValue
	"Answer the number of milliseconds since the millisecond clock was last reset or rolled over.
	Answer 0 if the primitive fails."

	<primitive: 135>
	^ 0! !

