'From Squeak3.7beta of ''1 April 2004'' [latest update: #5868] on 6 April 2004 at 5:38:29 pm'!
"Change Set:		PackageInfoFromSM-avi
Date:			6 April 2004
Author:			Avi Bryant

Update the PackageInfo package from SqueakMap.  To avoid having to pull in Monticello for now, this first strips down the existing PackageInfo to a bare class (so as to not obsolete existing instances and references), and then loads the package as if for the first time from SqueakMap.  In the future, we should update it 'properly' by just asking SM to pull in the next version.

Modified by Ned Konz to still work if Monticello is already installed."!

(Smalltalk includesKey: #MCPackage) ifFalse: [
Object subclass: #PackageInfo
	instanceVariableNames: 'packageName methodCategoryPrefix '
	classVariableNames: 'Registry '
	poolDictionaries: ''
	category: 'PackageInfo-Base'.
PackageInfo class
	instanceVariableNames: 'default '.
PackageInfo class removeSelector: #allPackageNames.
PackageInfo class removeSelector: #allPackages.
PackageInfo class removeSelector: #default.
PackageInfo class removeSelector: #initialize.
PackageInfo class removeSelector: #named:.
PackageInfo class removeSelector: #registerPackage:.
PackageInfo class removeSelector: #registerPackageName:.
PackageInfo class removeSelector: #unregisterPackageName:.
PackageInfo class
	instanceVariableNames: ''.
PackageInfo removeSelector: #category:matches:.
PackageInfo removeSelector: #categoryName.
PackageInfo removeSelector: #classes.
PackageInfo removeSelector: #classesAndMetaClasses.
PackageInfo removeSelector: #coreCategoriesForClass:.
PackageInfo removeSelector: #coreMethods.
PackageInfo removeSelector: #coreMethodsForClass:.
PackageInfo removeSelector: #extensionCategoriesForClass:.
PackageInfo removeSelector: #extensionMethods.
PackageInfo removeSelector: #extensionMethodsForClass:.
PackageInfo removeSelector: #extensionMethodsFromClasses:.
PackageInfo removeSelector: #externalCallers.
PackageInfo removeSelector: #externalClasses.
PackageInfo removeSelector: #externalName.
PackageInfo removeSelector: #externalRefsSelect:thenCollect:.
PackageInfo removeSelector: #externalSubclasses.
PackageInfo removeSelector: #externalUsers.
PackageInfo removeSelector: #fileOut.
PackageInfo removeSelector: #fileOutOnStream:.
PackageInfo removeSelector: #foreignClasses.
PackageInfo removeSelector: #foreignExtensionCategoriesForClass:.
PackageInfo removeSelector: #foreignExtensionMethodsForClass:.
PackageInfo removeSelector: #foreignSystemCategories.
PackageInfo removeSelector: #includesClass:.
PackageInfo removeSelector: #includesMethod:ofClass:.
PackageInfo removeSelector: #includesMethodCategory:ofClass:.
PackageInfo removeSelector: #includesMethodReference:.
PackageInfo removeSelector: #includesSystemCategory:.
PackageInfo removeSelector: #isForeignClassExtension:.
PackageInfo removeSelector: #isYourClassExtension:.
PackageInfo removeSelector: #methodCategoryPrefix.
PackageInfo removeSelector: #methods.
PackageInfo removeSelector: #outsideClasses.
PackageInfo removeSelector: #packageName.
PackageInfo removeSelector: #packageName:.
PackageInfo removeSelector: #referenceForMethod:ofClass:.
PackageInfo removeSelector: #selectors.
PackageInfo removeSelector: #systemCategories.
PackageInfo removeSelector: #systemCategoryPrefix.
Smalltalk removeClassNamed: #ChangeSetPackageExporter.
Smalltalk removeClassNamed: #PackageExporter.
]!
"Postscript:"

SMSqueakMap default
	clearInstalledPackageWithId: '73fb0862-5f49-4b90-b899-c0101335b7c5';
	loadUpdates;
	installPackageWithId: '73fb0862-5f49-4b90-b899-c0101335b7c5' autoVersion: '6'

!

