'From Squeak3.7beta of ''1 April 2004'' [latest update: #5878] on 23 April 2004 at 2:59:14 pm'!
"Change Set:		Week-missing-startDay-send-jf
Date:			23 April 2004
Author:			Julian Fitzell

Week (class)>>starting:duration: was accessing StartDay directly rather than calling #startDay.  This caused it to bypass the lazy initialization of StartDay.

The bug can be noticed by doing:

Date today asMonth weeks first dates first dayOfWeek

It should return 1 (Sunday) but returns 7 (Saturday) in a new image without this fix."!


!Week class methodsFor: 'squeak protocol' stamp: 'jf 4/23/2004 14:51'!
starting: aDateAndTime duration: aDuration
	"Override - the duration is always one week.
	 Week will start from the Week class>>startDay"

	| midnight delta adjusted |
	midnight _ aDateAndTime asDateAndTime midnight.
	delta _ ((midnight dayOfWeek + 7 - (DayNames indexOf: self startDay)) rem: 7) abs.
	adjusted _ midnight - (Duration days: delta hours: 0 minutes: 0 seconds: 0).

	^ super starting: adjusted duration: (Duration weeks: 1).! !



