'From Squeak3.7beta of ''1 April 2004'' [latest update: #5878] on 22 April 2004 at 6:06:34 pm'!
"Change Set:		ZipCommentsAndCategoryChanges-nk
Date:			22 April 2004
Author:			Ned Konz

Some comments and protocol reorganization for the Zip-related classes."!


!ZipArchive commentStamp: '<historical>' prior: 0!
A ZipArchive represents an archive that is read and/or written using the PKZIP file format.

ZipArchive instances know how to read and write such archives; their members are subinstances of ZipArchiveMember.!


!ZipFileMember commentStamp: '<historical>' prior: 0!
ZipNewFileMember instances are used to represent files that have been read from a ZipArchive.
Their data stays in the file on disk, so the original Zip file cannot be directly overwritten.!


!ZipDirectoryMember commentStamp: '<historical>' prior: 0!
ZipFileMember instances represent directories inside ZipArchives.
They don't do much other than hold names and permissions (and extra fields).

You can add files in subdirectories to a ZipArchive without using any ZipDirectoryMembers.!


!ZipNewFileMember commentStamp: '<historical>' prior: 0!
ZipNewFileMember instances are used to represent files that are going to be written to a ZipArchive.
Their data comes from external file streams.!


!ZipStringMember commentStamp: '<historical>' prior: 0!
ZipStringMember instances are used to represent files that are going to be written to a ZipArchive.
Their data comes from in-image strings, though.!


!ZipStringMember reorganize!
('initialization' contents contents: initialize)
('private' readRawChunk:)
('private-writing' rewindData)
!


!ZipNewFileMember reorganize!
('initialization' close from: initialize)
('testing' usesFileNamed:)
('private' readRawChunk:)
('private-writing' rewindData)
!


!ZipDirectoryMember reorganize!
('accessing' desiredCompressionMethod: localFileName:)
('initialization' initialize)
('testing' isDirectory usesFileNamed:)
('private' asDirectory rewindData)
!


!ZipArchiveMember reorganize!
('accessing' centralDirectoryHeaderSize clearExtraFields compressedSize compressionMethod crc32 crc32String desiredCompressionLevel desiredCompressionLevel: desiredCompressionMethod desiredCompressionMethod: fileComment fileComment: lastModTime localFileName setLastModFileDateTimeFrom: splitFileName uncompressedSize unixFileAttributes unixFileAttributes:)
('extraction' extractInDirectory: extractInDirectory:overwrite: extractTo: extractTo:from:to: extractToFileNamed: extractToFileNamed:inDirectory:)
('initialization' initialize)
('reading' contentStream contents contentsFrom:to:)
('testing' hasDataDescriptor isDirectory isEncrypted isTextFile isTextFile: looksLikeDirectory)
('writing' writeTo:)
('private' asDirectory dosToUnixTime: endRead mapPermissionsFromUnix: mapPermissionsToUnix: readRawChunk: rewindData unixToDosTime: unixToSqueakTime:)
('private-writing' compressDataTo: copyDataTo: copyDataWithCRCTo: copyRawDataTo: copyRawDataTo:from:to: refreshLocalFileHeaderTo: writeCentralDirectoryFileHeaderTo: writeDataDescriptorTo: writeDataTo: writeDataTo:from:to: writeLocalFileHeaderTo:)
!


!ZipArchive reorganize!
('accessing' prependedDataSize zipFileComment zipFileComment:)
('archive operations' extractAllTo: extractAllTo:informing: extractAllTo:informing:overwrite:)
('initialization' close initialize)
('reading' readFrom:)
('writing' writeTo: writeTo:prepending: writeTo:prependingFileNamed: writeToFileNamed:prepending: writeToFileNamed:prependingFileNamed:)
('private' memberClass readEndOfCentralDirectoryFrom: readMembersFrom:named: readSignatureFrom: writeCentralDirectoryTo: writeEndOfCentralDirectoryTo:)
!

