'From Squeak3.7-m17n of 21 July 2004 [latest update: #19] on 25 July 2004 at 3:48:06 pm'!
"Change Set:		e03DecPlaceSafety-sw
Date:			25 May 2004
Author:			Scott Wallace

If the user typed a value with thirteen or more decimal-places into an etoy readout a debugger would appear.  This fixes that.

This update for 3.8a is identical to Squeakland update 0211decPlaceSafety-sw.cs"!


!UpdatingStringMorph methodsFor: 'accessing' stamp: 'sw 5/26/2004 00:01'!
decimalPlaces: aNumber
	"Set the receiver's number of decimal places to be shown.  If my target is a morph or a player, tell it about the change, in case it wants to remember it."

	| constrained |
	self setProperty: #decimalPlaces toValue: (constrained _ aNumber min: 11).
	self pvtFloatPrecision: (Utilities floatPrecisionForDecimalPlaces: constrained).
	(target isKindOf: Morph orOf: Player) ifTrue:
		[target noteDecimalPlaces: constrained forGetter: getSelector]! !

