'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 25 November 2004 at 11:28:39 am'!
"Change Set:		MSecFix-ar
Date:			25 November 2004
Author:			Andreas Raab

Time>>millisecondsToRun: can - if executed across image saves - result in a negative number. This fixes it to answer a very large number by replacing the simple subtraction with Time>>millisecondsSince: wich compensates for overflow."!


!Time class methodsFor: 'general inquiries' stamp: 'ar 11/25/2004 11:26'!
millisecondsToRun: timedBlock 
	"Answer the number of milliseconds timedBlock takes to return its value."

	| initialMilliseconds |
	initialMilliseconds _ self millisecondClockValue.
	timedBlock value.
	^self millisecondsSince: initialMilliseconds! !

