'From Squeak3.9alpha of ''2 November 2004'' [latest update: #6520] on 5 December 2004 at 4:15:02 pm'!
"Change Set:		positionOfSubcollectionTests
Date:			5 December 2004
Author:			Tom Koenig
Updated sunit TestCases for ReadWrite and SocketStream.  The RWS test pretty much just adds the test suggested by Avi.  The SS test adds a basic test for the modified method.  It also comments out a couple of failing tests methods that were failing and pointless.  Added class comments for both TestCases."!


!ReadStreamTest commentStamp: 'tlk 12/5/2004 14:36' prior: 0!
I am an SUnit test for ReadStream.
I have no test fixtures.!


!SocketStreamTest commentStamp: 'tlk 12/5/2004 16:05' prior: 0!
I am an SUnit test of SocketStream. At this point, I am broken and do very little that is useful.
My test fixtures are:
alistener  - a Socket
stream1 - a SocketStream on alistener

!


!ReadStreamTest methodsFor: 'as yet unclassified' stamp: 'tlk 12/5/2004 14:34'!
testPositionOfSubCollection
	
	self assert: ('xyz' readStream positionOfSubCollection: 'q' ) = 0.
	self assert: ('xyz' readStream positionOfSubCollection: 'x' ) = 1.

	self assert: ('xyz' readStream positionOfSubCollection: 'y' ) = 2.
	self assert: ('xyz' readStream positionOfSubCollection: 'z' ) = 3.! !


!SocketStreamTest methodsFor: 'running' stamp: 'tlk 12/5/2004 16:00'!
setUp
	listener _ Socket createIfFail: [].
	stream1 _ SocketStream on: listener.
	"listener _ Socket newTCP listenOn: 7357 backlogSize: 5.
	stream1 _ SocketStream on: (Socket newTCP connectTo: NetNameResolver localHostAddress port: 7357).
	stream2 _ SocketStream on: listener accept"! !

!SocketStreamTest methodsFor: 'running' stamp: 'tlk 12/5/2004 16:00'!
tearDown
	listener close.
	stream1 close.
	"stream2 close"! !

!SocketStreamTest methodsFor: 'running' stamp: 'tlk 12/5/2004 15:55'!
testNextColonBug
	"stream2 timeout: 1.
	stream1 nextPutAll: '12345678'; flush.
	stream2 next: 4.
	self should: [stream2 next: 8] raise: ConnectionTimedOut"
	"md: doesn't timeOut for me... just hangs".! !

!SocketStreamTest methodsFor: 'running' stamp: 'tlk 12/5/2004 15:51'!
testNextColonConnectionTimeout
	"
	stream1 nextPutAll: '12345'; flush.
	stream2 timeout: 1.
	self should: [stream2 next: 10] raise: ConnectionTimedOut.
	stream1 nextPutAll: '67890'; flush.
	self assert: (stream2 next: 10) size = 10
	"
! !

!SocketStreamTest methodsFor: 'running' stamp: 'tlk 12/5/2004 16:04'!
testUpToAll
	"just a test to exercise changed method"
	self assert: (stream1 upToAll:  '12345678') =''.
	! !

