'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #348] on 19 January 2005 at 1:29:06 pm'!
"Change Set:		FileListRemoteDirectoryExceptionHandling-nk
Date:			19 January 2005
Author:			Ned Konz

The FileList was showing a walkback on encountering protocol errors.

This swallows these errors, showing a popup instead.

In particular, this allows for 550 errors (no such directory) to be non-fatal; you just end up at the root.
"!


!FileList methodsFor: 'initialization' stamp: 'nk 1/19/2005 13:25'!
modelWakeUp
	"User has entered or expanded the window -- reopen any remote connection."

	(directory notNil and:[directory isRemoteDirectory])
		ifTrue: [[directory wakeUp] on: TelnetProtocolError do: [ :ex | self inform: ex printString ]] "It would be good to implement a null method wakeUp on the root of directory"! !

