'From Squeak3.10beta of 22 July 2007 [latest update: #7158] on 31 October 2007 at 5:10:20 pm'!
"Change Set:		findStringFix-mir
Date:			14 November 2007
Author:			John McIntosh, Michael Rueger

Fixes for dropped dnd events."!

!EventSensor methodsFor: 'private' stamp: 'JMM 8/17/2007 14:59'!
flushNonKbdEvents
	"flush all non-keyboard events, but preserve drag/drop events. If drag drop triggers a project change 
	we would flush the drag/drop event, that is an error since we want the event. Also on application startup 
	on the macintosh starting a tweak project would flush the synthetic drag/drop indicating which files to open if any
	as a result of double-clicking a VM application file"
	eventQueue ifNil: [^ self].
	eventQueue flushAllSuchThat:
		[:buf | (self isKbdEvent: buf) not and: [(self isDragDropFilesEvent: buf) not]]
! !
!EventSensor methodsFor: 'private' stamp: 'JMM 9/21/2006 13:54'!
isDragDropFilesEvent: buf
	^ (buf at: 1) = EventTypeDragDropFiles! !
